package com.notmusa.comercial.backingBeans;

import java.text.DateFormat;
import java.text.SimpleDateFormat;

import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.Locale;

import java.io.Serializable;

import javax.faces.component.UIForm;
import javax.faces.component.UIInput;
import javax.faces.component.UISelectMany;
import javax.faces.component.UISelectOne;
import javax.faces.component.html.HtmlInputTextarea;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.faces.model.SelectItem;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import org.ajax4jsf.component.html.HtmlAjaxCommandLink;

import org.richfaces.component.UICalendar;
import org.richfaces.component.html.HtmlInputNumberSpinner;
import org.richfaces.component.html.HtmlInputText;

import com.notmusa.comercial.managedBeans.PedidoMBean;

import com.sun.org.apache.xerces.internal.impl.xpath.regex.ParseException;

/**
 * <p>backing bean de orden donde se maneja la logica de la captura de ordenes
 * segun las reglas configuradas en base de datos.</p>
 *
 * @version PedidoBBean.java
 * @version Created on 03/04/2009, 06:41:02 PM
 * @author Rodrigo Mendoza Lazo de la Vega
 */

public class PedidoBBean implements Serializable {

	private static final long serialVersionUID = -6021227038233333675L;

	private String selectedItemsSlaveProductos="";
    private List<SelectItem> selectItemsSlaveProductos;
    
    private String selectedItemsSlaveAgencias="";
    private List<SelectItem> selectItemsSlaveAgencias;
    
    private String selectedItemsSlaveSuplementos="";
    private List<SelectItem> selectItemsSlaveSuplementos;
    
    private String selectedItemsSlaveConvenios="";
    private List<SelectItem> selectItemsSlaveConvenios;
    
    private String selectedItemsSlaveRegiones="";
    private List<SelectItem> selectItemsSlaveRegiones;
    
    private String selectedItemsSlavePatrocinios="";
    private List<SelectItem> selectItemsSlavePatrocinios;
    
    private String selectedItemsSlaveFormatos="";
    private List<SelectItem> selectItemsSlaveFormatos;
    
    private String selectedItemsSlaveAltoFormato="";
    private List<SelectItem> selectItemsSlaveAltoFormato;
    
    private String selectedItemsSlaveAnchoFormato="";
    private List<SelectItem> selectItemsSlaveAnchoFormato;
    
    private String selectedItemsSlaveTiposVenta="";
    private List<SelectItem> selectItemsSlaveTiposVenta;
    
    private String selectedItemsSlaveFormasPago="";
    private List<SelectItem> selectItemsSlaveFormasPago;
    
    private String selectedItemsSlavePosiciones="";
    private List<SelectItem> selectItemsSlavePosiciones;
    
    private String selectedItemsSlaveTarifas="";
    private List<SelectItem> selectItemsSlaveTarifas;
    
    private String selectedItemsSlaveEjecutivos="";
    private List<SelectItem> selectItemsSlaveEjecutivos;
    
    private String selectedItemsSlaveComisionistas="";
    private List<SelectItem> selectItemsSlaveComisionistas;
    
    private String selectedItemsSlaveSecciones="";
    private List<SelectItem> selectItemsSlaveSecciones;
    
    private String selectedItemsSlaveVersiones="";
    private List<SelectItem> selectItemsSlaveVersiones;
    
    private String selectedItemsSlaveEventos="";
    private List<SelectItem> selectItemsSlaveEventos;
    
    private String selectedItemsSufijo=""; 
    private List<SelectItem> selectItemsSufijo;
    
    private String selectedItemsDivisa=""; 
    private List<SelectItem> selectItemsDivisa;
    
    private String selectedItemsCopiarTarifa=""; 
    private List<SelectItem> selectItemsCopiarTarifa;
    
	public PedidoBBean() {
		
		/*Runtime rt = Runtime.getRuntime();
		System.out.println(" 	freeMemory------------------> "+ Long.toString(rt.freeMemory()));*/
		
		selectItemsSlaveProductos = new ArrayList<SelectItem>();
        selectItemsSlaveProductos.add(new SelectItem("-1", "-sin productos-"));
        
        selectItemsSlaveAgencias = new ArrayList<SelectItem>();
        selectItemsSlaveAgencias.add(new SelectItem("-1", "-sin agencias-"));
        
        selectItemsSlaveSuplementos = new ArrayList<SelectItem>();
        selectItemsSlaveSuplementos.add(new SelectItem("-1", "-sin suplementos-"));
        
        selectItemsSlaveConvenios = new ArrayList<SelectItem>();
        selectItemsSlaveConvenios.add(new SelectItem("-1", "-sin convenios-"));
        
        selectItemsSlaveRegiones = new ArrayList<SelectItem>();
        selectItemsSlaveRegiones.add(new SelectItem("-1", "-sin regiones-"));
        
        selectItemsSlavePatrocinios = new ArrayList<SelectItem>();
        selectItemsSlavePatrocinios.add(new SelectItem("-1", "-sin patrocinios-"));
        
        selectItemsSlaveFormatos = new ArrayList<SelectItem>();
        selectItemsSlaveFormatos.add(new SelectItem("-1", "-sin formatos-"));
             
        selectItemsSlaveAltoFormato = new ArrayList<SelectItem>();
        selectItemsSlaveAltoFormato.add(new SelectItem("", "--"));
        
    	selectItemsSlaveAnchoFormato = new ArrayList<SelectItem>();
        selectItemsSlaveAnchoFormato.add(new SelectItem("", "--"));
        
        selectItemsSlaveTiposVenta = new ArrayList<SelectItem>();
        selectItemsSlaveTiposVenta.add(new SelectItem("-1", "-sin tipos venta-"));
        
        selectItemsSlaveFormasPago = new ArrayList<SelectItem>();
        selectItemsSlaveFormasPago.add(new SelectItem("-1", "-sin formas pago-"));
        
        selectItemsSlavePosiciones = new ArrayList<SelectItem>();
        selectItemsSlavePosiciones.add(new SelectItem("-1", "-sin posiciones-"));
        
        selectItemsSlaveTarifas = new ArrayList<SelectItem>();
        selectItemsSlaveTarifas.add(new SelectItem("-1", "-sin tarifas-"));
        
        selectItemsSlaveEjecutivos = new ArrayList<SelectItem>();
        selectItemsSlaveEjecutivos.add(new SelectItem("-1", "-sin ejecutivos-"));
        
        selectItemsSlaveComisionistas = new ArrayList<SelectItem>();
        selectItemsSlaveComisionistas.add(new SelectItem("-1", "-sin comisionistas-"));
        
        selectItemsSlaveSecciones = new ArrayList<SelectItem>();
        selectItemsSlaveSecciones.add(new SelectItem("-1", "-sin secciones-"));
        
        selectItemsSlaveVersiones = new ArrayList<SelectItem>();
        selectItemsSlaveVersiones.add(new SelectItem("-1", "-sin versiones-"));
        
        selectItemsSlaveEventos = new ArrayList<SelectItem>();
        selectItemsSlaveEventos.add(new SelectItem("-1", "-sin eventos-"));
        
        selectItemsSufijo = new ArrayList<SelectItem>();
        selectItemsSufijo.add(new SelectItem("-1", "-sin sufijos-"));
        
        selectItemsDivisa = new ArrayList<SelectItem>();
        selectItemsDivisa.add(new SelectItem("-1", "-sin divisas-"));
        
        selectItemsCopiarTarifa = new ArrayList<SelectItem>();
        selectItemsCopiarTarifa.add(new SelectItem("-1", "-sin tarifas-"));
       
	}
	
	public SelectItem getExtraItem(){
    	return new SelectItem("0", "Seleccione...");
    }
	
    public SelectItem[] getListaPublicacionesItems(){
    	if(this.publicaciones==null || this.publicaciones.isEmpty()){
    		PedidoMBean mb = new PedidoMBean();
    		this.setPublicaciones(mb.obtenerPublicaciones());
    	}
    	SelectItem[] localeItems = new SelectItem[this.publicaciones.size()];
	    for(int i=0; i<this.publicaciones.size(); i++)
	    	localeItems[i] = new SelectItem(this.publicaciones.get(i).publicacion, this.publicaciones.get(i).nombrePublicacion);
	    return localeItems;
    }
    
    public List<String> autoCompleteClientes(Object suggest) {
        PedidoMBean mb = new PedidoMBean();
        String cliente = (String) suggest;
        clientes = mb.obtenerClientes(getIdUsuario(), cliente);
        for(int i=0; i<clientes.size(); i++){
        	suggestListClientes.add(clientes.get(i).getNombreCliente()+" ("+clientes.get(i).idCliente+")");
        }
		ArrayList<String> result = new ArrayList<String>();
		Iterator<String> iterator = suggestListClientes.iterator();
		while (iterator.hasNext()) {
			String elem = ((String) iterator.next());
			result.add(elem);
		}
		return result;
	}
    
    public SelectItem[] getListaPublicacionesPosicionItems(){
    	if(this.publicaciones==null || this.publicaciones.isEmpty()){
    		PedidoMBean mb = new PedidoMBean();
    		this.setPublicaciones(mb.obtenerPublicaciones());
    	}
    	this.listaPublicacionesPosicionItems = new SelectItem[this.publicaciones.size()];
	    for(int i=0; i<this.publicaciones.size(); i++)
	    	listaPublicacionesPosicionItems[i] = new SelectItem(this.publicaciones.get(i).getTipoPublicacion()+"|"+this.publicaciones.get(i).idPublicacion, this.publicaciones.get(i).nombrePublicacion);
	    return listaPublicacionesPosicionItems;
    }
    
    public SelectItem[] setListaPublicacionesPosicionItems(List<PedidoBBean> lista){
    	if(this.publicaciones==null || this.publicaciones.isEmpty()){
    		PedidoMBean mb = new PedidoMBean();
    		this.setPublicaciones(mb.obtenerPublicaciones());
    	}
    	SelectItem[] localeItems = new SelectItem[this.publicaciones.size()];
    	for(int i=0; i<this.publicaciones.size(); i++){
			localeItems[i] = new SelectItem(this.publicaciones.get(i).idPublicacion, 
					this.publicaciones.get(i).nombrePublicacion);
    	}
    	this.listaPublicacionesPosicionItems = localeItems;
	    return listaPublicacionesPosicionItems;
    }
    
    public SelectItem[] getListaPublicacionesEventoItems(){
    	if(this.publicaciones==null || this.publicaciones.isEmpty()){
    		PedidoMBean mb = new PedidoMBean();
    		this.setPublicaciones(mb.obtenerPublicaciones());
    	}
    	this.listaPublicacionesEventoItems = new SelectItem[this.publicaciones.size()];
	    for(int i=0; i<this.publicaciones.size(); i++)
	    	listaPublicacionesEventoItems[i] = new SelectItem(this.publicaciones.get(i).getTipoPublicacion()+"|"+this.publicaciones.get(i).idPublicacion, this.publicaciones.get(i).nombrePublicacion);
	    return listaPublicacionesEventoItems;
    }
    
    public SelectItem[] setListaPublicacionesEventoItems(List<PedidoBBean> lista){
    	if(this.publicaciones==null || this.publicaciones.isEmpty()){
    		PedidoMBean mb = new PedidoMBean();
    		this.setPublicaciones(mb.obtenerPublicaciones());
    	}
    	SelectItem[] localeItems = new SelectItem[this.publicaciones.size()];
    	for(int i=0; i<this.publicaciones.size(); i++){
			localeItems[i] = new SelectItem(this.publicaciones.get(i).idPublicacion, 
					this.publicaciones.get(i).nombrePublicacion);
    	}
    	this.listaPublicacionesEventoItems = localeItems;
	    return listaPublicacionesEventoItems;
    }

	public SelectItem[] getListaClientesItems(){
    	FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
        HtmlInputText selectCli = (HtmlInputText)form.findComponent("clientesSelect");
    	String cliente = "";
    	if(selectCli.getSubmittedValue()!=null)
        	cliente = selectCli.getSubmittedValue().toString();
    	if(this.clientes==null || this.clientes.isEmpty()){
    		PedidoMBean mb = new PedidoMBean();
			this.setClientes(mb.obtenerClientes(getIdUsuario(), cliente));
		}
    	SelectItem[] localeItems = new SelectItem[this.clientes.size()];
	    for(int i=0; i<this.clientes.size(); i++)
	    	localeItems[i] = new SelectItem(this.clientes.get(i).idCliente, this.clientes.get(i).nombreCliente);
	    return localeItems;
    }
    
    public void setPublicacionSlave(ActionEvent event) throws Exception { 
    	System.out.println("--> PedidoBBean.setPublicacionSlave() ");
    	FacesContext context = FacesContext.getCurrentInstance();
    	UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
    	PedidoMBean mb = new PedidoMBean();
    	setDatos();
    	UIInput radioTipOrden = (UIInput)form.findComponent("radioTipoOrden");
        UIInput numOrden = (UIInput)form.findComponent("numOrden");
        String numeroOrden = "";
    	selectItemsSlaveSuplementos = new ArrayList<SelectItem>();
    	selectItemsSlaveRegiones = new ArrayList<SelectItem>();
    	selectItemsSlaveTarifas = new ArrayList<SelectItem>();
    	selectItemsSlavePatrocinios = new ArrayList<SelectItem>();
    	selectItemsSlaveFormatos = new ArrayList<SelectItem>();
    	selectItemsSlaveConvenios = new ArrayList<SelectItem>();
    	selectItemsSlaveFormasPago = new ArrayList<SelectItem>();
    	selectItemsSlaveTiposVenta = new ArrayList<SelectItem>();
    	selectItemsSlavePosiciones = new ArrayList<SelectItem>();
    	selectItemsSlaveEjecutivos = new ArrayList<SelectItem>();
    	selectItemsSlaveComisionistas = new ArrayList<SelectItem>();
    	selectItemsSlaveSecciones = new ArrayList<SelectItem>();
    	selectItemsSlaveEventos = new ArrayList<SelectItem>();
		List<PedidoBBean> listaSuplementos = new ArrayList<PedidoBBean>();
		List<PedidoBBean> listaRegiones = new ArrayList<PedidoBBean>();
		List<PedidoBBean> listaPatrocinios = new ArrayList<PedidoBBean>();
		List<PedidoBBean> listaFormatos = new ArrayList<PedidoBBean>();
		List<PedidoBBean> listaConvenios = new ArrayList<PedidoBBean>();
		List<PedidoBBean> listaFormasPago = new ArrayList<PedidoBBean>();
		List<PedidoBBean> listaTiposVenta = new ArrayList<PedidoBBean>();
		List<PedidoBBean> listaPosiciones = new ArrayList<PedidoBBean>();
		List<PedidoBBean> listaTarifas = new ArrayList<PedidoBBean>();
		List<PedidoBBean> listaEventos = new ArrayList<PedidoBBean>();
		List<PedidoBBean> listaEjecutivos = new ArrayList<PedidoBBean>();
		List<PedidoBBean> listaComisionistas = new ArrayList<PedidoBBean>();
		List<PedidoBBean> listaSecciones = new ArrayList<PedidoBBean>();
		if(this.publicacion!=null && !this.publicacion.equals("")){
			listaSuplementos = mb.obtenerSuplementos(this.idPublicacion);
			listaRegiones = mb.obtenerRegiones(this.idPublicacion);
			listaPatrocinios = mb.obtenerPatrocinios(this.idPublicacion);
			listaFormatos = mb.obtenerFormatos(this.idPublicacion);
			listaFormasPago = mb.obtenerFormasPago();
			listaTiposVenta = mb.obtenerTiposVenta();
			listaPosiciones = mb.obtenerPosiciones(this.idPublicacion);
			listaSecciones = mb.obtenerSecciones(this.idPublicacion);
			this.setPeriodoPublicacion(mb.obtenerPeriodo(this.idPublicacion));
			this.setDisabledPublicacion(mb.obtenerDisabledPeriodo(this.idPublicacion));
			this.setFormatos(listaFormatos);
			if(listaSuplementos.size()==0){
				selectItemsSlaveSuplementos.add(new SelectItem("-1", "-sin suplementos-"));
				this.setSuplementoRequired(false);
			}
			if(listaSuplementos.size()>0) selectItemsSlaveSuplementos.add(new SelectItem("0", "Seleccione..."));
			if(listaRegiones.size()==0) selectItemsSlaveRegiones.add(new SelectItem("-1", "-sin regiones-"));
			if(listaPatrocinios.size()==0){
				selectItemsSlavePatrocinios.add(new SelectItem("-1", "-sin patrocinios-"));
				this.setPatrocinioRequired(false);
			}
			if(listaPatrocinios.size()>1) selectItemsSlavePatrocinios.add(new SelectItem("0", "Seleccione..."));
			if(listaFormatos.size()==0) selectItemsSlaveFormatos.add(new SelectItem("-1", "-sin formatos-"));
			if(listaFormatos.size()>1) selectItemsSlaveFormatos.add(new SelectItem("0", "Seleccione..."));
			if(listaTiposVenta.size()==0) selectItemsSlaveTiposVenta.add(new SelectItem("-1", "-sin tipos venta-"));
			if(listaTiposVenta.size()>1) selectItemsSlaveTiposVenta.add(new SelectItem("0", "Seleccione..."));
			if(listaFormasPago.size()==0) selectItemsSlaveFormasPago.add(new SelectItem("-1", "-sin formas pago-"));
			if(listaFormasPago.size()>1) selectItemsSlaveFormasPago.add(new SelectItem("0", "Seleccione..."));
			if(listaPosiciones.size()==0){
				selectItemsSlavePosiciones.add(new SelectItem("-1", "-sin posiciones-"));
				this.setPosicionRequired(false);
			}
			if(listaPosiciones.size()>1) selectItemsSlavePosiciones.add(new SelectItem("0", "Seleccione..."));
			if(listaSecciones.size()==0){
				selectItemsSlaveSecciones.add(new SelectItem("-1", "-sin secciones-"));
				this.setPosicionRequired(false);
			}
			if(listaSecciones.size()>1) selectItemsSlaveSecciones.add(new SelectItem("0", "Seleccione..."));
			for(int i=0; i<listaSuplementos.size(); i++)
				selectItemsSlaveSuplementos.add(new SelectItem(listaSuplementos.get(i).getIdSuplemento(), 
						listaSuplementos.get(i).getNombreSuplemento()));
			for(int i=0; i<listaRegiones.size(); i++)
				selectItemsSlaveRegiones.add(new SelectItem(listaRegiones.get(i).getIdRegion(), listaRegiones.get(i).getNombreRegion()));
			for(int i=0; i<listaPatrocinios.size(); i++)
				selectItemsSlavePatrocinios.add(new SelectItem(listaPatrocinios.get(i).getIdPatrocinio(), 
						listaPatrocinios.get(i).getNombrePatrocinio()));
			for(int i=0; i<listaFormatos.size(); i++)
				selectItemsSlaveFormatos.add(new SelectItem(listaFormatos.get(i).getFormato(), listaFormatos.get(i).getNombreFormato()));
			for(int i=0; i<listaSecciones.size(); i++)
				selectItemsSlaveSecciones.add(new SelectItem(listaSecciones.get(i).getIdSeccion(), listaSecciones.get(i).getNombreSeccion()));
			if(this.idCliente!=0){
				listaConvenios = mb.obtenerConvenios(this.idCliente, this.idPublicacion, this.valorEspecial, this.tipoValoracion);
				listaEjecutivos = mb.obtenerEjecutivos(this.idPublicacion, this.idCliente);
				listaComisionistas = mb.obtenerComisionistas(this.idCliente, this.idPublicacion);
				if(listaConvenios.size()==0) selectItemsSlaveConvenios.add(new SelectItem("-1", "-sin convenios-"));
				if(listaConvenios.size()>0) selectItemsSlaveConvenios.add(new SelectItem("0", "Seleccione..."));
				if(listaEjecutivos.size()==0){
					selectItemsSlaveEjecutivos.add(new SelectItem("-1", "-sin ejecutivos-")); 
					this.setEjecutivoRequired(false);
				}
				if(listaEjecutivos.size()>1) selectItemsSlaveEjecutivos.add(new SelectItem("0", "Seleccione..."));
				if(listaComisionistas.size()==0){ 
					selectItemsSlaveComisionistas.add(new SelectItem("-1", "-sin comisionistas-"));
					this.setComisionistaRequired(false);
					this.setComisionistaPorcentajeRequired(false);
					this.setComisionistaPorcentajeDisabled(true);
				}
				if(listaComisionistas.size()==1){
					this.setComisionistaRequired(true);
					this.setComisionistaPorcentajeRequired(true);
					this.setComisionistaPorcentajeDisabled(false);
				}else if(listaComisionistas.size()>1){
					this.setComisionistaRequired(true);
					this.setComisionistaPorcentajeRequired(true);
					this.setComisionistaPorcentajeDisabled(true);
				}
				if(listaComisionistas.size()>1) selectItemsSlaveComisionistas.add(new SelectItem("0", "Seleccione..."));
				for(int i=0; i<listaConvenios.size(); i++)
					selectItemsSlaveConvenios.add(new SelectItem(listaConvenios.get(i).getConvenio(), 
							listaConvenios.get(i).getNombreConvenio()));
				for(int i=0; i<listaEjecutivos.size(); i++)
					selectItemsSlaveEjecutivos.add(new SelectItem(listaEjecutivos.get(i).getIdEjecutivo(), 
							listaEjecutivos.get(i).getNombreEjecutivo()));
				for(int i=0; i<listaComisionistas.size(); i++)
					selectItemsSlaveComisionistas.add(new SelectItem(listaComisionistas.get(i).getIdComisionista(), 
							listaComisionistas.get(i).getNombreComisionista()));
				
				if(this.fechaPublicacionString!=null && !this.fechaPublicacionString.equals("")){
					listaEventos = mb.obtenerEventos(this.idPublicacion, this.fechaPublicacionString);
					if(listaEventos.size()==0) selectItemsSlaveEventos.add(new SelectItem("-1", "-sin eventos-"));
					if(listaEventos.size()>0) selectItemsSlaveEventos.add(new SelectItem("0", "Seleccione..."));
					for(int i=0; i<listaEventos.size(); i++)
						selectItemsSlaveEventos.add(new SelectItem(listaEventos.get(i).getIdEvento(), listaEventos.get(i).getNombreEvento()));
					listaTarifas = mb.obtenerTarifas(this.idCliente, this.idPublicacion, this.fechaPublicacionString);
					if(listaTarifas.size()==0){ 
						selectItemsSlaveTarifas.add(new SelectItem("-1", "-sin tarifas-"));
						this.setErrorPedidoSeccion1("Esta publicacin no cuenta con tarifas.");
					}
					if(listaTarifas.size()>1) selectItemsSlaveTarifas.add(new SelectItem("0", "Seleccione..."));
					for(int i=0; i<listaTarifas.size(); i++)
						selectItemsSlaveTarifas.add(new SelectItem(listaTarifas.get(i).getIdTarifa(), listaTarifas.get(i).getNombreTarifa()));
				}else{
					selectItemsSlaveTarifas.add(new SelectItem("-1", "-sin tarifas-"));
					selectItemsSlaveEventos.add(new SelectItem("-1", "-sin eventos-"));
				}
			}else{
				selectItemsSlaveTarifas.add(new SelectItem("-1", "-sin tarifas-"));
				selectItemsSlaveConvenios.add(new SelectItem("-1", "-sin convenios-"));
				selectItemsSlaveEjecutivos.add(new SelectItem("-1", "-sin ejecutivos-"));
		    	selectItemsSlaveComisionistas.add(new SelectItem("-1", "-sin comisionistas-"));
		    	selectItemsSlaveEventos.add(new SelectItem("-1", "-sin eventos-"));
			}
			if(this.idFormaPago!=0 && this.idFormaPago!=-1)
				setFormaPagoSlave(event);
			else{
				for(int i=0; i<listaTiposVenta.size(); i++)
					selectItemsSlaveTiposVenta.add(new SelectItem(listaTiposVenta.get(i).getIdTipoVenta(), 
							listaTiposVenta.get(i).getNombreTipoVenta()));
			}
			for(int i=0; i<listaFormasPago.size(); i++)
				selectItemsSlaveFormasPago.add(new SelectItem(listaFormasPago.get(i).getIdFormaPago(), 
						listaFormasPago.get(i).getNombreFormaPago()));
			for(int i=0; i<listaPosiciones.size(); i++)
				selectItemsSlavePosiciones.add(new SelectItem(listaPosiciones.get(i).getIdPosicion(), 
						listaPosiciones.get(i).getNombrePosicion()));
			if(this.fechaPublicacionString!=null && !this.fechaPublicacionString.equals("")) setFechaSlave(event);
		}else{
			selectItemsSlaveSuplementos.add(new SelectItem("-1", "-sin suplementos-"));
	    	selectItemsSlaveRegiones.add(new SelectItem("-1", "-sin regiones-"));
	    	selectItemsSlaveTarifas.add(new SelectItem("-1", "-sin tarifas-"));
	    	selectItemsSlavePatrocinios.add(new SelectItem("-1", "-sin patrocinios-"));
	    	selectItemsSlaveFormatos.add(new SelectItem("-1", "-sin formatos-"));
	    	selectItemsSlaveConvenios.add(new SelectItem("-1", "-sin convenios-"));
	    	selectItemsSlaveEventos.add(new SelectItem("-1", "-sin eventos-"));
	    	selectItemsSlaveFormasPago.add(new SelectItem("-1", "-sin formas pago-"));
	    	selectItemsSlaveTiposVenta.add(new SelectItem("-1", "-sin tipos venta-"));
	    	selectItemsSlavePosiciones.add(new SelectItem("-1", "-sin posiciones-"));
	    	selectItemsSlaveEjecutivos.add(new SelectItem("-1", "-sin ejecutivos-"));
	    	selectItemsSlaveComisionistas.add(new SelectItem("-1", "-sin comisionistas-"));
	    	selectItemsSlaveSecciones.add(new SelectItem("-1", "-sin secciones-"));
		}
		if(this.idAgencia==1199)//Directo
			this.setTipoOrden(1);
		else
			this.setTipoOrden(0);
		if(this.tipoOrden == 1)
        	numeroOrden = mb.obtenerNumeroOrden(this.idPublicacion, getIdUsuario()); 
    	this.setNumeroOrden(numeroOrden);
    	this.setIdOrden(numeroOrden);
    	radioTipOrden.setSubmittedValue(this.tipoOrden);
    	numOrden.setSubmittedValue(numeroOrden);
    	System.out.println("			--------------------  this.tipoPublicacion "+this.tipoPublicacion);
    	if(this.tipoPublicacion==1)
    		this.setPeriodicoRevistaStyle("panelGridRenglonPeriodicoRevistaOn");
    	else
    		this.setPeriodicoRevistaStyle("panelGridRenglonPeriodicoRevistaOff");
		System.out.println("<-- PedidoBBean.setPublicacionSlave() ");
    }

	public void setClienteSlave(ActionEvent event) throws Exception {
    	System.out.println("--> PedidoBBean.setClienteSlave() ");
    	FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
        UISelectOne selectAge = (UISelectOne)form.findComponent("agenciasList");
    	setDatos();
    	UIInput radioTipOrden = (UIInput)form.findComponent("radioTipoOrden");
        UIInput numOrden = (UIInput)form.findComponent("numOrden");
        String numeroOrden = "";
    	selectItemsSlaveAgencias = new ArrayList<SelectItem>();
    	selectItemsSlaveProductos = new ArrayList<SelectItem>();
    	selectItemsSlaveConvenios = new ArrayList<SelectItem>();
    	selectItemsSlaveTiposVenta = new ArrayList<SelectItem>();
    	selectItemsSlaveComisionistas = new ArrayList<SelectItem>();
    	selectItemsSlaveEjecutivos = new ArrayList<SelectItem>();
    	selectItemsSlaveTarifas = new ArrayList<SelectItem>();
		PedidoMBean mb = new PedidoMBean();
		List<PedidoBBean> listaAgencias = new ArrayList<PedidoBBean>();
		List<PedidoBBean> listaProductos = new ArrayList<PedidoBBean>();
		List<PedidoBBean> listaConvenios = new ArrayList<PedidoBBean>();
		List<PedidoBBean> listaTiposVenta = new ArrayList<PedidoBBean>();
		List<PedidoBBean> listaTarifas = new ArrayList<PedidoBBean>();
		List<PedidoBBean> listaEjecutivos = new ArrayList<PedidoBBean>();
		List<PedidoBBean> listaComisionistas = new ArrayList<PedidoBBean>();
		if(this.idCliente!=0){
			listaAgencias = mb.obtenerAgencias(this.idCliente);
			listaProductos = mb.obtenerProductos(this.idCliente);
			listaComisionistas = mb.obtenerComisionistas(this.idCliente, this.idPublicacion);
			if(this.publicacion!=null && !this.publicacion.equals("")){
				listaConvenios = mb.obtenerConvenios(this.idCliente, this.idPublicacion, this.valorEspecial, this.tipoValoracion);
				listaEjecutivos = mb.obtenerEjecutivos(this.idPublicacion, this.idCliente);
				if(listaEjecutivos.size()==0){
					selectItemsSlaveEjecutivos.add(new SelectItem("-1", "-sin ejecutivos-")); 
					this.setEjecutivoRequired(false);
				}
				if(listaEjecutivos.size()>1) selectItemsSlaveEjecutivos.add(new SelectItem("0", "Seleccione..."));
				for(int i=0; i<listaEjecutivos.size(); i++)
					selectItemsSlaveEjecutivos.add(new SelectItem(listaEjecutivos.get(i).getIdEjecutivo(), 
							listaEjecutivos.get(i).getNombreEjecutivo()));
				if(this.fechaPublicacionString!=null && !this.fechaPublicacionString.equals("")){
					listaTarifas = mb.obtenerTarifas(this.idCliente, this.idPublicacion, this.fechaPublicacionString);
					if(listaTarifas.size()==0){
						selectItemsSlaveTarifas.add(new SelectItem("-1", "-sin tarifas-"));
						this.setErrorPedidoSeccion1("Esta publicacin no cuenta con tarifas.");
					}
					if(listaTarifas.size()>1) selectItemsSlaveTarifas.add(new SelectItem("0", "Seleccione..."));
					for(int i=0; i<listaTarifas.size(); i++)
						selectItemsSlaveTarifas.add(new SelectItem(listaTarifas.get(i).getIdTarifa(), listaTarifas.get(i).getNombreTarifa()));
				}
			}
		}	
		listaTiposVenta = mb.obtenerTiposVenta();
		if(listaAgencias.size()==0){
			selectItemsSlaveAgencias.add(new SelectItem("-1", "-sin agencias-"));
			this.setAgenciaRequired(false);
			this.setIdAgencia(0);
		}
		if(listaAgencias.size()>1) selectItemsSlaveAgencias.add(new SelectItem("0", "Seleccione..."));
		if(listaProductos.size()==0) selectItemsSlaveProductos.add(new SelectItem("-1", "-sin productos-"));
		if(listaProductos.size()>1) selectItemsSlaveProductos.add(new SelectItem("0", "Seleccione..."));
		if(listaConvenios.size()==0) selectItemsSlaveConvenios.add(new SelectItem("-1", "-sin convenios-"));
		if(listaConvenios.size()>0)selectItemsSlaveConvenios.add(new SelectItem("0", "Seleccione..."));
		if(listaTiposVenta.size()==0) selectItemsSlaveTiposVenta.add(new SelectItem("-1", "-sin tipos venta-"));
		if(listaTiposVenta.size()>1) selectItemsSlaveTiposVenta.add(new SelectItem("0", "Seleccione..."));
		if(listaComisionistas.size()==0){ 
			selectItemsSlaveComisionistas.add(new SelectItem("-1", "-sin comisionistas-"));
			this.setComisionistaRequired(false);
			this.setComisionistaPorcentajeRequired(false);
			this.setComisionistaPorcentajeDisabled(true);
		}
		if(listaComisionistas.size()==1){
			this.setComisionistaRequired(true);
			this.setComisionistaPorcentajeRequired(true);
			this.setComisionistaPorcentajeDisabled(false);
		}else if(listaComisionistas.size()>1){
			this.setComisionistaRequired(true);
			this.setComisionistaPorcentajeRequired(true);
			this.setComisionistaPorcentajeDisabled(true);
		}
		if(listaComisionistas.size()>1) selectItemsSlaveComisionistas.add(new SelectItem("0", "Seleccione..."));
		if(listaTarifas.size()==0){
			selectItemsSlaveTarifas.add(new SelectItem("-1", "-sin tarifas-"));
		}
		if(listaTarifas.size()>1) selectItemsSlaveTarifas.add(new SelectItem("0", "Seleccione..."));
		for(int i=0; i<listaAgencias.size(); i++){
			selectItemsSlaveAgencias.add(new SelectItem(listaAgencias.get(i).getIdAgencia(), listaAgencias.get(i).getNombreAgencia()));
			if(listaAgencias.get(i).isEsDefault()){
				this.setIdAgencia(listaAgencias.get(i).getIdAgencia());
				selectAge.setSubmittedValue(this.getIdAgencia());
			}
		}
		for(int i=0; i<listaProductos.size(); i++)
			selectItemsSlaveProductos.add(new SelectItem(listaProductos.get(i).getIdProducto(), listaProductos.get(i).getNombreProducto()));
		for(int i=0; i<listaConvenios.size(); i++)
			selectItemsSlaveConvenios.add(new SelectItem(listaConvenios.get(i).getConvenio(), listaConvenios.get(i).getNombreConvenio()));
		for(int i=0; i<listaTiposVenta.size(); i++)
			selectItemsSlaveTiposVenta.add(new SelectItem(listaTiposVenta.get(i).getIdTipoVenta(), listaTiposVenta.get(i).getNombreTipoVenta()));
		for(int i=0; i<listaComisionistas.size(); i++)
			selectItemsSlaveComisionistas.add(new SelectItem(listaComisionistas.get(i).getIdComisionista(), 
					listaComisionistas.get(i).getNombreComisionista()));
		if(this.idAgencia==1199)//Directo
			this.setTipoOrden(1);
		else
			this.setTipoOrden(0);
		if(this.tipoOrden == 1)
        	numeroOrden = mb.obtenerNumeroOrden(this.idPublicacion, getIdUsuario()); 
    	this.setNumeroOrden(numeroOrden);
    	this.setIdOrden(numeroOrden);
    	radioTipOrden.setSubmittedValue(this.tipoOrden);
    	numOrden.setSubmittedValue(numeroOrden);
		System.out.println("<-- PedidoBBean.setClienteSlave() ");
    }
	
	public void setAgenciaSalve(ActionEvent event) throws Exception{
		System.out.println("--> PedidoBBean.setAgenciaSalve() ");
		FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
        UISelectOne selectPublicacionesList = (UISelectOne)form.findComponent("publicacionesList");
        decodePublicacion((String)selectPublicacionesList.getSubmittedValue());
		UISelectOne selectAge = (UISelectOne)form.findComponent("agenciasList");
		if(selectAge.getSubmittedValue()!=null && !selectAge.getSubmittedValue().equals(""))
			this.setIdAgencia(Integer.parseInt(selectAge.getSubmittedValue().toString()));
        UIInput radioTipOrden = (UIInput)form.findComponent("radioTipoOrden");
        UIInput numOrden = (UIInput)form.findComponent("numOrden");
        String numeroOrden = "";
        PedidoMBean mb = new PedidoMBean();
        if(this.idAgencia==1199)//Directo
			this.setTipoOrden(1);
		else
			this.setTipoOrden(0);
        if(this.tipoOrden == 1){
        	numeroOrden = mb.obtenerNumeroOrden(this.idPublicacion, getIdUsuario());
        }
    	this.setNumeroOrden(numeroOrden);
    	this.setIdOrden(numeroOrden);
    	radioTipOrden.setSubmittedValue(this.tipoOrden);
    	numOrden.setSubmittedValue(numeroOrden);
		System.out.println("<-- PedidoBBean.setAgenciaSalve() "+this.tipoOrden);
	}
	
	public void setComisionistaSalve(ActionEvent event) throws Exception{
		System.out.println("--> PedidoBBean.setComisionistaSalve() ");
		FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
        UISelectOne selectComisionistasList = (UISelectOne)form.findComponent("comisionistasList");
        this.setIdComisionista(Integer.parseInt(selectComisionistasList.getSubmittedValue().toString()));
        if(this.idComisionista==0 || this.idComisionista==-1){
			this.setPorcentajeComisionista(null);
			this.setComisionistaPorcentajeRequired(false);
			this.setComisionistaPorcentajeDisabled(true);
        }else{
        	this.setComisionistaPorcentajeRequired(true);
			this.setComisionistaPorcentajeDisabled(false);
        }
		System.out.println("<-- PedidoBBean.setComisionistaSalve() "+this.tipoOrden);
	}
	
	public void setTipoOrdenSlave(ActionEvent event) throws Exception{
    	System.out.println("--> PedidoBBean.setTipoOrdenSlave ");
    	FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
        UIInput radioTipOrden = (UIInput)form.findComponent("radioTipoOrden");
        UIInput numOrden = (UIInput)form.findComponent("numOrden");
        String numeroOrden = "";
        PedidoMBean mb = new PedidoMBean();
        System.out.println("     radioTipOrden.getSubmittedValue() "+radioTipOrden.getSubmittedValue());
        try{
        	this.setTipoOrden(Integer.parseInt(radioTipOrden.getSubmittedValue().toString()));
        }catch(Exception ex){
        	System.out.println("ERROR :  PedidoBBean.setTipoOrdenSlave: "+ex);
        }
        System.out.println("     tipoOrden "+this.tipoOrden);
        if(this.tipoOrden == 1)
        	numeroOrden = mb.obtenerNumeroOrden(this.idPublicacion, getIdUsuario()); 
    	this.setNumeroOrden(numeroOrden);
    	this.setIdOrden(numeroOrden);
    	radioTipOrden.setSubmittedValue(this.tipoOrden);
    	numOrden.setSubmittedValue(numeroOrden);
    	System.out.println("<-- PedidoBBean.setTipoOrdenSlave ");
    }
	
	public void setFechaSlave(ActionEvent event) throws Exception {
		System.out.println("--> PedidoBBean.setFechaSalve() ");
		setDatos();
		List<PedidoBBean> listaTarifas = new ArrayList<PedidoBBean>();
		List<PedidoBBean> listaEventos = new ArrayList<PedidoBBean>();
		PedidoMBean mb = new PedidoMBean();
		if(this.publicacion!=null && !this.publicacion.equals("") 
				&& this.fechaPublicacionString!=null && !this.fechaPublicacionString.equals("")
				&& this.idRegion!=0 && this.idRegion!=-1){
			selectItemsSlaveEventos = new ArrayList<SelectItem>();
			listaEventos = mb.obtenerEventos(this.idPublicacion, this.fechaPublicacionString);
			if(listaEventos.size()==0) selectItemsSlaveEventos.add(new SelectItem("-1", "-sin eventos-"));
			if(listaEventos.size()>0) selectItemsSlaveEventos.add(new SelectItem("0", "Seleccione..."));
			for(int i=0; i<listaEventos.size(); i++)
				selectItemsSlaveEventos.add(new SelectItem(listaEventos.get(i).getIdEvento(), listaEventos.get(i).getNombreEvento()));
			if(this.idCliente!=0){
				selectItemsSlaveTarifas = new ArrayList<SelectItem>();
				listaTarifas = mb.obtenerTarifas(this.idCliente, this.idPublicacion, this.fechaPublicacionString);
				if(listaTarifas.size()==0){
					selectItemsSlaveTarifas.add(new SelectItem("-1", "-sin tarifas-"));
					this.setErrorPedidoSeccion1("Esta publicacin no cuenta con tarifas.");
				}
				if(listaTarifas.size()>1) selectItemsSlaveTarifas.add(new SelectItem("0", "Seleccione..."));
				for(int i=0; i<listaTarifas.size(); i++)
					selectItemsSlaveTarifas.add(new SelectItem(listaTarifas.get(i).getIdTarifa(), listaTarifas.get(i).getNombreTarifa()));
				if(this.idConvenio!=0 && this.idConvenio!=-1)
	    			mb.obtenerDetallesConvenio(this.idCliente, this.idPublicacion, this.idConvenio, this.fechaPublicacionString, 
	    					this.valorEspecial, this.tipoValoracion, this.idTarifa, this.idRegion, this.idFormato, this.tipoFormato, this.altoFormato, 
	    					this.anchoFormato);
				if(listaTarifas.size()==1)this.setIdTarifa(listaTarifas.get(0).getIdTarifa());
				mb.obtenerDetallesRegion(this.idPublicacion, this.idRegion, this.fechaPublicacionString, this.idTarifa, 
	        			this.idFormato, this.altoFormato, this.anchoFormato, this.tipoFormato, this.tipoValoracion, this.valorEspecial);
			}
		}else if(listaTarifas.size()==0){
			selectItemsSlaveTarifas.add(new SelectItem("-1", "-sin tarifas-"));
			this.setErrorPedidoSeccion1("Esta publicacin no cuenta con tarifas.");
		}
		System.out.println("<-- PedidoBBean.setFechaSalve() "+this.fechaPublicacionString);
	}
    
	public void setProductoSlave(ActionEvent event) throws Exception {
		System.out.println("--> PedidoBBean.setProductoSlave() ");
		setDatos();
        List<PedidoBBean> listaTarifas = new ArrayList<PedidoBBean>();
        List<PedidoBBean> listaVersiones = new ArrayList<PedidoBBean>();
        selectItemsSlaveTarifas = new ArrayList<SelectItem>();
        selectItemsSlaveVersiones = new ArrayList<SelectItem>();
        PedidoMBean mb = new PedidoMBean();
        if(this.idProducto!=-1){
        	listaVersiones = mb.obtenerVersiones(this.idProducto);
        	if(listaVersiones.size()==0) selectItemsSlaveVersiones.add(new SelectItem("-1", "-sin versiones-"));
			if(listaVersiones.size()>1) selectItemsSlaveVersiones.add(new SelectItem("0", "Seleccione..."));
        	for(int i=0; i<listaVersiones.size(); i++)
        		selectItemsSlaveVersiones.add(new SelectItem(listaVersiones.get(i).getIdVersion(), listaVersiones.get(i).getNombreVersion()));
        }else{
        	selectItemsSlaveVersiones.add(new SelectItem("-1", "-sin versiones-"));
        }
        if(this.fechaPublicacionString!=null && !this.fechaPublicacionString.equals("")){
			listaTarifas = mb.obtenerTarifas(this.idCliente, this.idPublicacion, this.fechaPublicacionString);
			if(listaTarifas.size()==0){
				selectItemsSlaveTarifas.add(new SelectItem("-1", "-sin tarifas-"));
				this.setErrorPedidoSeccion1("Esta publicacin no cuenta con tarifas.");
			}
			if(listaTarifas.size()>1) selectItemsSlaveTarifas.add(new SelectItem("0", "Seleccione..."));
			for(int i=0; i<listaTarifas.size(); i++)
				selectItemsSlaveTarifas.add(new SelectItem(listaTarifas.get(i).getIdTarifa(), listaTarifas.get(i).getNombreTarifa()));
		}else if(listaTarifas.size()==0){
			selectItemsSlaveTarifas.add(new SelectItem("-1", "-sin tarifas-"));
		}
		System.out.println("<-- PedidoBBean.setProductoSlave() ");
	}
	
	public void setValorEspecialSlave(ActionEvent event) throws Exception {
    	System.out.println("--> PedidoBBean.setValorEspecialSlave()");
    	setDatos();
    	FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
        UIInput valorEspecialHidden = (UIInput)form.findComponent("valorEspecialHidden");
        this.setValorEspecial((String)valorEspecialHidden.getSubmittedValue());
        System.out.println("	--> valorEspecialHidden "+valorEspecialHidden.getSubmittedValue());
        UIInput tipoValoracionHidden = (UIInput)form.findComponent("tipoValoracionHidden");
    	System.out.println("		--> tipoValoracionHidden) "+tipoValoracionHidden.getSubmittedValue());
    	this.setTipoValoracion((String)tipoValoracionHidden.getSubmittedValue());
        if(this.publicacion!=null && !this.publicacion.equals("") && this.idRegion!=0 && this.idRegion!=-1 
        		&& this.fechaPublicacionString!=null && !this.fechaPublicacionString.equals("") 
        		&& this.idTarifa!=0 && this.idTarifa!=-1 && this.valorEspecial!=null && !this.valorEspecial.equals("")){
        	PedidoMBean mb = new PedidoMBean();
        	DetallePedidoBBean detallePedidoBBean = new DetallePedidoBBean();
        	mb.obtenerDetallesRegion(this.idPublicacion, this.idRegion, this.fechaPublicacionString, this.idTarifa, 
        			this.idFormato, this.altoFormato, this.anchoFormato, this.tipoFormato, this.tipoValoracion, this.valorEspecial);
        	if(detallePedidoBBean.getCotizacionAnuncio()!=null && !detallePedidoBBean.getCotizacionAnuncio().equals("")) 
        		detallePedidoBBean.setCotizacionAnuncioLabel("Cotizacin Anuncio: ");
        	if(this.idCliente!=0 && this.publicacion!=null && !this.publicacion.equals("") 
    				&& this.idConvenio!=0 && this.idConvenio!=-1 && this.fechaPublicacionString!=null 
    				&& !this.fechaPublicacionString.equals("")
    				&& this.idTarifa!=0 && this.idTarifa!=-1 && this.idRegion!=0 && this.idRegion!=-1)
    			mb.obtenerMontoRestanteConvenio(this.idCliente, this.idPublicacion, this.idConvenio, this.fechaPublicacionString, 
    					this.valorEspecial, this.tipoValoracion, this.idTarifa, this.idRegion, this.idFormato, this.tipoFormato, this.altoFormato, 
    					this.anchoFormato, null, null);
        }
		System.out.println("<-- PedidoBBean.setValorEspecialSlave()");
    }
     
	public void setFormatoMedidasSlave(ActionEvent event) throws Exception { 
    	System.out.println("--> PedidoBBean.setFormatoMedidasSlave()");
    	setDatos();
    	FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
        HtmlInputNumberSpinner sAlto = (HtmlInputNumberSpinner)form.findComponent("spinnerAlto");
        HtmlInputNumberSpinner sAncho = (HtmlInputNumberSpinner)form.findComponent("spinnerAncho");
        decodeMedidasEspeciales(sAlto.getValue(), sAncho.getValue());
        String alto = "";
        String ancho = "";
        
        UISelectOne selectCon = (UISelectOne)form.findComponent("conveniosList");
        decodeConvenio((String)selectCon.getSubmittedValue());
        UISelectOne selectFmt = (UISelectOne)form.findComponent("formatosList");
        System.out.println("--> selectFmt.getSubmittedValue() --- "+selectFmt.getSubmittedValue());
        this.setFormato((String)selectFmt.getSubmittedValue());
        decodeFormato(this.getFormato());
        //if(this.idFormato==0)
        	
        System.out.println("--> sAlto.getValue() "+sAlto.getValue());
        System.out.println("--> sAncho.getValue() "+sAncho.getValue());
        System.out.println("--> this.publicacion "+this.publicacion);
        System.out.println("--> this.idFormato "+this.idFormato);
        
        if(sAlto.getValue()!=null && !sAlto.getValue().equals(""))
        	alto = sAlto.getValue().toString();
        if(sAncho.getValue()!=null && !sAncho.getValue().equals(""))
        	ancho = sAncho.getValue().toString();
        PedidoMBean mb = new PedidoMBean();
		if(this.formato!=null && !this.formato.equals("")){
			if(this.formatos==null || this.formatos.size()==0)
	    		if(this.publicacion!=null && !this.publicacion.equals("")) 
	    			this.formatos = mb.obtenerFormatos(this.idPublicacion);
			for(int i=0; i<this.formatos.size(); i++){
				if(this.formatos.get(i).getIdFormato()==this.idFormato){
					if(this.formatos.get(i).getTipoFormato()==1){//formatoEspecial
						sAlto.setDisabled(false);
						sAlto.setValue(0);
						sAlto.setEnableManualInput(true);
						sAncho.setDisabled(false);
						sAncho.setValue(0);
						sAncho.setEnableManualInput(true);
						this.setAltoDisabled(false);
						this.setAltoRequired(true);
						this.setAnchoDisabled(false);
						this.setAnchoRequired(true);
					}else{
						sAncho.setValue(this.formatos.get(i).getAnchoFormato());
						sAncho.setSubmittedValue(this.formatos.get(i).getAnchoFormato());
						sAncho.setEnableManualInput(false);
						sAncho.setDisabled(true);
						sAlto.setValue(this.formatos.get(i).getAltoFormato());
						sAlto.setSubmittedValue(this.formatos.get(i).getAltoFormato());
						sAlto.setEnableManualInput(false);
						sAlto.setDisabled(true);
					}
				}
			}
		}else{
			sAlto.setDisabled(true);
			sAlto.setValue(null);
			sAncho.setDisabled(true);
			sAncho.setValue(null);
		}
		if(this.fechaPublicacionString!=null && !this.fechaPublicacionString.equals("") && this.idTarifa!=0 
        		&& this.idTarifa!=-1 && this.idRegion!=0 && this.idRegion!=-1)
        	mb.obtenerDetallesRegion(this.idPublicacion, this.idRegion, this.fechaPublicacionString, this.idTarifa, 
        			this.idFormato, alto, ancho, this.tipoFormato, this.tipoValoracion, this.valorEspecial);
		
		System.out.println("--> this.idCliente "+this.idCliente);
        System.out.println("--> this.publicacion "+this.publicacion);
        System.out.println("--> this.idConvenio "+this.idConvenio);
        System.out.println("--> this.fechaPublicacionString "+this.fechaPublicacionString);
        System.out.println("--> this.idTarifa "+this.idTarifa);
        System.out.println("--> this.idRegion "+this.idRegion);
		
		if(this.idCliente!=0 && this.publicacion!=null && !this.publicacion.equals("") 
				&& this.idConvenio!=0 && this.idConvenio!=-1 && this.fechaPublicacionString!=null 
				&& !this.fechaPublicacionString.equals("")
				&& this.idTarifa!=0 && this.idTarifa!=-1 && this.idRegion!=0 && this.idRegion!=-1)
			mb.obtenerMontoRestanteConvenio(this.idCliente, this.idPublicacion, this.idConvenio, this.fechaPublicacionString, 
					this.valorEspecial, this.tipoValoracion, this.idTarifa, this.idRegion, this.idFormato, this.tipoFormato, alto, 
					ancho, null, null);
		if(this.getTipoPublicacion()==1){// periodico
    		this.setMaxAlto("35.5");
    		this.setMaxAncho("5");
    	}else{// revista
    		this.setMaxAlto("27.5");
    		this.setMaxAncho("21");
    	}
		System.out.println("<-- PedidoBBean.setFormatoMedidasSlave() ");
    }
    
	public void setFormatoAltoAnchoSlave(ActionEvent event) throws Exception {
    	System.out.println("--> PedidoBBean.setFormatoAltoAnchoSlave() ");
    	setDatos();
    	PedidoMBean mb = new PedidoMBean();
    	DetallePedidoBBean detallePedidoBBean = new DetallePedidoBBean();
    	if(this.idCliente!=0 && this.publicacion!=null && !this.publicacion.equals("") 
				&& this.fechaPublicacionString!=null && !this.fechaPublicacionString.equals("")
				&& this.idTarifa!=0 && this.idTarifa!=-1 && this.idRegion!=0 && this.idRegion!=-1)
			mb.obtenerMontoRestanteConvenio(this.idCliente, this.idPublicacion, this.idConvenio, this.fechaPublicacionString, 
					this.valorEspecial, this.tipoValoracion, this.idTarifa, this.idRegion, this.idFormato, this.tipoFormato, this.altoFormato, 
					this.anchoFormato, null, detallePedidoBBean.getListaDetalleConvenio());
    	if(this.publicacion!=null && !this.publicacion.equals("") && this.idRegion!=0 && this.idRegion!=-1 
        		&& this.fechaPublicacionString!=null && !this.fechaPublicacionString.equals("") 
        		&& this.idTarifa!=0 && this.idTarifa!=-1 && this.formato!=null && !this.formato.equals("") 
        		&& this.altoFormato!=null && !this.altoFormato.equals("") 
        		&& this.anchoFormato!=null && !this.anchoFormato.equals("")){
        	mb.obtenerDetallesRegion(this.idPublicacion, this.idRegion, this.fechaPublicacionString, this.idTarifa, 
        			this.idFormato, this.altoFormato, this.anchoFormato, this.tipoFormato, this.tipoValoracion, this.valorEspecial);
        	if(detallePedidoBBean.getCotizacionAnuncio()!=null && !detallePedidoBBean.getCotizacionAnuncio().equals("")) 
        		detallePedidoBBean.setCotizacionAnuncioLabel("Cotizacin Anuncio: ");
        }
		System.out.println("<-- PedidoBBean.setFormatoAltoAnchoSlave() "+detallePedidoBBean.getCotizacionAnuncio());
    }

	public void setFormaPagoSlave(ActionEvent event) throws Exception {
    	System.out.println("--> PedidoBBean.setFormaPagoSlave() ");
    	setDatos();
    	PedidoMBean mb = new PedidoMBean();
    	selectItemsSlaveTiposVenta = new ArrayList<SelectItem>();
    	List<PedidoBBean> listaTipoVenta = new ArrayList<PedidoBBean>();
    	if(this.idFormaPago!=0 && this.idFormaPago!=-1){
    		listaTipoVenta = mb.obtenerTiposVentaFormaPago(this.idFormaPago);
    		if(listaTipoVenta.size()==0) selectItemsSlaveTiposVenta.add(new SelectItem("-1", "-sin tipos venta-"));
    		if(listaTipoVenta.size()>1) selectItemsSlaveTiposVenta.add(new SelectItem("0", "Seleccione..."));
    		for(int i=0; i<listaTipoVenta.size(); i++)
    			selectItemsSlaveTiposVenta.add(new SelectItem(listaTipoVenta.get(i).getIdTipoVenta(), 
    					listaTipoVenta.get(i).getNombreTipoVenta()));
    	}else
    		selectItemsSlaveTiposVenta.add(new SelectItem("-1", "-sin tipos venta-"));
    	System.out.println("<-- PedidoBBean.setFormaPagoSlave() ");
    }
    
    public void setDetalleConvenioSlave(ActionEvent event) throws Exception {
    	System.out.println("--> PedidoBBean.setDetalleConvenioSlave() ");
    	setDatos();
    	FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
    	UISelectOne selectCon = (UISelectOne)form.findComponent("conveniosList");
        decodeConvenio((String)selectCon.getSubmittedValue());
        selectItemsSlaveFormasPago = new ArrayList<SelectItem>();
        selectItemsSlaveTiposVenta = new ArrayList<SelectItem>();
        List<PedidoBBean> listaFormasPago = new ArrayList<PedidoBBean>();
    	List<PedidoBBean> listaTiposVenta = new ArrayList<PedidoBBean>();
    	PedidoMBean mb = new PedidoMBean();
        if(this.idConvenio!=0 && this.idConvenio!=-1){
        	listaFormasPago = mb.obtenerTipoVentaFormaPago(this.idConvenio, this.idFormaPago);
        	listaTiposVenta = mb.obtenerTiposVentaFormaPago(this.idFormaPago);
        	if(listaFormasPago.size()==0) selectItemsSlaveFormasPago.add(new SelectItem("-1", "-sin formas pago-"));
    		if(listaFormasPago.size()>1) selectItemsSlaveFormasPago.add(new SelectItem("0", "Seleccione..."));
    		if(listaTiposVenta.size()==0) selectItemsSlaveTiposVenta.add(new SelectItem("-1", "-sin tipos venta-"));
    		if(listaTiposVenta.size()>1) selectItemsSlaveTiposVenta.add(new SelectItem("0", "Seleccione..."));
    		for(int i=0; i<listaFormasPago.size(); i++)
    				selectItemsSlaveFormasPago.add(new SelectItem(listaFormasPago.get(i).getIdFormaPago(), 
    						listaFormasPago.get(i).getNombreFormaPago()));
    		for(int i=0; i<listaTiposVenta.size(); i++)
					selectItemsSlaveTiposVenta.add(new SelectItem(listaTiposVenta.get(i).getIdTipoVenta(), 
							listaTiposVenta.get(i).getNombreTipoVenta()));
    		if(this.idCliente!=0 && this.idPublicacion!=0 && this.idPublicacion!=-1 
    				&& this.idConvenio!=0 && this.idConvenio!=-1 && this.fechaPublicacionString!=null 
    				&& !this.fechaPublicacionString.equals("")){
    			mb.obtenerDetallesConvenio(this.idCliente, this.idPublicacion, this.idConvenio, this.fechaPublicacionString, 
    					this.valorEspecial, this.tipoValoracion, this.idTarifa, this.idRegion, this.idFormato, this.tipoFormato, this.altoFormato, 
    					this.anchoFormato);
    		}
        }else{
			mb.obtenerMontoRestanteConvenio(this.idCliente, this.idPublicacion, this.idConvenio, this.fechaPublicacionString, 
					this.valorEspecial, this.tipoValoracion, this.idTarifa, this.idRegion, this.idFormato, this.tipoFormato, this.altoFormato, 
					this.anchoFormato, null, null);
        	listaFormasPago = mb.obtenerFormasPago();
        	listaTiposVenta = mb.obtenerTiposVenta();
        	selectItemsSlaveFormasPago.add(new SelectItem("0", "Seleccione..."));
        	selectItemsSlaveTiposVenta.add(new SelectItem("0", "Seleccione..."));
        	System.out.println("--> PedidoBBean.setDetalleConvenioSlave() "+listaFormasPago.size());
        	for(int i=0; i<listaFormasPago.size(); i++)
    			selectItemsSlaveFormasPago.add(new SelectItem(listaFormasPago.get(i).getIdFormaPago(), 
    					listaFormasPago.get(i).getNombreFormaPago()));
        	for(int i=0; i<listaTiposVenta.size(); i++)
    			selectItemsSlaveTiposVenta.add(new SelectItem(listaTiposVenta.get(i).getIdTipoVenta(), 
    					listaTiposVenta.get(i).getNombreTipoVenta()));
        }
    	System.out.println("<-- PedidoBBean.setDetalleConvenioSlave() ");
    }
    
    public void setDetalleRegionSlave(ActionEvent event) throws Exception {
    	System.out.println("--> PedidoBBean.setDetalleRegionSlave() ");
    	setDatos();
        PedidoMBean mb = new PedidoMBean();
        if(this.fechaPublicacionString!=null && !this.fechaPublicacionString.equals("")){
			mb.obtenerDetallesRegion(this.idPublicacion, this.idRegion, this.fechaPublicacionString, this.idTarifa, 
        			this.idFormato, this.altoFormato, this.anchoFormato, this.tipoFormato, this.tipoValoracion, this.valorEspecial);
        }
    	System.out.println("<-- PedidoBBean.setDetalleRegionSlave() ");
    }
    
    public void setTarifaSlave(ActionEvent event) throws Exception {
    	setFechaSlave(event);
    }
    
    public void getTarifaNewUpdate(ActionEvent event) throws Exception {
    	System.out.println("--> PedidoBBean.getTarifaNewUpdate() ");
    	selectItemsDivisa = new ArrayList<SelectItem>();
    	PedidoMBean mb = new PedidoMBean();
    	List<PedidoBBean> lsTarifa = null;
    	List<PedidoBBean> lsDivisas = null;
    	this.setRespuestaTarifaNewUpdate("");
    	FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
        UISelectOne selectPublicacionesList = (UISelectOne)form.findComponent("publicacionesList");
        decodePublicacion((String)selectPublicacionesList.getSubmittedValue());
        try{
        	UISelectOne selectTar = (UISelectOne)form.findComponent("tarifasList");
        	this.setIdTarifa(Integer.parseInt(selectTar.getSubmittedValue().toString()));
        }catch(Exception e){
        	//nada
        }
        UIInput fechaInicialHidden = (UIInput)form.findComponent("fInicioTarifaHidden");
    	UIInput fechaFinalHidden = (UIInput)form.findComponent("fFinTarifaHidden");
    	UIInput nombreTarifaHidden = (UIInput)form.findComponent("nombreTarifaHidden");
    	UIInput publicacionTarifaHidden = (UIInput)form.findComponent("publicacionTarifaHidden");
    	UIInput publicacionDivisaHidden = (UIInput)form.findComponent("publicacionDivisaHidden");
    	UIInput radioStatusHidden = (UIInput)form.findComponent("radioStatusHidden");
    	UIInput costoTotalDivisaHidden = (UIInput)form.findComponent("costoTotalDivisaHidden");
        
        UICalendar fechaInicial = (UICalendar)form.findComponent("fechaTarifaInicio");
        UICalendar fechaFinal = (UICalendar)form.findComponent("fechaTarifaFin");
        UIInput nombreTarifaNewUpdate = (UIInput)form.findComponent("tarifaNewUpdateField");
        UISelectOne selectPublicacionesTarifaList = (UISelectOne)form.findComponent("publicacionesTarifaList");
        UISelectOne selectPublicacionesDivisaList = (UISelectOne)form.findComponent("publicacionesDivisaList");
        UIInput radioStatus = (UIInput)form.findComponent("radioStatusTarifa");
        UIInput costoTotalDivisa = (UIInput)form.findComponent("costoTotalDivisa");
        HtmlAjaxCommandLink botonActualizarTarifa = (HtmlAjaxCommandLink)form.findComponent("botonActualizarTarifa");
        botonActualizarTarifa.setDisabled(false);
    	botonActualizarTarifa.setStyleClass("botonActualizarOn");
        lsTarifa = mb.obtenerDetallesTarifa(this.idPublicacion, this.idTarifa);
        lsDivisas = mb.obtenerDivisas();
        if(lsTarifa!=null && !lsTarifa.isEmpty()){
        	fechaInicial.setSubmittedValue(lsTarifa.get(0).getFechaTarifaInicioDate());
        	fechaInicialHidden.setValue(lsTarifa.get(0).getFechaTarifaInicioDate());
        	fechaFinal.setSubmittedValue(lsTarifa.get(0).getFechaTarifaFinDate());
        	fechaFinalHidden.setValue(lsTarifa.get(0).getFechaTarifaFinDate());
        	nombreTarifaNewUpdate.setSubmittedValue(lsTarifa.get(0).getNombreTarifaNewUpdate());
        	nombreTarifaHidden.setValue(lsTarifa.get(0).getNombreTarifaNewUpdate());
        	selectPublicacionesTarifaList.setSubmittedValue(lsTarifa.get(0).getPublicacionTarifa());
        	publicacionTarifaHidden.setValue(lsTarifa.get(0).getPublicacionTarifa());
        	selectPublicacionesDivisaList.setSubmittedValue(lsTarifa.get(0).getIdDivisa());
        	publicacionDivisaHidden.setValue(lsTarifa.get(0).getIdDivisa());
        	radioStatus.setSubmittedValue(lsTarifa.get(0).getEstatus());
        	radioStatusHidden.setValue(lsTarifa.get(0).getEstatus());
        	costoTotalDivisa.setSubmittedValue(lsTarifa.get(0).getCostoTotalDivisa());
        	costoTotalDivisaHidden.setValue(lsTarifa.get(0).getCostoTotalDivisa());
        }else{
        	fechaInicial.setSubmittedValue("");
        	fechaInicialHidden.setValue("");
        	fechaFinal.setSubmittedValue("");
        	fechaFinalHidden.setValue("");
        	nombreTarifaNewUpdate.setSubmittedValue("");
        	nombreTarifaHidden.setValue("");
        	selectPublicacionesTarifaList.setSubmittedValue("");
        	publicacionTarifaHidden.setValue("");
        	selectPublicacionesDivisaList.setSubmittedValue("");
        	publicacionDivisaHidden.setValue("");
        	radioStatus.setSubmittedValue("");
        	radioStatusHidden.setValue("");
        	costoTotalDivisa.setSubmittedValue("");
        	costoTotalDivisaHidden.setValue("");
        }
        if(lsDivisas.size()==0) selectItemsDivisa.add(new SelectItem("-1", "-sin divisa-"));
		for(int i=0; i<lsDivisas.size(); i++)
			selectItemsDivisa.add(new SelectItem(lsDivisas.get(i).getIdDivisa(), lsDivisas.get(i).getNombreDivisa()));
    	System.out.println("<-- PedidoBBean.getTarifaNewUpdate() ");
    }
    
    public void setTarifa(ActionEvent event) throws Exception {
    	System.out.println("--> PedidoBBean.setTarifa() ");
    	PedidoMBean mb = new PedidoMBean();
    	List<PedidoBBean> lsTarifa = null;
    	this.setRespuestaTarifaNewUpdate("");
    	FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
        UISelectOne selectPublicacionesList = (UISelectOne)form.findComponent("publicacionesList");
        decodePublicacion((String)selectPublicacionesList.getSubmittedValue());
        UISelectOne selectTar = (UISelectOne)form.findComponent("tarifasList");
        boolean decode = false;
        try{
        	this.setIdTarifa(Integer.parseInt(selectTar.getSubmittedValue().toString()));
        	UIInput fechaInicial = (UIInput)form.findComponent("fInicioTarifaHidden");
        	UIInput fechaFinal = (UIInput)form.findComponent("fFinTarifaHidden");
        	UIInput nombreTarifaNewUpdate = (UIInput)form.findComponent("nombreTarifaHidden");
        	UIInput selectPublicacionesTarifaList = (UIInput)form.findComponent("publicacionTarifaHidden");
        	UIInput selectPublicacionesDivisaList = (UIInput)form.findComponent("publicacionDivisaHidden");
        	UIInput radioStatus = (UIInput)form.findComponent("radioStatusHidden");
        	UIInput costoTotalDivisa = (UIInput)form.findComponent("costoTotalDivisaHidden");
        	System.out.println("////////////////////////////////////////////////////////////////////////");
        	System.out.println("	fechaInicial		"+fechaInicial.getSubmittedValue());
        	System.out.println("	fechaInicial		"+fechaInicial.getValue());
        	System.out.println("	fechaFinal			"+fechaFinal.getSubmittedValue());
        	System.out.println("	fechaFinal			"+fechaFinal.getValue());
        	System.out.println("	nombreTarifaNewUpdate			"+nombreTarifaNewUpdate.getSubmittedValue());
        	System.out.println("	nombreTarifaNewUpdate			"+nombreTarifaNewUpdate.getValue());
        	System.out.println("	selectPublicacionesTarifaList			"+selectPublicacionesTarifaList.getSubmittedValue());
        	System.out.println("	selectPublicacionesTarifaList			"+selectPublicacionesTarifaList.getValue());
        	System.out.println("////////////////////////////////////////////////////////////////////////");
        	if(fechaInicial.getSubmittedValue()!=null && !fechaInicial.getSubmittedValue().toString().equals("")){
        		this.setFechaTarifaInicioString((String)fechaInicial.getSubmittedValue());
        		decode = true;
        	}else if(fechaInicial.getValue()!=null && !fechaInicial.getValue().toString().equals("")){
        		this.setFechaTarifaInicioString(fechaInicial.getValue().toString());
        	}
        	if(fechaFinal.getSubmittedValue()!=null && !fechaFinal.getSubmittedValue().toString().equals("")){
        		this.setFechaTarifaFinString((String)fechaFinal.getSubmittedValue());
        		decode = true;
        	}else if(fechaFinal.getValue()!=null && !fechaFinal.getValue().toString().equals("")){
        		this.setFechaTarifaFinString(fechaFinal.getValue().toString());
        	}
        	if(decode)
        		dateTarifaString2Date(this.fechaTarifaInicioString, this.fechaTarifaFinString);
	        if(nombreTarifaNewUpdate.getSubmittedValue()!=null && !nombreTarifaNewUpdate.getSubmittedValue().toString().equals(""))
	        	this.setNombreTarifaNewUpdate((String)nombreTarifaNewUpdate.getSubmittedValue());
        	else if(nombreTarifaNewUpdate.getValue()!=null && !nombreTarifaNewUpdate.getValue().toString().equals(""))
        		this.setNombreTarifaNewUpdate(nombreTarifaNewUpdate.getValue().toString());
	        if(selectPublicacionesTarifaList.getSubmittedValue()!=null && !selectPublicacionesTarifaList.getSubmittedValue().toString().equals(""))
	        	this.setPublicacionTarifa((String)selectPublicacionesTarifaList.getSubmittedValue());
        	else if(selectPublicacionesTarifaList.getValue()!=null && !selectPublicacionesTarifaList.getValue().toString().equals(""))
        		this.setPublicacionTarifa(selectPublicacionesTarifaList.getValue().toString());
	        if(selectPublicacionesDivisaList.getSubmittedValue()!=null && !selectPublicacionesDivisaList.getSubmittedValue().toString().equals(""))
	        	this.setIdDivisa(Integer.parseInt(selectPublicacionesDivisaList.getSubmittedValue().toString()));
        	else if(selectPublicacionesDivisaList.getValue()!=null && !selectPublicacionesDivisaList.getValue().toString().equals(""))
        		this.setIdDivisa(Integer.parseInt(selectPublicacionesDivisaList.getValue().toString()));
	        if(radioStatus.getSubmittedValue()!=null && !radioStatus.getSubmittedValue().toString().equals(""))
	        	this.setEstatus(Integer.parseInt(radioStatus.getSubmittedValue().toString()));
        	else if(radioStatus.getValue()!=null && !radioStatus.getValue().toString().equals(""))
        		this.setEstatus(Integer.parseInt(radioStatus.getValue().toString()));
	        if(costoTotalDivisa.getSubmittedValue()!=null && !costoTotalDivisa.getSubmittedValue().toString().equals(""))
	        	this.setCostoTotalDivisa((String)costoTotalDivisa.getSubmittedValue());
        	else if(costoTotalDivisa.getValue()!=null && !costoTotalDivisa.getValue().toString().equals(""))
        		this.setCostoTotalDivisa((String)costoTotalDivisa.getValue());
	       
	        UIInput copiarTarifaHidden = (UIInput)form.findComponent("copiarTarifaHidden");
	        this.setIdTarifaCopiar(Integer.parseInt(copiarTarifaHidden.getSubmittedValue().toString()));
        }catch(Exception e){
        	System.err.println(e);
        }
        lsTarifa = mb.obtenerDetallesTarifa(this.idPublicacion, this.idTarifa);
        if(lsTarifa!=null && !lsTarifa.isEmpty()){
			if(this.fechaTarifaInicioString==null || this.fechaTarifaFinString==null)
				dateTarifaString2Date(lsTarifa.get(0).getFechaTarifaInicioDate().toString(), lsTarifa.get(0).getFechaTarifaInicioDate().toString());
        }
        System.out.println("--> 3 "+this.fechaTarifaInicioString);
        System.out.println("--> 3 "+this.publicacionTarifa);
        System.out.println("--> 3 "+this.nombreTarifaNewUpdate);
        if(this.respuestaTarifaNewUpdate.equals(""))
	        this.setRespuestaTarifaNewUpdate(mb.agregarActualizarTarifa(0, this.fechaTarifaInicioString, this.fechaTarifaFinString, this.nombreTarifaNewUpdate,
	        		this.getPublicacionTarifa(), this.idDivisa, this.estatus, this.costoTotalDivisa, this.idTarifaCopiar, getIdUsuario(), lsTarifa));
        if(this.respuestaTarifaNewUpdate!=null && !this.respuestaTarifaNewUpdate.equals(""))
        	decodeRespuestaTarifa(this.respuestaTarifaNewUpdate);
        selectTar.setSubmittedValue(this.idTarifa);
        setFechaSlave(event);
    	System.out.println("<-- PedidoBBean.setTarifa() ");
    }
    
    public void updateTarifa(ActionEvent event) throws Exception {
    	System.out.println("--> PedidoBBean.updateTarifa() ");
    	PedidoMBean mb = new PedidoMBean();
    	List<PedidoBBean> lsTarifa = null;
    	this.setRespuestaTarifaNewUpdate("");
    	FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
        UISelectOne selectPublicacionesList = (UISelectOne)form.findComponent("publicacionesList");
        decodePublicacion((String)selectPublicacionesList.getSubmittedValue());
        UISelectOne selectTar = (UISelectOne)form.findComponent("tarifasList");
        boolean decode = false;
        try{
        	this.setIdTarifa(Integer.parseInt(selectTar.getSubmittedValue().toString()));
        	UIInput fechaInicial = (UIInput)form.findComponent("fInicioTarifaHidden");
        	UIInput fechaFinal = (UIInput)form.findComponent("fFinTarifaHidden");
        	UIInput nombreTarifaNewUpdate = (UIInput)form.findComponent("nombreTarifaHidden");
        	UIInput selectPublicacionesTarifaList = (UIInput)form.findComponent("publicacionTarifaHidden");
        	UIInput selectPublicacionesDivisaList = (UIInput)form.findComponent("publicacionDivisaHidden");
        	UIInput radioStatus = (UIInput)form.findComponent("radioStatusHidden");
        	UIInput costoTotalDivisa = (UIInput)form.findComponent("costoTotalDivisaHidden");
        	System.out.println("////////////////////////////////////////////////////////////////////////");
        	System.out.println("	fechaInicial		"+fechaInicial.getSubmittedValue());
        	System.out.println("	fechaInicial		"+fechaInicial.getValue());
        	System.out.println("	fechaFinal			"+fechaFinal.getSubmittedValue());
        	System.out.println("	fechaFinal			"+fechaFinal.getValue());
        	System.out.println("	nombreTarifaNewUpdate			"+nombreTarifaNewUpdate.getSubmittedValue());
        	System.out.println("	nombreTarifaNewUpdate			"+nombreTarifaNewUpdate.getValue());
        	System.out.println("	selectPublicacionesTarifaList			"+selectPublicacionesTarifaList.getSubmittedValue());
        	System.out.println("	selectPublicacionesTarifaList			"+selectPublicacionesTarifaList.getValue());
        	System.out.println("////////////////////////////////////////////////////////////////////////");
        	if(fechaInicial.getSubmittedValue()!=null && !fechaInicial.getSubmittedValue().toString().equals("")){
        		this.setFechaTarifaInicioString((String)fechaInicial.getSubmittedValue());
        		decode = true;
        	}else if(fechaInicial.getValue()!=null && !fechaInicial.getValue().toString().equals("")){
        		this.setFechaTarifaInicioString(fechaInicial.getValue().toString());
        	}
        	if(fechaFinal.getSubmittedValue()!=null && !fechaFinal.getSubmittedValue().toString().equals("")){
        		this.setFechaTarifaFinString((String)fechaFinal.getSubmittedValue());
        		decode = true;
        	}else if(fechaFinal.getValue()!=null && !fechaFinal.getValue().toString().equals("")){
        		this.setFechaTarifaFinString(fechaFinal.getValue().toString());
        	}
        	if(decode)
        		dateTarifaString2Date(this.fechaTarifaInicioString, this.fechaTarifaFinString);
	        if(nombreTarifaNewUpdate.getSubmittedValue()!=null && !nombreTarifaNewUpdate.getSubmittedValue().toString().equals(""))
	        	this.setNombreTarifaNewUpdate((String)nombreTarifaNewUpdate.getSubmittedValue());
        	else if(nombreTarifaNewUpdate.getValue()!=null && !nombreTarifaNewUpdate.getValue().toString().equals(""))
        		this.setNombreTarifaNewUpdate(nombreTarifaNewUpdate.getValue().toString());
	        if(selectPublicacionesTarifaList.getSubmittedValue()!=null && !selectPublicacionesTarifaList.getSubmittedValue().toString().equals(""))
	        	this.setPublicacionTarifa((String)selectPublicacionesTarifaList.getSubmittedValue());
        	else if(selectPublicacionesTarifaList.getValue()!=null && !selectPublicacionesTarifaList.getValue().toString().equals(""))
        		this.setPublicacionTarifa(selectPublicacionesTarifaList.getValue().toString());
	        if(selectPublicacionesDivisaList.getSubmittedValue()!=null && !selectPublicacionesDivisaList.getSubmittedValue().toString().equals(""))
	        	this.setIdDivisa(Integer.parseInt(selectPublicacionesDivisaList.getSubmittedValue().toString()));
        	else if(selectPublicacionesDivisaList.getValue()!=null && !selectPublicacionesDivisaList.getValue().toString().equals(""))
        		this.setIdDivisa(Integer.parseInt(selectPublicacionesDivisaList.getValue().toString()));
	        if(radioStatus.getSubmittedValue()!=null && !radioStatus.getSubmittedValue().toString().equals(""))
	        	this.setEstatus(Integer.parseInt(radioStatus.getSubmittedValue().toString()));
        	else if(radioStatus.getValue()!=null && !radioStatus.getValue().toString().equals(""))
        		this.setEstatus(Integer.parseInt(radioStatus.getValue().toString()));
	        if(costoTotalDivisa.getSubmittedValue()!=null && !costoTotalDivisa.getSubmittedValue().toString().equals(""))
	        	this.setCostoTotalDivisa((String)costoTotalDivisa.getSubmittedValue());
        	else if(costoTotalDivisa.getValue()!=null && !costoTotalDivisa.getValue().toString().equals(""))
        		this.setCostoTotalDivisa((String)costoTotalDivisa.getValue());
	       
	        UIInput copiarTarifaHidden = (UIInput)form.findComponent("copiarTarifaHidden");
	        this.setIdTarifaCopiar(Integer.parseInt(copiarTarifaHidden.getSubmittedValue().toString()));
        }catch(Exception e){
        	System.err.println(e);
        }
        lsTarifa = mb.obtenerDetallesTarifa(this.idPublicacion, this.idTarifa);
        if(lsTarifa!=null && !lsTarifa.isEmpty()){
			if(this.fechaTarifaInicioString==null || this.fechaTarifaFinString==null)
				dateTarifaString2Date(lsTarifa.get(0).getFechaTarifaInicioDate().toString(), lsTarifa.get(0).getFechaTarifaInicioDate().toString());
        }
        if(this.respuestaTarifaNewUpdate.equals(""))
	        this.setRespuestaTarifaNewUpdate(mb.agregarActualizarTarifa(this.idTarifa, this.fechaTarifaInicioString, this.fechaTarifaFinString, this.nombreTarifaNewUpdate,
	        		this.publicacionTarifa, this.idDivisa, this.estatus, this.costoTotalDivisa, this.idTarifaCopiar, getIdUsuario(), lsTarifa));
        if(this.respuestaTarifaNewUpdate!=null && !this.respuestaTarifaNewUpdate.equals(""))
        	decodeRespuestaTarifa(this.respuestaTarifaNewUpdate);
        selectTar.setSubmittedValue(this.idTarifa);
        setFechaSlave(event);
    	System.out.println("<-- PedidoBBean.updateTarifa() ");
    }
    
    public void setFechaTarifaInicio(ActionEvent event) throws Exception {
    	System.out.println("############################> PedidoBBean.setFechaTarifaInicio() ");
    	FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
    	UIInput fechaInicial = (UIInput)form.findComponent("fInicioTarifaHidden");
    	fechaInicial.setValue(fechaInicial.getSubmittedValue());
    	fechaInicial.setSubmittedValue(fechaInicial.getSubmittedValue());
    }
    
    public void setFechaTarifaFin(ActionEvent event) throws Exception {
    	System.out.println("############################> PedidoBBean.setFechaTarifaFin() ");
    	FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
    	UIInput fechaFinal = (UIInput)form.findComponent("fFinTarifaHidden");
    	fechaFinal.setValue(fechaFinal.getSubmittedValue());
    	fechaFinal.setSubmittedValue(fechaFinal.getSubmittedValue());
    }
    
    public void setPublicacionTarifaSlave(ActionEvent event) throws Exception {
    	System.out.println("--> PedidoBBean.setPublicacionTarifaSlave() ");
    	PedidoMBean mb = new PedidoMBean();
    	selectItemsCopiarTarifa = new ArrayList<SelectItem>();
    	List<PedidoBBean> lsTarifasCopiar = new ArrayList<PedidoBBean>();
    	FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
    	UIInput selectPublicacionesTarifaList = (UIInput)form.findComponent("publicacionTarifaHidden");
    	decodePublicacion((String)selectPublicacionesTarifaList.getSubmittedValue());
    	System.out.println("	this.idPublicacion	-->  "+this.idPublicacion);
    	System.out.println("	getIdUsuario()		-->  "+getIdUsuario());
    	lsTarifasCopiar = mb.obtenerTarifasCopiar(this.idPublicacion, getIdUsuario());
    	if(lsTarifasCopiar.size()==0) selectItemsDivisa.add(new SelectItem("-1", "-sin tarifas-"));
		for(int i=0; i<lsTarifasCopiar.size(); i++)
			selectItemsCopiarTarifa.add(new SelectItem(lsTarifasCopiar.get(i).getIdTarifaCopiar(), lsTarifasCopiar.get(i).getNombreTarifa()));
    	System.out.println("<-- PedidoBBean.setPublicacionTarifaSlave() ");
    }
    
    public void setCopiarTarifaSlave(ActionEvent event) throws Exception {
    	System.out.println("--> PedidoBBean.setCopiarTarifaSlave() ");
    	selectItemsDivisa = new ArrayList<SelectItem>();
    	List<PedidoBBean> lsDivisas = null;
    	PedidoMBean mb = new PedidoMBean();
    	List<PedidoBBean> lsTarifaCopiar = new ArrayList<PedidoBBean>();
    	FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
    	UIInput publicacionTarifaHidden = (UIInput)form.findComponent("publicacionTarifaHidden");
    	decodePublicacion((String)publicacionTarifaHidden.getSubmittedValue());
    	UIInput copiarTarifaHidden = (UIInput)form.findComponent("copiarTarifaHidden");
    	this.setIdTarifaCopiar(Integer.parseInt(copiarTarifaHidden.getSubmittedValue().toString()));
    	
    	UIInput fechaInicialHidden = (UIInput)form.findComponent("fInicioTarifaHidden");
    	UIInput fechaFinalHidden = (UIInput)form.findComponent("fFinTarifaHidden");
    	UIInput nombreTarifaHidden = (UIInput)form.findComponent("nombreTarifaHidden");
    	UIInput publicacionDivisaHidden = (UIInput)form.findComponent("publicacionDivisaHidden");
    	UIInput radioStatusHidden = (UIInput)form.findComponent("radioStatusHidden");
    	UIInput costoTotalDivisaHidden = (UIInput)form.findComponent("costoTotalDivisaHidden");
    	
    	UICalendar fechaInicial = (UICalendar)form.findComponent("fechaTarifaInicio");
        UICalendar fechaFinal = (UICalendar)form.findComponent("fechaTarifaFin");
        UIInput nombreTarifaNewUpdate = (UIInput)form.findComponent("tarifaNewUpdateField");
        UISelectOne selectPublicacionesTarifaList = (UISelectOne)form.findComponent("publicacionesTarifaList");
        UISelectOne selectPublicacionesDivisaList = (UISelectOne)form.findComponent("publicacionesDivisaList");
        UIInput radioStatus = (UIInput)form.findComponent("radioStatusTarifa");
        UIInput costoTotalDivisa = (UIInput)form.findComponent("costoTotalDivisa");
        HtmlAjaxCommandLink botonActualizarTarifa = (HtmlAjaxCommandLink)form.findComponent("botonActualizarTarifa");

    	System.out.println("	this.idPublicacion	-->  "+this.idPublicacion);
    	System.out.println("	this.idTarifaCopiar	-->  "+this.idTarifaCopiar);
        lsTarifaCopiar = mb.obtenerDatosTarifaPorCopiar(this.idPublicacion, this.idTarifaCopiar);
        lsDivisas = mb.obtenerDivisas();
        
        if(lsTarifaCopiar!=null && !lsTarifaCopiar.isEmpty()){
        	fechaInicialHidden.setValue(lsTarifaCopiar.get(0).getFechaTarifaInicioDate());
        	fechaInicialHidden.setSubmittedValue(lsTarifaCopiar.get(0).getFechaTarifaInicioDate());
        	fechaInicial.setSubmittedValue(lsTarifaCopiar.get(0).getFechaTarifaInicioDate());
        	fechaFinalHidden.setValue(lsTarifaCopiar.get(0).getFechaTarifaFinDate());
        	fechaFinalHidden.setSubmittedValue(lsTarifaCopiar.get(0).getFechaTarifaFinDate());
        	fechaFinal.setSubmittedValue(lsTarifaCopiar.get(0).getFechaTarifaFinDate());
        	nombreTarifaHidden.setValue(lsTarifaCopiar.get(0).getNombreTarifaNewUpdate());
        	nombreTarifaNewUpdate.setSubmittedValue(lsTarifaCopiar.get(0).getNombreTarifaNewUpdate());
        	publicacionTarifaHidden.setValue((String)publicacionTarifaHidden.getSubmittedValue());
        	selectPublicacionesTarifaList.setSubmittedValue(lsTarifaCopiar.get(0).getPublicacionTarifa());
        	publicacionDivisaHidden.setValue(lsTarifaCopiar.get(0).getIdDivisa());
        	selectPublicacionesDivisaList.setSubmittedValue(lsTarifaCopiar.get(0).getIdDivisa());
        	radioStatusHidden.setValue(lsTarifaCopiar.get(0).getEstatus());
        	radioStatus.setSubmittedValue(lsTarifaCopiar.get(0).getEstatus());
        	costoTotalDivisaHidden.setValue(lsTarifaCopiar.get(0).getCostoTotalDivisa());
        	costoTotalDivisa.setSubmittedValue(lsTarifaCopiar.get(0).getCostoTotalDivisa());
        	copiarTarifaHidden.setValue(this.idTarifaCopiar);
        	botonActualizarTarifa.setDisabled(true);
        	botonActualizarTarifa.setStyleClass("botonActualizarOff");
        }
        
        if(lsDivisas.size()==0) selectItemsDivisa.add(new SelectItem("-1", "-sin divisa-"));
    	for(int i=0; i<lsDivisas.size(); i++)
    		selectItemsDivisa.add(new SelectItem(lsDivisas.get(i).getIdDivisa(), lsDivisas.get(i).getNombreDivisa()));
    	
    	System.out.println("<-- PedidoBBean.setCopiarTarifaSlave() ");
    }
    
    public void setTipoValoracionSlave(ActionEvent event) throws Exception {
    	System.out.println("--> PedidoBBean.setTipoValoracionSlave() "+this.tipoValoracion);
    	setDatos();
    	FacesContext context = FacesContext.getCurrentInstance();
        selectItemsSlaveFormasPago = new ArrayList<SelectItem>();
        selectItemsSlaveTiposVenta = new ArrayList<SelectItem>();
        List<PedidoBBean> listaFormasPago = new ArrayList<PedidoBBean>();
    	List<PedidoBBean> listaTiposVenta = new ArrayList<PedidoBBean>();
        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
    	UIInput tipoValoracionHidden = (UIInput)form.findComponent("tipoValoracionHidden");
    	PedidoMBean mb = new PedidoMBean();
    	System.out.println("		--> tipoValoracionHidden) "+tipoValoracionHidden.getSubmittedValue());
    	if(this.idPublicacion!=-1 && this.idPublicacion!=0){
	    	this.setTipoValoracion((String)tipoValoracionHidden.getSubmittedValue());
	    	if(this.tipoValoracion.equals("especial")){
	    		this.setValorEspecialDisabled(false);
	    		this.setValorEspecialStyle("visibility: visible;");
	    	}else if (this.tipoValoracion.equals("valorar")){
	    		this.setValorEspecialDisabled(true);
	    		this.setValorEspecialStyle("visibility: hidden; width: 0px; height: 0px;");
	    	}else if (this.tipoValoracion.equals("normal")){
	    		this.setValorEspecialDisabled(true);
	    		this.setValorEspecialStyle("visibility: hidden; width: 0px; height: 0px;");
	    	}
	    	System.out.println("		--> this.valorEspecial "+this.valorEspecial);
	        System.out.println(this.publicacion+" "+this.idRegion+" "+this.fechaPublicacionString+" "+this.idTarifa+" "
	        		+this.formato+" "+this.altoFormato+" "+this.anchoFormato+" "+this.tipoValoracion+" "+this.valorEspecial);
	        if(this.publicacion!=null && !this.publicacion.equals("") && this.fechaPublicacionString!=null 
	        		&& !this.fechaPublicacionString.equals("")){
	        	if(this.idRegion!=0 && this.idRegion!=-1 && this.idTarifa!=0 && this.idTarifa!=-1)
	        		mb.obtenerDetallesRegion(this.idPublicacion, this.idRegion, this.fechaPublicacionString, this.idTarifa, 
	    	    			this.idFormato, this.altoFormato, this.anchoFormato, this.tipoFormato, this.tipoValoracion, this.valorEspecial);
		        if(this.idCliente!=0 && this.idConvenio!=0 && this.idConvenio!=-1)
		        	mb.obtenerDetallesConvenio(this.idCliente, this.idPublicacion, this.idConvenio, this.fechaPublicacionString, 
		        			this.valorEspecial, this.tipoValoracion, this.idTarifa, this.idRegion, this.idFormato, this.tipoFormato, this.altoFormato, 
	    					this.anchoFormato);
	        }
            if(this.idConvenio!=0 && this.idConvenio!=-1){
            	listaFormasPago = mb.obtenerTipoVentaFormaPago(this.idConvenio, this.idFormaPago);
            	listaTiposVenta = mb.obtenerTiposVentaFormaPago(this.idFormaPago);
            	if(listaFormasPago.size()==0) selectItemsSlaveFormasPago.add(new SelectItem("-1", "-sin formas pago-"));
        		if(listaFormasPago.size()>1) selectItemsSlaveFormasPago.add(new SelectItem("0", "Seleccione..."));
        		if(listaTiposVenta.size()==0) selectItemsSlaveTiposVenta.add(new SelectItem("-1", "-sin tipos venta-"));
        		if(listaTiposVenta.size()>1) selectItemsSlaveTiposVenta.add(new SelectItem("0", "Seleccione..."));
        		for(int i=0; i<listaFormasPago.size(); i++)
        				selectItemsSlaveFormasPago.add(new SelectItem(listaFormasPago.get(i).getIdFormaPago(), 
        						listaFormasPago.get(i).getNombreFormaPago()));
        		for(int i=0; i<listaTiposVenta.size(); i++)
    					selectItemsSlaveTiposVenta.add(new SelectItem(listaTiposVenta.get(i).getIdTipoVenta(), 
    							listaTiposVenta.get(i).getNombreTipoVenta()));
        		if(this.idCliente!=0 && this.idPublicacion!=0 && this.idPublicacion!=-1 
        				&& this.idConvenio!=0 && this.idConvenio!=-1 && this.fechaPublicacionString!=null 
        				&& !this.fechaPublicacionString.equals("")){
        			mb.obtenerDetallesConvenio(this.idCliente, this.idPublicacion, this.idConvenio, this.fechaPublicacionString, 
        					this.valorEspecial, this.tipoValoracion, this.idTarifa, this.idRegion, this.idFormato, this.tipoFormato, this.altoFormato, 
        					this.anchoFormato);
        		}
            }else{
    			mb.obtenerMontoRestanteConvenio(this.idCliente, this.idPublicacion, this.idConvenio, this.fechaPublicacionString, 
    					this.valorEspecial, this.tipoValoracion, this.idTarifa, this.idRegion, this.idFormato, this.tipoFormato, this.altoFormato, 
    					this.anchoFormato, null, null);
            	listaFormasPago = mb.obtenerFormasPago();
            	listaTiposVenta = mb.obtenerTiposVenta();
            	selectItemsSlaveFormasPago.add(new SelectItem("0", "Seleccione..."));
            	selectItemsSlaveTiposVenta.add(new SelectItem("0", "Seleccione..."));
            	System.out.println("--> PedidoBBean.setTipoValoracionSlave() listaFormasPago: "+listaFormasPago.size());
            	for(int i=0; i<listaFormasPago.size(); i++)
        			selectItemsSlaveFormasPago.add(new SelectItem(listaFormasPago.get(i).getIdFormaPago(), 
        					listaFormasPago.get(i).getNombreFormaPago()));
            	for(int i=0; i<listaTiposVenta.size(); i++)
        			selectItemsSlaveTiposVenta.add(new SelectItem(listaTiposVenta.get(i).getIdTipoVenta(), 
        					listaTiposVenta.get(i).getNombreTipoVenta()));
            }
	        if(this.idPublicacion!=-1)
	        	setFormatoMedidasSlave(event);
    	}
    	System.out.println("<-- PedidoBBean.setTipoValoracionSlave() "+this.tipoValoracion);
    }
    
    public Boolean checkRequestType(String tipoValoracion){
    	return (this.tipoValoracion.equalsIgnoreCase(tipoValoracion)) ? true : false;
    }
    
    public void getProductoNewUpdate(ActionEvent event) throws Exception {
    	System.out.println("--> PedidoBBean.getProductoNewUpdate()");
    	this.setRespuestaProductoNewUpdate("");
    	FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
        HtmlInputText selectCli = (HtmlInputText)form.findComponent("clientesSelect");
        decodeCliente((String)selectCli.getSubmittedValue());
        UISelectOne selectPro = (UISelectOne)form.findComponent("productosList");
        this.setIdProducto(Integer.parseInt(selectPro.getSubmittedValue().toString()));
        UIInput nombreProductoNewUpdate = (UIInput)form.findComponent("productoNewUpdateField");
        if(this.idCliente!=0 && this.idProducto!=0 && this.idProducto!=-1){
        	PedidoMBean mb = new PedidoMBean();
        	this.setNombreProductoNewUpdate(mb.obtenerNombreProducto(this.idCliente, this.idProducto));
            nombreProductoNewUpdate.setSubmittedValue(this.getNombreProductoNewUpdate());
        }else
        	nombreProductoNewUpdate.setSubmittedValue("");
    	System.out.println("<-- PedidoBBean.getProductoNewUpdate()");
    }
    
    public void setProducto(ActionEvent event) throws Exception {
    	System.out.println("--> PedidoBBean.setProducto()");
    	FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
        UISelectOne selectPro = (UISelectOne)form.findComponent("productosList");
        HtmlInputText selectCli = (HtmlInputText)form.findComponent("clientesSelect");
        decodeCliente((String)selectCli.getSubmittedValue());
    	UIInput nombreProductoNewUpdate = (UIInput)form.findComponent("nombreProductoHidden");
    	this.setNombreProductoNewUpdate((String)nombreProductoNewUpdate.getSubmittedValue());
    	PedidoMBean mb = new PedidoMBean();
    	if(this.nombreProductoNewUpdate!=null && !this.nombreProductoNewUpdate.equals(""))
    		this.setRespuestaProductoNewUpdate(mb.agregarActualizarProducto(this.idCliente, 0, this.nombreProductoNewUpdate, getIdUsuario()));
    	else
    		this.setRespuestaProductoNewUpdate("Capture el nombre del nuevo producto.");
    	if(this.respuestaProductoNewUpdate!=null && !this.respuestaProductoNewUpdate.equals(""))
    		decodeRespuestaProducto(this.respuestaProductoNewUpdate);
    	selectPro.setSubmittedValue(this.idProducto);
    	setClienteSlave(event);
    	System.out.println("<-- PedidoBBean.setProducto()");
    }
    
	public void updateProducto(ActionEvent event) throws Exception {
    	System.out.println("--> PedidoBBean.updateProducto()");
    	FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
        HtmlInputText selectCli = (HtmlInputText)form.findComponent("clientesSelect");
        decodeCliente((String)selectCli.getSubmittedValue());
        UISelectOne selectPro = (UISelectOne)form.findComponent("productosList");
        this.setIdProducto(Integer.parseInt(selectPro.getSubmittedValue().toString()));
        UIInput nombreProductoNewUpdate = (UIInput)form.findComponent("nombreProductoHidden");
    	this.setNombreProductoNewUpdate((String)nombreProductoNewUpdate.getSubmittedValue());
    	PedidoMBean mb = new PedidoMBean();
    	if(this.idProducto!=0 && this.idProducto!=-1)
    		this.setRespuestaProductoNewUpdate(mb.agregarActualizarProducto(this.idCliente, this.idProducto, this.nombreProductoNewUpdate, getIdUsuario()));
    	else
    		this.setRespuestaProductoNewUpdate("Para actualizar debe primero seleccionar un producto, si no hay productos capture uno nuevo.");
    	if(this.respuestaProductoNewUpdate!=null && !this.respuestaProductoNewUpdate.equals(""))
    		decodeRespuestaProducto(this.respuestaProductoNewUpdate);
    	setClienteSlave(event);
    	System.out.println("<-- PedidoBBean.updateProducto()");
    }
    
    public void getVersionNewUpdate(ActionEvent event) throws Exception {
    	System.out.println("--> PedidoBBean.getVersionNewUpdate()");
    	FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
        UISelectOne selectPro = (UISelectOne)form.findComponent("productosList");
        this.setIdProducto(Integer.parseInt(selectPro.getSubmittedValue().toString()));
        UISelectOne selectVer = (UISelectOne)form.findComponent("versionesList");
        this.setIdVersion(Integer.parseInt(selectVer.getSubmittedValue().toString()));
        UIInput nombreVersionNewUpdate = (UIInput)form.findComponent("versionNewUpdateField");
        if(this.idProducto!=0 && this.idProducto!=-1 && this.idVersion!=0 && this.idVersion!=-1){
        	PedidoMBean mb = new PedidoMBean();
        	this.setNombreVersionNewUpdate(mb.obtenerNombreVersion(this.idProducto, this.idVersion));
        	nombreVersionNewUpdate.setSubmittedValue(this.getNombreVersionNewUpdate());
        }else
        	nombreVersionNewUpdate.setSubmittedValue("");
    	System.out.println("<-- PedidoBBean.getVersionNewUpdate()");
    }
    
    public void setVersion(ActionEvent event) throws Exception {
    	System.out.println("--> PedidoBBean.setVersion()");
    	FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
        UISelectOne selectVer = (UISelectOne)form.findComponent("versionesList");
        UISelectOne selectPro = (UISelectOne)form.findComponent("productosList");
        this.setIdProducto(Integer.parseInt(selectPro.getSubmittedValue().toString()));
    	UIInput nombreVersionNewUpdate = (UIInput)form.findComponent("nombreVersionHidden");
    	this.setNombreVersionNewUpdate((String)nombreVersionNewUpdate.getSubmittedValue());
    	PedidoMBean mb = new PedidoMBean();
    	if(this.nombreVersionNewUpdate!=null && !this.nombreVersionNewUpdate.equals(""))
    		this.setRespuestaVersionNewUpdate(mb.agregarActualizarVersion(this.idProducto, 0, this.nombreVersionNewUpdate, getIdUsuario()));
    	else
    		this.setRespuestaVersionNewUpdate("Capture el nombre de la nueva version.");
    	if(this.respuestaVersionNewUpdate!=null && !this.respuestaVersionNewUpdate.equals(""))
    		decodeRespuestaVersion(this.respuestaVersionNewUpdate);
    	selectVer.setSubmittedValue(this.idVersion);
    	setProductoSlave(event);
    	System.out.println("<-- PedidoBBean.setVersion()");
    }
    
    public void updateVersion(ActionEvent event) throws Exception {
    	System.out.println("--> PedidoBBean.updateVersion()");
    	FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
        UISelectOne selectPro = (UISelectOne)form.findComponent("productosList");
        this.setIdProducto(Integer.parseInt(selectPro.getSubmittedValue().toString()));
        UISelectOne selectVer = (UISelectOne)form.findComponent("versionesList");
        this.setIdVersion(Integer.parseInt(selectVer.getSubmittedValue().toString()));
    	UIInput nombreVersionNewUpdate = (UIInput)form.findComponent("nombreVersionHidden");
    	this.setNombreVersionNewUpdate((String)nombreVersionNewUpdate.getSubmittedValue());
    	PedidoMBean mb = new PedidoMBean();
    	if(this.idVersion!=0 && this.idVersion!=-1)
    		this.setRespuestaVersionNewUpdate(mb.agregarActualizarVersion(this.idProducto, this.idVersion, this.nombreVersionNewUpdate, getIdUsuario()));
    	else
    		this.setRespuestaVersionNewUpdate("Para actualizar debe primero seleccionar una versin, si no hay versiones capture una nueva.");
    	if(this.respuestaVersionNewUpdate!=null && !this.respuestaVersionNewUpdate.equals(""))
    		decodeRespuestaVersion(this.respuestaVersionNewUpdate);
    	setProductoSlave(event);
    	System.out.println("<-- PedidoBBean.updateVersion()");
    }
    
    public void getEventoNewUpdate(ActionEvent event) throws Exception {
    	System.out.println("--> PedidoBBean.getEventoNewUpdate()");
    	this.setRespuestaEventoNewUpdate("");
    	this.setPublicacionesEvento(null);
    	//setDatos();
    	FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
        UISelectOne selectPublicacionesList = (UISelectOne)form.findComponent("publicacionesList");
        decodePublicacion((String)selectPublicacionesList.getSubmittedValue());
        UICalendar fechaPublicacion = (UICalendar)form.findComponent("fechaPublicacion");
        dateString2Date((String)fechaPublicacion.getSubmittedValue());
        UISelectOne selectEve = (UISelectOne)form.findComponent("eventosList");
        this.setIdEvento(Integer.parseInt(selectEve.getSubmittedValue().toString()));
        UICalendar fechaEventoInicio = (UICalendar)form.findComponent("fechaEventoInicio");
        UICalendar fechaEventoFin = (UICalendar)form.findComponent("fechaEventoFin");
        UIInput nombreEventoNewUpdate = (UIInput)form.findComponent("eventoNewUpdateField");
        UIInput descripcionEvento = (UIInput)form.findComponent("descripcionEvento");
        UIInput idEventoPublicacionHidden = (UIInput)form.findComponent("idsPublicacionesHidden");
        UISelectMany idEventoPublicacionNewUpdateField = (UISelectMany)form.findComponent("idEventoPublicacionNewUpdateField");
        UIInput nombreEventoHidden = (UIInput)form.findComponent("nombreEventoHidden");
        UIInput descripcionEventoHidden = (UIInput)form.findComponent("descripcionEventoHidden");
        UIInput fInicioEventoHidden = (UIInput)form.findComponent("fInicioEventoHidden");
    	UIInput fFinEventoHidden = (UIInput)form.findComponent("fFinEventoHidden");
    	UIInput idsPublicacionesHidden = (UIInput)form.findComponent("idsPublicacionesHidden");
    	String idsPublicacionEvento="";
        List<PedidoBBean> lsEventoPublicaciones = null;
        PedidoMBean mb = new PedidoMBean();
    	PedidoBBean bean = new PedidoBBean();
    	String arrayIdPubEve[] = null;
        if(this.idPublicacion!=0 && this.fechaPublicacionString!=null 
        		&& !this.fechaPublicacionString.equals("") && this.idEvento!=0 && this.idEvento!=-1){
        	lsEventoPublicaciones = mb.obtenerDetallesEvento(this.idPublicacion, this.fechaPublicacionString, this.idEvento, bean);
        	fechaEventoInicio.setSubmittedValue(bean.getFechaEventoInicioDate());
        	fInicioEventoHidden.setValue(bean.getFechaEventoInicioDate());
        	fechaEventoFin.setSubmittedValue(bean.getFechaEventoFinDate());
        	fFinEventoHidden.setValue(bean.getFechaEventoFinDate());
        	nombreEventoNewUpdate.setSubmittedValue(bean.getNombreEvento());
        	nombreEventoHidden.setValue(bean.getNombreEvento());
        	descripcionEvento.setSubmittedValue(bean.getDescripcionEvento());
        	descripcionEventoHidden.setValue(bean.getDescripcionEvento());
        	if(lsEventoPublicaciones != null && !lsEventoPublicaciones.isEmpty()){
        		arrayIdPubEve = new String[lsEventoPublicaciones.size()];
            	for(int i=0; i<lsEventoPublicaciones.size(); i++){
            		arrayIdPubEve[i] = lsEventoPublicaciones.get(i).getIdMultiPublicacionModal().toString();
            		idsPublicacionEvento = idsPublicacionEvento+"^"
            		+lsEventoPublicaciones.get(i).getIdMultiPublicacionModal().toString();
            	}
            	this.setPublicacionesEvento(arrayIdPubEve);
            	idEventoPublicacionNewUpdateField.setSubmittedValue(this.getPublicacionesEvento());
            	idsPublicacionesHidden.setValue(idsPublicacionEvento);
        	}
        }else{
        	fechaEventoInicio.setSubmittedValue(null);
        	fechaEventoFin.setSubmittedValue(null);
        	nombreEventoNewUpdate.setSubmittedValue(null);
        	descripcionEvento.setSubmittedValue(null);
        	idEventoPublicacionHidden.setSubmittedValue(null);
        	arrayIdPubEve = new String[1];
        	arrayIdPubEve[0] = this.publicacion;
        	this.setPublicacionesEvento(arrayIdPubEve);
        	idEventoPublicacionNewUpdateField.setSubmittedValue(this.getPublicacionesEvento());
        }
    	System.out.println("<-- PedidoBBean.getEventoNewUpdate() "+this.getPublicacionesEvento());
    }
    
    public void setEvento(ActionEvent event) throws Exception {
    	System.out.println("--> PedidoBBean.setEvento()");
    	this.setRespuestaEventoNewUpdate("");
    	FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
        UISelectOne selectEve = (UISelectOne)form.findComponent("eventosList");
        UISelectOne selectPublicacionesList = (UISelectOne)form.findComponent("publicacionesList");
        decodePublicacion((String)selectPublicacionesList.getSubmittedValue());
        UICalendar fechaPublicacion = (UICalendar)form.findComponent("fechaPublicacion");
        dateString2Date((String)fechaPublicacion.getSubmittedValue());
        this.setIdEvento(Integer.parseInt(selectEve.getSubmittedValue().toString()));
        List<PedidoBBean> lsEventoPublicaciones = null;
        PedidoMBean mb = new PedidoMBean();
    	PedidoBBean bean = new PedidoBBean();
    	String idPubEvento="";
    	try{
	        UIInput nombreEventoNewUpdate = (UIInput)form.findComponent("nombreEventoHidden");
	        UIInput descripcionEvento = (UIInput)form.findComponent("descripcionEventoHidden");
	        UIInput fechaEventoInicio = (UIInput)form.findComponent("fInicioEventoHidden");
	    	UIInput fechaEventoFin = (UIInput)form.findComponent("fFinEventoHidden");
	    	UIInput idEventoPublicacionHidden = (UIInput)form.findComponent("idsPublicacionesHidden");
	        if(nombreEventoNewUpdate.getSubmittedValue()!=null
	        		&& !nombreEventoNewUpdate.getSubmittedValue().toString().equals(""))
	        	this.setNombreEventoNewUpdate((String)nombreEventoNewUpdate.getSubmittedValue());
	        else
	        	this.setNombreEventoNewUpdate((String)nombreEventoNewUpdate.getValue());
	    	if(descripcionEvento.getSubmittedValue()!=null 
	    			&& !descripcionEvento.getSubmittedValue().toString().equals(""))
	    		this.setDescripcionEvento((String)descripcionEvento.getSubmittedValue());
	    	else
	    		this.setDescripcionEvento((String)descripcionEvento.getValue());
	    	if(fechaEventoInicio.getSubmittedValue()!=null && fechaEventoFin.getSubmittedValue()!=null
	    			&& !fechaEventoInicio.getSubmittedValue().toString().equals("")
	    			&& !fechaEventoFin.getSubmittedValue().toString().equals(""))
	    		dateEventoString2Date((String)fechaEventoInicio.getSubmittedValue(), (String)fechaEventoFin.getSubmittedValue());
	    	else
	    		dateEventoString2Date((String)fechaEventoInicio.getValue(), (String)fechaEventoFin.getValue());
	    	if(idEventoPublicacionHidden.getSubmittedValue()!=null
	    			&& !idEventoPublicacionHidden.getSubmittedValue().toString().equals(""))
	    		this.setIdsPublicacionesHidden((String)idEventoPublicacionHidden.getSubmittedValue());
	    	else
	    		this.setIdsPublicacionesHidden((String)idEventoPublicacionHidden.getValue());
    	} catch (Exception e){
    		//nada
    	}
    	lsEventoPublicaciones = mb.obtenerDetallesEvento(this.idPublicacion, this.fechaPublicacionString, this.idEvento, bean);
    	if(this.nombreEventoNewUpdate==null || this.nombreEventoNewUpdate.equals(""))
    		this.setNombreEventoNewUpdate(bean.getNombreEvento());
		if(this.descripcionEvento==null || this.descripcionEvento.equals(""))
			this.setDescripcionEvento(bean.getDescripcionEvento());	
		if(this.fechaEventoInicioString==null || this.fechaEventoInicioString.equals(""))
			this.setFechaEventoInicioString(bean.getFechaEventoInicioDate().toString());
		if(this.fechaEventoFinString==null || this.fechaEventoFinString.equals(""))
			this.setFechaEventoFinString(bean.getFechaEventoFinDate().toString());
    	if(this.idsPublicacionesHidden==null || this.idsPublicacionesHidden.equals("")){
        	if(lsEventoPublicaciones != null && !lsEventoPublicaciones.isEmpty()){
            	for(int i=0; i<lsEventoPublicaciones.size(); i++)
            		idPubEvento =  idPubEvento+"^"+lsEventoPublicaciones.get(i).getIdMultiPublicacionModal().toString();
        	}
        	this.setIdsPublicacionesHidden(idPubEvento);
    	}
    	if(this.respuestaEventoNewUpdate.equals("")){ 
	    	if(this.nombreEventoNewUpdate!=null && !this.nombreEventoNewUpdate.equals("")&& this.fechaEventoInicioString!=null 
	    			&& !this.fechaEventoInicioString.equals("") && this.fechaEventoFinString!=null && !this.fechaEventoFinString.equals(""))
	    		this.setRespuestaEventoNewUpdate(mb.agregarActualizarEvento(0, this.nombreEventoNewUpdate, this.descripcionEvento, 
	    				this.fechaEventoInicioString, this.fechaEventoFinString, this.idPublicacion, this.idsPublicacionesHidden, getIdUsuario()));
	    	else
	    		this.setRespuestaEventoNewUpdate("Capture el nombre y periodo de fechas del nuevo evento.");
    	}
    	if(this.respuestaEventoNewUpdate!=null && !this.respuestaEventoNewUpdate.equals(""))
    		decodeRespuestaEvento(this.respuestaEventoNewUpdate);
    	selectEve.setSubmittedValue(this.idEvento);
    	setPublicacionSlave(event);
    	System.out.println("<-- PedidoBBean.setEvento()");
    }
    
    public void updateEvento(ActionEvent event) throws Exception {
    	System.out.println("--> PedidoBBean.updateEvento()");
    	this.setRespuestaEventoNewUpdate("");
    	FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
        List<PedidoBBean> lsEventoPublicaciones = null;
        PedidoMBean mb = new PedidoMBean();
    	PedidoBBean bean = new PedidoBBean();
    	String idPubEvento="";
    	UISelectOne selectEve = (UISelectOne)form.findComponent("eventosList");
    	this.setIdEvento(Integer.parseInt(selectEve.getSubmittedValue().toString()));
        try{
	        UISelectOne selectPublicacionesList = (UISelectOne)form.findComponent("publicacionesList");
	        decodePublicacion((String)selectPublicacionesList.getSubmittedValue());
	        UIInput nombreEventoNewUpdate = (UIInput)form.findComponent("nombreEventoHidden");
	        UIInput descripcionEvento = (UIInput)form.findComponent("descripcionEventoHidden");
	        UIInput fechaEventoInicio = (UIInput)form.findComponent("fInicioEventoHidden");
	    	UIInput fechaEventoFin = (UIInput)form.findComponent("fFinEventoHidden");
	    	UIInput idEventoPublicacionHidden = (UIInput)form.findComponent("idsPublicacionesHidden");
	        if(nombreEventoNewUpdate.getSubmittedValue()!=null
	        		&& !nombreEventoNewUpdate.getSubmittedValue().toString().equals(""))
	        	this.setNombreEventoNewUpdate((String)nombreEventoNewUpdate.getSubmittedValue());
	        else
	        	this.setNombreEventoNewUpdate((String)nombreEventoNewUpdate.getValue());
	    	if(descripcionEvento.getSubmittedValue()!=null 
	    			&& !descripcionEvento.getSubmittedValue().toString().equals(""))
	    		this.setDescripcionEvento((String)descripcionEvento.getSubmittedValue());
	    	else
	    		this.setDescripcionEvento((String)descripcionEvento.getValue());
	    	if(fechaEventoInicio.getSubmittedValue()!=null && fechaEventoFin.getSubmittedValue()!=null
	    			&& !fechaEventoInicio.getSubmittedValue().toString().equals("")
	    			&& !fechaEventoFin.getSubmittedValue().toString().equals(""))
	    		dateEventoString2Date((String)fechaEventoInicio.getSubmittedValue(), (String)fechaEventoFin.getSubmittedValue());
	    	else
	    		dateEventoString2Date((String)fechaEventoInicio.getValue(), (String)fechaEventoFin.getValue());
	    	if(idEventoPublicacionHidden.getSubmittedValue()!=null
	    			&& !idEventoPublicacionHidden.getSubmittedValue().toString().equals(""))
	    		this.setIdsPublicacionesHidden((String)idEventoPublicacionHidden.getSubmittedValue());
	    	else
	    		this.setIdsPublicacionesHidden((String)idEventoPublicacionHidden.getValue());
        }catch(Exception e){
        	//System.out.println("ERROR : "+e+" en PedidoBBean.updateEvento()");
        	this.setRespuestaEventoNewUpdate(e.toString());
        }
        lsEventoPublicaciones = mb.obtenerDetallesEvento(this.idPublicacion, this.fechaPublicacionString, this.idEvento, bean);
    	if(this.nombreEventoNewUpdate==null || this.nombreEventoNewUpdate.equals(""))
    		this.setNombreEventoNewUpdate(bean.getNombreEvento());
		if(this.descripcionEvento==null || this.descripcionEvento.equals(""))
			this.setDescripcionEvento(bean.getDescripcionEvento());	
		if(this.fechaEventoInicioString==null || this.fechaEventoInicioString.equals(""))
			this.setFechaEventoInicioString(bean.getFechaEventoInicioDate().toString());
		if(this.fechaEventoFinString==null || this.fechaEventoFinString.equals(""))
			this.setFechaEventoFinString(bean.getFechaEventoFinDate().toString());
    	if(this.idsPublicacionesHidden==null || this.idsPublicacionesHidden.equals("")){
        	if(lsEventoPublicaciones != null && !lsEventoPublicaciones.isEmpty()){
            	for(int i=0; i<lsEventoPublicaciones.size(); i++)
            		idPubEvento =  idPubEvento+"^"+lsEventoPublicaciones.get(i).getIdMultiPublicacionModal().toString();
        	}
        	this.setIdsPublicacionesHidden(idPubEvento);
    	}
    	if(this.respuestaEventoNewUpdate.equals("")){ 
	    	if(this.nombreEventoNewUpdate!=null && !this.nombreEventoNewUpdate.equals("") && this.fechaEventoInicioString!=null 
	    			&& !this.fechaEventoInicioString.equals("") && this.fechaEventoFinString!=null && !this.fechaEventoFinString.equals("")){
	    		if(this.idEvento!=0 && this.idEvento!=-1)
		    		this.setRespuestaEventoNewUpdate(mb.agregarActualizarEvento(this.idEvento, this.nombreEventoNewUpdate, this.descripcionEvento, 
		    				this.fechaEventoInicioString, this.fechaEventoFinString, this.idPublicacion, this.idsPublicacionesHidden, getIdUsuario()));
	    		else
	    			this.setRespuestaEventoNewUpdate("Debe seleccionar un evento para actualizar.");
	    	}else
	    		this.setRespuestaEventoNewUpdate("Capture el nombre y periodo de fechas del nuevo evento.");
    	}
    	if(this.respuestaEventoNewUpdate!=null && !this.respuestaEventoNewUpdate.equals(""))
    		decodeRespuestaEvento(this.respuestaEventoNewUpdate);
    	setPublicacionSlave(event);
    	System.out.println("<-- PedidoBBean.updateEvento()");
    }
    
    public void getSuplementoNewUpdate(ActionEvent event) throws Exception {
    	System.out.println("--> PedidoBBean.getSuplementoNewUpdate()");
    	selectItemsSufijo = new ArrayList<SelectItem>();
    	FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
        UIInput nombreSuplementoNewUpdate = (UIInput)form.findComponent("nombreSuplementoHidden");
    	UIInput noPaginasHidden = (UIInput)form.findComponent("noPaginasHidden");
    	UIInput radioStatusHidden = (UIInput)form.findComponent("radioStatusHidden");
    	UIInput sufijoHidden = (UIInput)form.findComponent("sufijoHidden");
        UISelectOne selectPublicacionesList = (UISelectOne)form.findComponent("publicacionesList");
        decodePublicacion((String)selectPublicacionesList.getSubmittedValue());
        UISelectOne selectSup = (UISelectOne)form.findComponent("suplementosList");
        this.setIdSuplemento(Integer.parseInt(selectSup.getSubmittedValue().toString()));
        UIInput suplementoNewUpdateField = (UIInput)form.findComponent("suplementoNewUpdateField");
        UIInput spinnerNoPagSuplemento = (UIInput)form.findComponent("spinnerNoPagSuplemento");
        UIInput radioStatus = (UIInput)form.findComponent("radioStatusSuplemento");
        UISelectOne sufijoSuplementoList = (UISelectOne)form.findComponent("sufijoSuplementoList");
        List<PedidoBBean> listaSuplementos = new ArrayList<PedidoBBean>();
        List<PedidoBBean> listaSufijos = new ArrayList<PedidoBBean>();
        if(this.idPublicacion!=0 && this.idPublicacion!=-1 && this.idSuplemento!=0 && this.idSuplemento!=-1){
        	PedidoMBean mb = new PedidoMBean();
        	listaSuplementos = mb.obtenerDetallesSuplemento(this.idPublicacion, this.idSuplemento);
        	listaSufijos = mb.obtenerSufijos();
        	if(listaSufijos.size()==0) selectItemsSufijo.add(new SelectItem("-1", "-sin sufijo-"));
			if(listaSufijos.size()>1) selectItemsSufijo.add(new SelectItem("0", "Seleccione..."));
			for(int i=0; i<listaSufijos.size(); i++)
				selectItemsSufijo.add(new SelectItem(listaSufijos.get(i).getIdSufijo(), listaSufijos.get(i).getNombreSufijo()));
    		this.setNombreSuplementoNewUpdate(listaSuplementos.get(0).getNombreSuplementoNewUpdate());
    		this.setNumeroPaginas(listaSuplementos.get(0).getNumeroPaginas());
    		this.setEstatus(listaSuplementos.get(0).getEstatus());
    		this.setIdSufijo(listaSuplementos.get(0).getIdSufijo());
        	suplementoNewUpdateField.setSubmittedValue(this.getNombreSuplementoNewUpdate());
        	nombreSuplementoNewUpdate.setValue(this.getNombreSuplementoNewUpdate());
        	spinnerNoPagSuplemento.setSubmittedValue(String.valueOf(this.getNumeroPaginas()));
        	noPaginasHidden.setValue(String.valueOf(this.getNumeroPaginas()));
        	radioStatus.setSubmittedValue(this.getEstatus());
        	radioStatusHidden.setValue(this.getEstatus());
        	sufijoSuplementoList.setSubmittedValue(this.getIdSufijo());
        	sufijoHidden.setValue(this.getIdSufijo());
        }else
        	suplementoNewUpdateField.setSubmittedValue("");
    	System.out.println("<-- PedidoBBean.getSuplementoNewUpdate() "+this.getEstatus());
    }
    
    public void setSuplemento(ActionEvent event) throws Exception {
    	System.out.println("--> PedidoBBean.setSuplemento()");
    	PedidoMBean mb = new PedidoMBean();
    	FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
        UISelectOne selectPublicacionesList = (UISelectOne)form.findComponent("publicacionesList");
        decodePublicacion((String)selectPublicacionesList.getSubmittedValue());
        UISelectOne selectSup = (UISelectOne)form.findComponent("suplementosList");
        this.setIdSuplemento(Integer.parseInt(selectSup.getSubmittedValue().toString()));
        List<PedidoBBean> listaSuplementos = mb.obtenerDetallesSuplemento(this.idPublicacion, this.idSuplemento);
        try{
	    	UIInput nombreSuplementoNewUpdate = (UIInput)form.findComponent("nombreSuplementoHidden");
	    	UIInput spinnerNoPagSuplemento = (UIInput)form.findComponent("noPaginasHidden");
	    	UIInput radioStatus = (UIInput)form.findComponent("radioStatusHidden");
	    	UISelectOne sufijoSuplementoList = (UISelectOne)form.findComponent("sufijoHidden");
	    	if(nombreSuplementoNewUpdate.getSubmittedValue()!=null 
	    			&& !nombreSuplementoNewUpdate.getSubmittedValue().toString().equals(""))
	    		this.setNombreSuplementoNewUpdate((String)nombreSuplementoNewUpdate.getSubmittedValue());
	    	else
	    		this.setNombreSuplementoNewUpdate((String)nombreSuplementoNewUpdate.getValue());
	    	if(spinnerNoPagSuplemento.getSubmittedValue()!=null 
	    			&& !spinnerNoPagSuplemento.getSubmittedValue().toString().equals(""))
	    		this.setNumeroPaginas(Integer.parseInt(spinnerNoPagSuplemento.getSubmittedValue().toString()));
	    	else
	    		this.setNumeroPaginas(Integer.parseInt(spinnerNoPagSuplemento.getValue().toString()));
	    	if(radioStatus.getSubmittedValue()!=null 
	    			&& !radioStatus.getSubmittedValue().toString().equals(""))
	    		this.setEstatus(Integer.parseInt(radioStatus.getSubmittedValue().toString()));
	    	else
	    		this.setEstatus(Integer.parseInt(radioStatus.getValue().toString()));
	    	if(sufijoSuplementoList.getSubmittedValue()!=null
	    			&& sufijoSuplementoList.getSubmittedValue().toString().equals(""))
	    		this.setIdSufijo(Integer.parseInt(sufijoSuplementoList.getSubmittedValue().toString()));
	    	else
	    		this.setIdSufijo(Integer.parseInt(sufijoSuplementoList.getValue().toString()));
        }catch(Exception e){
        	//System.out.println("ERROR en PedidoBBean.setSuplemento : "+e);
        }
		this.setRespuestaSuplementoNewUpdate(mb.agregarActualizarSuplemento(this.idPublicacion, 0, this.nombreSuplementoNewUpdate, 
				this.numeroPaginas, this.estatus, this.idSufijo, getIdUsuario(), listaSuplementos));
    	if(this.nombreSuplementoNewUpdate!=null && !this.nombreSuplementoNewUpdate.equals(""))
    		decodeRespuestaSuplemento(this.respuestaSuplementoNewUpdate);
    	selectSup.setSubmittedValue(this.idSuplemento);
    	setPublicacionSlave(event);
    	System.out.println("<-- PedidoBBean.setSuplemento()");
    }
    
	public void updateSuplemento(ActionEvent event) throws Exception {
    	System.out.println("--> PedidoBBean.updateSuplemento()");
    	PedidoMBean mb = new PedidoMBean();
    	FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
        UISelectOne selectPublicacionesList = (UISelectOne)form.findComponent("publicacionesList");
        decodePublicacion((String)selectPublicacionesList.getSubmittedValue());
        UISelectOne selectSup = (UISelectOne)form.findComponent("suplementosList");
        this.setIdSuplemento(Integer.parseInt(selectSup.getSubmittedValue().toString()));
        List<PedidoBBean> listaSuplementos = mb.obtenerDetallesSuplemento(this.idPublicacion, this.idSuplemento);
        try{
        	UIInput nombreSuplementoNewUpdate = (UIInput)form.findComponent("nombreSuplementoHidden");
	    	UIInput spinnerNoPagSuplemento = (UIInput)form.findComponent("noPaginasHidden");
	    	UIInput radioStatus = (UIInput)form.findComponent("radioStatusHidden");
	    	UISelectOne sufijoSuplementoList = (UISelectOne)form.findComponent("sufijoHidden");
	    	if(nombreSuplementoNewUpdate.getSubmittedValue()!=null 
	    			&& !nombreSuplementoNewUpdate.getSubmittedValue().toString().equals(""))
	    		this.setNombreSuplementoNewUpdate((String)nombreSuplementoNewUpdate.getSubmittedValue());
	    	else
	    		this.setNombreSuplementoNewUpdate((String)nombreSuplementoNewUpdate.getValue());
	    	if(spinnerNoPagSuplemento.getSubmittedValue()!=null 
	    			&& !spinnerNoPagSuplemento.getSubmittedValue().toString().equals(""))
	    		this.setNumeroPaginas(Integer.parseInt(spinnerNoPagSuplemento.getSubmittedValue().toString()));
	    	else
	    		this.setNumeroPaginas(Integer.parseInt(spinnerNoPagSuplemento.getValue().toString()));
	    	if(radioStatus.getSubmittedValue()!=null 
	    			&& !radioStatus.getSubmittedValue().toString().equals(""))
	    		this.setEstatus(Integer.parseInt(radioStatus.getSubmittedValue().toString()));
	    	else
	    		this.setEstatus(Integer.parseInt(radioStatus.getValue().toString()));
	    	if(sufijoSuplementoList.getSubmittedValue()!=null
	    			&& sufijoSuplementoList.getSubmittedValue().toString().equals(""))
	    		this.setIdSufijo(Integer.parseInt(sufijoSuplementoList.getSubmittedValue().toString()));
	    	else
	    		this.setIdSufijo(Integer.parseInt(sufijoSuplementoList.getValue().toString()));
        }catch(Exception e){
        	//System.out.println("ERROR en PedidoBBean.updateSuplemento : "+e);
        }
		this.setRespuestaSuplementoNewUpdate(mb.agregarActualizarSuplemento(this.idPublicacion, this.idSuplemento, 
				this.nombreSuplementoNewUpdate, this.numeroPaginas, this.estatus, this.idSufijo, getIdUsuario(), listaSuplementos));
    	if(this.respuestaSuplementoNewUpdate!=null && !this.respuestaSuplementoNewUpdate.equals(""))
    		decodeRespuestaSuplemento(this.respuestaSuplementoNewUpdate);
    	setPublicacionSlave(event);
    	System.out.println("<-- PedidoBBean.updateSuplemento()");
    }
	
	public void getPatrocinioNewUpdate(ActionEvent event) throws Exception {
    	System.out.println("--> PedidoBBean.getPatrocinioNewUpdate()");
    	FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
        UISelectOne selectPublicacionesList = (UISelectOne)form.findComponent("publicacionesList");
        decodePublicacion((String)selectPublicacionesList.getSubmittedValue());
        UISelectOne selectPat = (UISelectOne)form.findComponent("patrociniosList");
        this.setIdPatrocinio(Integer.parseInt(selectPat.getSubmittedValue().toString()));
        UISelectOne selectPublicacionesPatrocinioList = (UISelectOne)form.findComponent("publicacionesPatrocinioList");
        UIInput patrocinioNewUpdateField = (UIInput)form.findComponent("patrocinioNewUpdateField");
        UIInput spinnerNoPagPatrocinio = (UIInput)form.findComponent("spinnerNoPagPatrocinio");
        UIInput radioStatusPatrocinio = (UIInput)form.findComponent("radioStatusPatrocinio");
        UIInput nombrePatrocinioNewUpdate = (UIInput)form.findComponent("nombrePatrocinioHidden");
    	UIInput publicacionPatrocinio = (UIInput)form.findComponent("publicacionPatrocinioHidden");
    	UIInput noPaginasHidden = (UIInput)form.findComponent("noPaginasHidden");
    	UIInput radioStatus = (UIInput)form.findComponent("radioStatusHidden");
        List<PedidoBBean> listaPatrocinios = new ArrayList<PedidoBBean>();
        if(this.idPublicacion!=0 && this.idPublicacion!=-1 && this.idPatrocinio!=0 && this.idPatrocinio!=-1){
        	PedidoMBean mb = new PedidoMBean();
        	listaPatrocinios = mb.obtenerDetallesPatrocinio(this.idPublicacion, this.idPatrocinio);
    		this.setNombrePatrocinioNewUpdate(listaPatrocinios.get(0).getNombrePatrocinioNewUpdate());
    		this.setPublicacionPatrocinio(listaPatrocinios.get(0).getPublicacionPatrocinio());
    		this.setNumeroPaginas(listaPatrocinios.get(0).getNumeroPaginas());
    		this.setEstatus(listaPatrocinios.get(0).getEstatus());
        	patrocinioNewUpdateField.setSubmittedValue(this.getNombrePatrocinioNewUpdate());
        	nombrePatrocinioNewUpdate.setValue(this.getNombrePatrocinioNewUpdate());
        	selectPublicacionesPatrocinioList.setSubmittedValue(this.getPublicacionPatrocinio());
        	publicacionPatrocinio.setValue(this.getPublicacionPatrocinio());
        	spinnerNoPagPatrocinio.setSubmittedValue(String.valueOf(this.getNumeroPaginas()));
        	noPaginasHidden.setValue(String.valueOf(this.getNumeroPaginas()));
        	radioStatusPatrocinio.setSubmittedValue(this.getEstatus());
        	radioStatus.setValue(this.getEstatus());
        }else
        	patrocinioNewUpdateField.setSubmittedValue("");
    	System.out.println("<-- PedidoBBean.getPatrocinioNewUpdate()");
    }
    
    public void setPatrocinio(ActionEvent event) throws Exception {
    	System.out.println("--> PedidoBBean.setPatrocinio()");
    	PedidoMBean mb = new PedidoMBean();
    	FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
        UISelectOne selectPublicacionesList = (UISelectOne)form.findComponent("publicacionesList");
        decodePublicacion((String)selectPublicacionesList.getSubmittedValue());
        UISelectOne selectPat = (UISelectOne)form.findComponent("patrociniosList");
        this.setIdPatrocinio(Integer.parseInt(selectPat.getSubmittedValue().toString()));
        List<PedidoBBean> listaPatrocinios = mb.obtenerDetallesPatrocinio(this.idPublicacion, this.idPatrocinio);
        try{
        	UIInput nombrePatrocinioNewUpdate = (UIInput)form.findComponent("nombrePatrocinioHidden");
	    	UIInput publicacionPatrocinio = (UIInput)form.findComponent("publicacionPatrocinioHidden");
	    	UIInput spinnerNoPagPatrocinio = (UIInput)form.findComponent("noPaginasHidden");
	    	UIInput radioStatus = (UIInput)form.findComponent("radioStatusHidden");
	    	if(nombrePatrocinioNewUpdate.getSubmittedValue()!=null
	    			&& !nombrePatrocinioNewUpdate.getSubmittedValue().toString().equals(""))
	    		this.setNombrePatrocinioNewUpdate((String)nombrePatrocinioNewUpdate.getSubmittedValue());
	    	else
	    		this.setNombrePatrocinioNewUpdate((String)nombrePatrocinioNewUpdate.getValue());
	    	if(publicacionPatrocinio.getSubmittedValue()!=null
	    			&& !publicacionPatrocinio.getSubmittedValue().toString().equals(""))
	    		this.setPublicacionPatrocinio((String)publicacionPatrocinio.getSubmittedValue());
	    	else
	    		this.setPublicacionPatrocinio((String)publicacionPatrocinio.getValue());
	    	if(spinnerNoPagPatrocinio.getSubmittedValue()!=null 
	    			&& !spinnerNoPagPatrocinio.getSubmittedValue().toString().equals(""))
	    		this.setNumeroPaginas(Integer.parseInt(spinnerNoPagPatrocinio.getSubmittedValue().toString()));
	    	else
	    		this.setNumeroPaginas(Integer.parseInt(spinnerNoPagPatrocinio.getValue().toString()));
	    	if(radioStatus.getSubmittedValue()!=null 
	    			&& !radioStatus.getSubmittedValue().toString().equals(""))
	    		this.setEstatus(Integer.parseInt(radioStatus.getSubmittedValue().toString()));
	    	else
	    		this.setEstatus(Integer.parseInt(radioStatus.getValue().toString()));
        }catch(Exception e){
        	//Nada, este error seria de obtencion de datos
        }
		this.setRespuestaPatrocinioNewUpdate(mb.agregarActualizarPatrocinio(this.idPublicacion, this.publicacionPatrocinio,
				0, this.nombrePatrocinioNewUpdate, this.numeroPaginas, this.estatus, getIdUsuario(), listaPatrocinios));
    	if(this.nombrePatrocinioNewUpdate!=null && !this.nombrePatrocinioNewUpdate.equals(""))
    		decodeRespuestaPatrocinio(this.respuestaPatrocinioNewUpdate);
    	selectPat.setSubmittedValue(this.idPatrocinio);
    	setPublicacionSlave(event);
    	System.out.println("<-- PedidoBBean.setPatrocinio()");
    }
    
	public void updatePatrocinio(ActionEvent event) throws Exception {
    	System.out.println("--> PedidoBBean.updatePatrocinio()");
    	PedidoMBean mb = new PedidoMBean();
    	FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
        UISelectOne selectPublicacionesList = (UISelectOne)form.findComponent("publicacionesList");
        decodePublicacion((String)selectPublicacionesList.getSubmittedValue());
        UISelectOne selectPat = (UISelectOne)form.findComponent("patrociniosList");
        this.setIdPatrocinio(Integer.parseInt(selectPat.getSubmittedValue().toString()));
        List<PedidoBBean> listaPatrocinios = mb.obtenerDetallesPatrocinio(this.idPublicacion, this.idPatrocinio);
        try{
	    	UIInput nombrePatrocinioNewUpdate = (UIInput)form.findComponent("nombrePatrocinioHidden");
	    	UIInput publicacionPatrocinio = (UIInput)form.findComponent("publicacionPatrocinioHidden");
	    	UIInput spinnerNoPagPatrocinio = (UIInput)form.findComponent("noPaginasHidden");
	    	UIInput radioStatus = (UIInput)form.findComponent("radioStatusHidden");
	    	if(nombrePatrocinioNewUpdate.getSubmittedValue()!=null
	    			&& !nombrePatrocinioNewUpdate.getSubmittedValue().toString().equals(""))
	    		this.setNombrePatrocinioNewUpdate((String)nombrePatrocinioNewUpdate.getSubmittedValue());
	    	else
	    		this.setNombrePatrocinioNewUpdate((String)nombrePatrocinioNewUpdate.getValue());
	    	if(publicacionPatrocinio.getSubmittedValue()!=null
	    			&& !publicacionPatrocinio.getSubmittedValue().toString().equals(""))
	    		this.setPublicacionPatrocinio((String)publicacionPatrocinio.getSubmittedValue());
	    	else
	    		this.setPublicacionPatrocinio((String)publicacionPatrocinio.getValue());
	    	if(spinnerNoPagPatrocinio.getSubmittedValue()!=null 
	    			&& !spinnerNoPagPatrocinio.getSubmittedValue().toString().equals(""))
	    		this.setNumeroPaginas(Integer.parseInt(spinnerNoPagPatrocinio.getSubmittedValue().toString()));
	    	else
	    		this.setNumeroPaginas(Integer.parseInt(spinnerNoPagPatrocinio.getValue().toString()));
	    	if(radioStatus.getSubmittedValue()!=null 
	    			&& !radioStatus.getSubmittedValue().toString().equals(""))
	    		this.setEstatus(Integer.parseInt(radioStatus.getSubmittedValue().toString()));
	    	else
	    		this.setEstatus(Integer.parseInt(radioStatus.getValue().toString()));
        }catch(Exception e){
        	//Nada, este error seria de obtencion de datos
        }
		this.setRespuestaPatrocinioNewUpdate(mb.agregarActualizarPatrocinio(this.idPublicacion, this.publicacionPatrocinio,
				this.idPatrocinio, this.nombrePatrocinioNewUpdate, this.numeroPaginas, this.estatus, getIdUsuario(), listaPatrocinios));
    	if(this.respuestaPatrocinioNewUpdate!=null && !this.respuestaPatrocinioNewUpdate.equals(""))
    		decodeRespuestaPatrocinio(this.respuestaPatrocinioNewUpdate);
    	setPublicacionSlave(event);
    	System.out.println("<-- PedidoBBean.updatePatrocinio()");
    }
	
	public void getPosicionNewUpdate(ActionEvent event) throws Exception {
    	System.out.println("--> PedidoBBean.getPosicionNewUpdate()");
    	PedidoMBean mb = new PedidoMBean();
    	PedidoBBean bean = new PedidoBBean();
    	String arrayIdPubEve[] = null;
    	List<PedidoBBean> lsPosicionPublicaciones = new ArrayList<PedidoBBean>();
    	FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
        UIInput nombrePosicionHidden = (UIInput)form.findComponent("nombrePosicionHidden");
        UIInput radioStatusHidden = (UIInput)form.findComponent("radioStatusHidden");
    	UIInput idPosicionPublicacionHidden = (UIInput)form.findComponent("idsPublicacionesHidden");
        String idsPosicionPublicacion = "";
        UISelectOne selectPublicacionesList = (UISelectOne)form.findComponent("publicacionesList");
        decodePublicacion((String)selectPublicacionesList.getSubmittedValue());
        UISelectOne selectPos = (UISelectOne)form.findComponent("posicionesList");
        this.setIdPosicion(Integer.parseInt(selectPos.getSubmittedValue().toString()));
        UIInput nombrePosicionNewUpdate = (UIInput)form.findComponent("posicionNewUpdateField");
        UIInput radioStatusPosicion = (UIInput)form.findComponent("radioStatusPosicion");
        UISelectMany idPosicionPublicacionNewUpdateField = (UISelectMany)form.findComponent("idPosicionPublicacionNewUpdateField");
        if(this.idPublicacion!=0 && this.idPublicacion!=-1 && this.idPosicion!=0 && this.idPosicion!=-1){
        	lsPosicionPublicaciones = mb.obtenerDetallesPosicion(this.idPublicacion, this.idPosicion, getIdUsuario(), bean);
        	this.setNombrePosicionNewUpdate(bean.getNombrePosicionNewUpdate());
        	this.setEstatus(bean.getEstatus());
        	if(lsPosicionPublicaciones != null && !lsPosicionPublicaciones.isEmpty()){
        		arrayIdPubEve = new String[lsPosicionPublicaciones.size()];
            	for(int i=0; i<lsPosicionPublicaciones.size(); i++){
            		arrayIdPubEve[i] = lsPosicionPublicaciones.get(i).getIdMultiPublicacionModal().toString();
            		idsPosicionPublicacion = idsPosicionPublicacion+"^"+lsPosicionPublicaciones.get(i).getIdMultiPublicacionModal().toString();
            	}
            	this.setPublicacionesEvento(arrayIdPubEve);
        	}
        	nombrePosicionNewUpdate.setSubmittedValue(this.getNombrePosicionNewUpdate());
        	nombrePosicionHidden.setValue(this.getNombrePosicionNewUpdate());
        	radioStatusPosicion.setSubmittedValue(this.getEstatus());
        	radioStatusHidden.setValue(this.getEstatus());
        	idPosicionPublicacionNewUpdateField.setSubmittedValue(this.getPublicacionesEvento());
        	idPosicionPublicacionHidden.setValue(idsPosicionPublicacion);
        }else
        	nombrePosicionNewUpdate.setSubmittedValue("");
    	System.out.println("<-- PedidoBBean.getPosicionNewUpdate()");
    }
    
    public void setPosicion(ActionEvent event) throws Exception {
    	System.out.println("--> PedidoBBean.setPosicion()");
    	List<PedidoBBean> lsPosicionPublicaciones = new ArrayList<PedidoBBean>();
    	PedidoMBean mb = new PedidoMBean();
    	PedidoBBean bean = new PedidoBBean();
    	FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
        UISelectOne selectPos = (UISelectOne)form.findComponent("posicionesList");
        this.setIdPosicion(Integer.parseInt(selectPos.getSubmittedValue().toString()));
        try{
        	UIInput nombrePosicionNewUpdate = (UIInput)form.findComponent("nombrePosicionHidden");
        	UIInput radioStatus = (UIInput)form.findComponent("radioStatusHidden");
        	UIInput idPosicionPublicacionHidden = (UIInput)form.findComponent("idsPublicacionesHidden");
        	if(nombrePosicionNewUpdate.getSubmittedValue()!=null 
        			&& !nombrePosicionNewUpdate.getSubmittedValue().toString().equals(""))
        		this.setNombrePosicionNewUpdate((String)nombrePosicionNewUpdate.getSubmittedValue());
        	else
        		this.setNombrePosicionNewUpdate((String)nombrePosicionNewUpdate.getValue());
        	if(radioStatus.getSubmittedValue()!=null
        			&& !radioStatus.getSubmittedValue().toString().equals(""))
        		this.setEstatus(Integer.parseInt(radioStatus.getSubmittedValue().toString()));
        	else
        		this.setEstatus(Integer.parseInt(radioStatus.getValue().toString()));
            if(idPosicionPublicacionHidden!=null 
            		&& !idPosicionPublicacionHidden.getSubmittedValue().equals(""))
        		this.setIdsPublicacionesHidden((String)idPosicionPublicacionHidden.getSubmittedValue());
            else
            	this.setIdsPublicacionesHidden((String)idPosicionPublicacionHidden.getValue());
	        lsPosicionPublicaciones = mb.obtenerDetallesPosicion(this.idPublicacion, this.idPosicion, getIdUsuario(), bean);
	    }catch(Exception e){
	    	//System.out.println("ERROR en PedidoBBean.setPosicion: "+e);
	    }
		this.setRespuestaPosicionNewUpdate(mb.agregarActualizarPosicion(0, this.nombrePosicionNewUpdate, 
				this.idsPublicacionesHidden, this.estatus, getIdUsuario(), bean, lsPosicionPublicaciones));
    	if(this.nombrePosicionNewUpdate!=null && !this.nombrePosicionNewUpdate.equals(""))
    		decodeRespuestaPosicion(this.respuestaPosicionNewUpdate);
    	selectPos.setSubmittedValue(this.idPosicion);
    	setPublicacionSlave(event);
    	System.out.println("<-- PedidoBBean.setPosicion()");
    }
    
	public void updatePosicion(ActionEvent event) throws Exception {
    	System.out.println("--> PedidoBBean.updatePosicion()");
    	List<PedidoBBean> lsPosicionPublicaciones = new ArrayList<PedidoBBean>();
    	PedidoMBean mb = new PedidoMBean();
    	PedidoBBean bean = new PedidoBBean();
    	FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
        UISelectOne selectPos = (UISelectOne)form.findComponent("posicionesList");
        this.setIdPosicion(Integer.parseInt(selectPos.getSubmittedValue().toString()));
        try{
        	UIInput nombrePosicionNewUpdate = (UIInput)form.findComponent("nombrePosicionHidden");
        	UIInput radioStatus = (UIInput)form.findComponent("radioStatusHidden");
        	UIInput idPosicionPublicacionHidden = (UIInput)form.findComponent("idsPublicacionesHidden");
        	if(nombrePosicionNewUpdate.getSubmittedValue()!=null 
        			&& !nombrePosicionNewUpdate.getSubmittedValue().toString().equals(""))
        		this.setNombrePosicionNewUpdate((String)nombrePosicionNewUpdate.getSubmittedValue());
        	else
        		this.setNombrePosicionNewUpdate((String)nombrePosicionNewUpdate.getValue());
        	if(radioStatus.getSubmittedValue()!=null
        			&& !radioStatus.getSubmittedValue().toString().equals(""))
        		this.setEstatus(Integer.parseInt(radioStatus.getSubmittedValue().toString()));
        	else
        		this.setEstatus(Integer.parseInt(radioStatus.getValue().toString()));
            if(idPosicionPublicacionHidden!=null 
            		&& !idPosicionPublicacionHidden.getSubmittedValue().equals(""))
        		this.setIdsPublicacionesHidden((String)idPosicionPublicacionHidden.getSubmittedValue());
            else
            	this.setIdsPublicacionesHidden((String)idPosicionPublicacionHidden.getValue());
            lsPosicionPublicaciones = mb.obtenerDetallesPosicion(this.idPublicacion, this.idPosicion, getIdUsuario(), bean);
        }catch(Exception e){
        	//System.out.println("ERROR en PedidoBBean.updatePosicion: "+e);
        }
		this.setRespuestaPosicionNewUpdate(mb.agregarActualizarPosicion(this.idPosicion, this.nombrePosicionNewUpdate, 
				this.idsPublicacionesHidden, this.estatus, getIdUsuario(), bean, lsPosicionPublicaciones));
    	if(this.respuestaPosicionNewUpdate!=null && !this.respuestaPosicionNewUpdate.equals(""))
    		decodeRespuestaPosicion(this.respuestaPosicionNewUpdate);
    	selectPos.setSubmittedValue(this.idPosicion);
    	setPublicacionSlave(event);
    	System.out.println("<-- PedidoBBean.updatePosicion()");
    }
	
	public void getSeccionNewUpdate(ActionEvent event) throws Exception {
    	System.out.println("--> PedidoBBean.getSeccionNewUpdate()");
    	selectItemsSufijo = new ArrayList<SelectItem>();
    	FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
        UISelectOne selectPublicacionesList = (UISelectOne)form.findComponent("publicacionesList");
        decodePublicacion((String)selectPublicacionesList.getSubmittedValue());
        UISelectOne selectSecc = (UISelectOne)form.findComponent("seccionesList");
        this.setIdSeccion(Integer.parseInt(selectSecc.getSubmittedValue().toString()));
        UIInput nombreSeccionNewUpdate = (UIInput)form.findComponent("seccionNewUpdateField");
        UIInput spinnerNoPagSeccion = (UIInput)form.findComponent("spinnerNoPagSeccion");
        UIInput radioStatus = (UIInput)form.findComponent("radioStatusSeccion");
        UISelectOne sufijoSeccionList = (UISelectOne)form.findComponent("sufijoSeccionList");
        UIInput nombreSeccionHidden = (UIInput)form.findComponent("nombreSeccionHidden");
		UIInput noPaginasHidden = (UIInput)form.findComponent("noPaginasHidden");
		UIInput radioStatusHidden = (UIInput)form.findComponent("radioStatusHidden");
		UIInput sufijoHidden = (UIInput)form.findComponent("sufijoHidden");
    	PedidoMBean mb = new PedidoMBean();
    	List<PedidoBBean> listaSecciones = new ArrayList<PedidoBBean>();
        List<PedidoBBean> listaSufijos = new ArrayList<PedidoBBean>();
        listaSufijos = mb.obtenerSufijos();
        listaSecciones = mb.obtenerDetallesSeccion(this.idPublicacion, this.idSeccion);
        if(listaSecciones!=null && !listaSecciones.isEmpty()){
	        this.setNombreSeccionNewUpdate(listaSecciones.get(0).getNombreSeccionNewUpdate());
	        this.setNumeroPaginas(listaSecciones.get(0).getNumeroPaginas());
	        this.setEstatus(listaSecciones.get(0).getEstatus());
	        this.setIdSufijo(listaSecciones.get(0).getIdSufijo());
        }
        if(listaSufijos.size()==0) selectItemsSufijo.add(new SelectItem("-1", "-sin sufijo-"));
		if(listaSufijos.size()>1) selectItemsSufijo.add(new SelectItem("0", "Seleccione..."));
		for(int i=0; i<listaSufijos.size(); i++)
			selectItemsSufijo.add(new SelectItem(listaSufijos.get(i).getIdSufijo(), listaSufijos.get(i).getNombreSufijo()));
        nombreSeccionNewUpdate.setSubmittedValue(this.getNombreSeccionNewUpdate());
        nombreSeccionHidden.setValue(this.getNombreSeccionNewUpdate());
        spinnerNoPagSeccion.setSubmittedValue(String.valueOf(this.getNumeroPaginas()));
        noPaginasHidden.setValue(String.valueOf(this.getNumeroPaginas()));
    	radioStatus.setSubmittedValue(this.getEstatus());
    	radioStatusHidden.setValue(this.getEstatus());
    	sufijoSeccionList.setSubmittedValue(this.getIdSufijo());
    	sufijoHidden.setValue(this.getIdSufijo());
    	System.out.println("<-- PedidoBBean.getSeccionNewUpdate()");
    }
    
    public void setSeccion(ActionEvent event) throws Exception {
    	System.out.println("--> PedidoBBean.setSeccion()");
    	FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
        UISelectOne selectPublicacionesList = (UISelectOne)form.findComponent("publicacionesList");
        decodePublicacion((String)selectPublicacionesList.getSubmittedValue());
        UISelectOne selectSecc = (UISelectOne)form.findComponent("seccionesList");
        this.setIdSeccion(Integer.parseInt(selectSecc.getSubmittedValue().toString()));
    	try{
    		UIInput nombreSeccionNewUpdate = (UIInput)form.findComponent("nombreSeccionHidden");
    		UIInput spinnerNoPagSeccion = (UIInput)form.findComponent("noPaginasHidden");
    		UIInput radioStatus = (UIInput)form.findComponent("radioStatusHidden");
    		UISelectOne sufijoSeccionList = (UISelectOne)form.findComponent("sufijoHidden");
    		if(nombreSeccionNewUpdate.getSubmittedValue()!=null
    				&& !nombreSeccionNewUpdate.getSubmittedValue().toString().equals(""))
    			this.setNombreSeccionNewUpdate((String)nombreSeccionNewUpdate.getSubmittedValue());
    		else
    			this.setNombreSeccionNewUpdate((String)nombreSeccionNewUpdate.getValue());
        	if(spinnerNoPagSeccion.getSubmittedValue()!=null
        			&& !spinnerNoPagSeccion.getSubmittedValue().toString().equals(""))
        		this.setNumeroPaginas(Integer.parseInt(spinnerNoPagSeccion.getSubmittedValue().toString()));
        	else
        		this.setNumeroPaginas(Integer.parseInt(spinnerNoPagSeccion.getValue().toString()));
        	if(radioStatus.getSubmittedValue()!=null
        			&& !radioStatus.getSubmittedValue().toString().equals(""))
        		this.setEstatus(Integer.parseInt(radioStatus.getSubmittedValue().toString()));
        	else
        		this.setEstatus(Integer.parseInt(radioStatus.getValue().toString()));
        	if(sufijoSeccionList.getSubmittedValue()!=null
        			&& !sufijoSeccionList.getSubmittedValue().toString().equals(""))
        		this.setIdSufijo(Integer.parseInt(sufijoSeccionList.getSubmittedValue().toString()));
        	else
        		this.setIdSufijo(Integer.parseInt(sufijoSeccionList.getValue().toString()));
    	}catch(Exception e){
    		//nada
    	}
    	PedidoMBean mb = new PedidoMBean();
    	List<PedidoBBean> listaSecciones = new ArrayList<PedidoBBean>();
        listaSecciones = mb.obtenerDetallesSeccion(this.idPublicacion, this.idSeccion);
        this.setRespuestaSeccionNewUpdate(mb.agregarActualizarSeccion(this.idPublicacion, this.idSeccion, 
				this.nombreSeccionNewUpdate, this.numeroPaginas, this.estatus, this.idSufijo, getIdUsuario(), listaSecciones));
    	if(this.nombreSeccionNewUpdate!=null && !this.nombreSeccionNewUpdate.equals(""))
    		decodeRespuestaSeccion(this.respuestaSeccionNewUpdate);
    	selectSecc.setSubmittedValue(this.idSeccion);
    	setPublicacionSlave(event);
    	System.out.println("<-- PedidoBBean.setSeccion()");
    }
    
	public void updateSeccion(ActionEvent event) throws Exception {
    	System.out.println("--> PedidoBBean.updateSeccion()");
    	FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
        UISelectOne selectPublicacionesList = (UISelectOne)form.findComponent("publicacionesList");
        decodePublicacion((String)selectPublicacionesList.getSubmittedValue());
        UISelectOne selectSecc = (UISelectOne)form.findComponent("seccionesList");
        this.setIdSeccion(Integer.parseInt(selectSecc.getSubmittedValue().toString()));
        try{
    		UIInput nombreSeccionNewUpdate = (UIInput)form.findComponent("nombreSeccionHidden");
    		UIInput spinnerNoPagSeccion = (UIInput)form.findComponent("noPaginasHidden");
    		UIInput radioStatus = (UIInput)form.findComponent("radioStatusHidden");
    		UISelectOne sufijoSeccionList = (UISelectOne)form.findComponent("sufijoHidden");
    		if(nombreSeccionNewUpdate.getSubmittedValue()!=null
    				&& !nombreSeccionNewUpdate.getSubmittedValue().toString().equals(""))
    			this.setNombreSeccionNewUpdate((String)nombreSeccionNewUpdate.getSubmittedValue());
    		else
    			this.setNombreSeccionNewUpdate((String)nombreSeccionNewUpdate.getValue());
        	if(spinnerNoPagSeccion.getSubmittedValue()!=null
        			&& !spinnerNoPagSeccion.getSubmittedValue().toString().equals(""))
        		this.setNumeroPaginas(Integer.parseInt(spinnerNoPagSeccion.getSubmittedValue().toString()));
        	else
        		this.setNumeroPaginas(Integer.parseInt(spinnerNoPagSeccion.getValue().toString()));
        	if(radioStatus.getSubmittedValue()!=null
        			&& !radioStatus.getSubmittedValue().toString().equals(""))
        		this.setEstatus(Integer.parseInt(radioStatus.getSubmittedValue().toString()));
        	else
        		this.setEstatus(Integer.parseInt(radioStatus.getValue().toString()));
        	if(sufijoSeccionList.getSubmittedValue()!=null
        			&& !sufijoSeccionList.getSubmittedValue().toString().equals(""))
        		this.setIdSufijo(Integer.parseInt(sufijoSeccionList.getSubmittedValue().toString()));
        	else
        		this.setIdSufijo(Integer.parseInt(sufijoSeccionList.getValue().toString()));
    	}catch(Exception e){
    		//nada
    	}
    	PedidoMBean mb = new PedidoMBean();
    	List<PedidoBBean> listaSecciones = new ArrayList<PedidoBBean>();
        listaSecciones = mb.obtenerDetallesSeccion(this.idPublicacion, this.idSeccion);
		this.setRespuestaSeccionNewUpdate(mb.agregarActualizarSeccion(this.idPublicacion, this.idSeccion, 
				this.nombreSeccionNewUpdate, this.numeroPaginas, this.estatus, this.idSufijo, getIdUsuario(), listaSecciones));
    	if(this.respuestaSeccionNewUpdate!=null && !this.respuestaSeccionNewUpdate.equals(""))
    		decodeRespuestaSeccion(this.respuestaSeccionNewUpdate);
    	selectSecc.setSubmittedValue(this.idSeccion);
    	setPublicacionSlave(event);
    	System.out.println("<-- PedidoBBean.updateSeccion()");
    }
	
	public void getFormatoNewUpdate(ActionEvent event) throws Exception {
    	System.out.println("--> PedidoBBean.getFormatoNewUpdate()");
    	FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
        UISelectOne selectPublicacionesList = (UISelectOne)form.findComponent("publicacionesList");
        decodePublicacion((String)selectPublicacionesList.getSubmittedValue());
        UISelectOne selectFor = (UISelectOne)form.findComponent("formatosList");
        decodeFormato((String)selectFor.getSubmittedValue());
        
        UIInput nombreFormatoHidden = (UIInput)form.findComponent("nombreFormatoHidden");
        UIInput tipoFormatoHidden = (UIInput)form.findComponent("radioTipoFormatoHidden");
        UIInput altoFormatoHidden = (UIInput)form.findComponent("altoFormatoHidden");
        UIInput anchoFormatoHidden = (UIInput)form.findComponent("anchoFormatoHidden");
        UIInput idFormatoPublicacionHidden = (UIInput)form.findComponent("idsPublicacionesHidden");
        
        UIInput nombreFormatoNewUpdate = (UIInput)form.findComponent("formatoNewUpdateField");
        UIInput radioTipoFormato = (UIInput)form.findComponent("radioTipoFormato");
        HtmlInputNumberSpinner spinnerAlt = (HtmlInputNumberSpinner)form.findComponent("spinnerFormatoAlto");
        HtmlInputNumberSpinner spinnerAnc = (HtmlInputNumberSpinner)form.findComponent("spinnerFormatoAncho");
        List<PedidoBBean> lsFormatoPublicaciones = null;
        PedidoBBean bean = new PedidoBBean();
        PedidoMBean mb = new PedidoMBean();
    	String arrayIdPubEve[] = null;
    	String idsPublicacionesFormato="";
        if(this.idPublicacion!=0 && this.idPublicacion!=-1 && this.idFormato!=0 && this.idFormato!=-1){
        	lsFormatoPublicaciones = mb.obtenerDetallesFormato(this.idPublicacion, this.idFormato, bean, getIdUsuario());
        	nombreFormatoNewUpdate.setSubmittedValue(bean.getNombreFormato());
        	nombreFormatoHidden.setValue(bean.getNombreFormato());
        	System.out.println("	--------------------> bean.getTipoFormato() "+bean.getTipoFormato());
        	radioTipoFormato.setSubmittedValue(bean.getTipoFormato());
        	tipoFormatoHidden.setValue(bean.getTipoFormato());
        	spinnerAlt.setSubmittedValue(bean.getAltoFormato());
        	altoFormatoHidden.setValue(bean.getAltoFormato());
        	spinnerAnc.setSubmittedValue(bean.getAnchoFormato());
        	anchoFormatoHidden.setValue(bean.getAnchoFormato());
        	if(this.getTipoPublicacion()==1){// periodico
        		this.setMaxAlto("35.5");
        		this.setMaxAncho("5");
        	}else{// revista
        		this.setMaxAlto("27.5");
        		this.setMaxAncho("21");
        	}
        	if(lsFormatoPublicaciones != null && !lsFormatoPublicaciones.isEmpty()){
        		arrayIdPubEve = new String[lsFormatoPublicaciones.size()];
            	for(int i=0; i<lsFormatoPublicaciones.size(); i++){
            		arrayIdPubEve[i] = lsFormatoPublicaciones.get(i).getIdMultiPublicacionModal().toString();
            		idsPublicacionesFormato = idsPublicacionesFormato+"^"
            		+lsFormatoPublicaciones.get(i).getIdMultiPublicacionModal().toString();
            	}
            	this.setPublicacionesEvento(arrayIdPubEve);
            	idFormatoPublicacionHidden.setValue(idsPublicacionesFormato);
        	}
        }else
        	nombreFormatoNewUpdate.setSubmittedValue("");
    	System.out.println("<-- PedidoBBean.getFormatoNewUpdate()"+bean.getTipoFormato());
    }
    
    public void setFormato(ActionEvent event) throws Exception {
    	System.out.println("--> PedidoBBean.setFormato()");
    	FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
        UISelectOne selectPublicacionesList = (UISelectOne)form.findComponent("publicacionesList");
        decodePublicacion((String)selectPublicacionesList.getSubmittedValue());
        UISelectOne selectFor = (UISelectOne)form.findComponent("formatosList");
        decodeFormato((String)selectFor.getSubmittedValue());
        UIInput nombreFormatoHidden = (UIInput)form.findComponent("nombreFormatoHidden");
        UIInput tipoFormatoHidden = (UIInput)form.findComponent("radioTipoFormatoHidden");
        UIInput altoFormatoHidden = (UIInput)form.findComponent("altoFormatoHidden");
        UIInput anchoFormatoHidden = (UIInput)form.findComponent("anchoFormatoHidden");
        UIInput idFormatoPublicacionHidden = (UIInput)form.findComponent("idsPublicacionesHidden");
        HtmlInputNumberSpinner sAlto = (HtmlInputNumberSpinner)form.findComponent("spinnerAlto");
        HtmlInputNumberSpinner sAncho = (HtmlInputNumberSpinner)form.findComponent("spinnerAncho");
        List<PedidoBBean> lsFormatoPublicaciones = null;
        PedidoBBean bean = new PedidoBBean();
        PedidoMBean mb = new PedidoMBean();
        String alto = "";
        String ancho = "";
        try{
        	if(idFormatoPublicacionHidden.getSubmittedValue()!=null
        			&& !idFormatoPublicacionHidden.getSubmittedValue().toString().equals(""))
        		this.setIdsPublicacionesHidden((String)idFormatoPublicacionHidden.getSubmittedValue());
        	else
        		this.setIdsPublicacionesHidden((String)idFormatoPublicacionHidden.getValue());
        	if(nombreFormatoHidden.getSubmittedValue()!=null
        			&& !nombreFormatoHidden.getSubmittedValue().toString().equals(""))
        		this.setNombreFormatoNewUpdate((String)nombreFormatoHidden.getSubmittedValue());
        	else
        		this.setNombreFormatoNewUpdate((String)nombreFormatoHidden.getValue());
        	if(tipoFormatoHidden.getSubmittedValue()!=null 
        			&& !tipoFormatoHidden.getSubmittedValue().equals(""))
        		this.setTipoFormato(Integer.parseInt(tipoFormatoHidden.getSubmittedValue().toString()));
        	else
        		this.setTipoFormato(Integer.parseInt(tipoFormatoHidden.getValue().toString()));
        	if(altoFormatoHidden.getSubmittedValue()!=null 
        			&& !altoFormatoHidden.getSubmittedValue().toString().equals(""))
        		alto = (String)altoFormatoHidden.getSubmittedValue();
        	else
        		alto = (String)altoFormatoHidden.getValue();
        	if(anchoFormatoHidden.getSubmittedValue()!=null 
        			&& !anchoFormatoHidden.getSubmittedValue().toString().equals(""))
        		ancho = (String)anchoFormatoHidden.getSubmittedValue();
        	else
        		alto = (String)anchoFormatoHidden.getValue();
        }catch(Exception e){
        	//Nada
        }
    	if(tipoFormatoHidden!=null && !tipoFormatoHidden.getSubmittedValue().toString().equals(""))
    		this.setTipoFormato(Integer.parseInt(tipoFormatoHidden.getSubmittedValue().toString()));
        lsFormatoPublicaciones = mb.obtenerDetallesFormato(this.idPublicacion, this.idFormato, bean, getIdUsuario());
		this.setRespuestaFormatoNewUpdate(mb.agregarActualizarFormato(this.idFormato, this.nombreFormatoNewUpdate, this.tipoFormato, 
				alto, ancho, this.idsPublicacionesHidden, getIdUsuario(), bean, lsFormatoPublicaciones));
    	if(this.nombreFormatoNewUpdate!=null && !this.nombreFormatoNewUpdate.equals(""))
    		decodeRespuestaFormato(this.respuestaFormatoNewUpdate, this.tipoFormato);
    	if(this.tipoFormato==1){//formatoEspecial
			sAlto.setDisabled(false);
			sAlto.setValue(0);
			sAlto.setEnableManualInput(true);
			sAncho.setDisabled(false);
			sAncho.setValue(0);
			sAncho.setEnableManualInput(true);
			this.setAltoDisabled(false);
			this.setAltoRequired(true);
			this.setAnchoDisabled(false);
			this.setAnchoRequired(true);
		}else{
			sAncho.setValue(ancho);
			sAncho.setSubmittedValue(ancho);
			sAncho.setEnableManualInput(false);
			sAncho.setDisabled(true);
			sAlto.setValue(alto);
			sAlto.setSubmittedValue(alto);
			sAlto.setEnableManualInput(false);
			sAlto.setDisabled(true);
		}
    	selectFor.setSubmittedValue(this.formato);
    	setPublicacionSlave(event);
    	System.out.println("<-- PedidoBBean.setFormato()");
    }
    
	public void updateFormato(ActionEvent event) throws Exception {
    	System.out.println("--> PedidoBBean.updateFormato()");
    	FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
        UISelectOne selectPublicacionesList = (UISelectOne)form.findComponent("publicacionesList");
        decodePublicacion((String)selectPublicacionesList.getSubmittedValue());
        UISelectOne selectFor = (UISelectOne)form.findComponent("formatosList");
        decodeFormato((String)selectFor.getSubmittedValue());
        UIInput nombreFormatoHidden = (UIInput)form.findComponent("nombreFormatoHidden");
        UIInput tipoFormatoHidden = (UIInput)form.findComponent("radioTipoFormatoHidden");
        UIInput altoFormatoHidden = (UIInput)form.findComponent("altoFormatoHidden");
        UIInput anchoFormatoHidden = (UIInput)form.findComponent("anchoFormatoHidden");
        UIInput idFormatoPublicacionHidden = (UIInput)form.findComponent("idsPublicacionesHidden");
        HtmlInputNumberSpinner sAlto = (HtmlInputNumberSpinner)form.findComponent("spinnerAlto");
        HtmlInputNumberSpinner sAncho = (HtmlInputNumberSpinner)form.findComponent("spinnerAncho");
    	String alto = "";
        String ancho = "";
        List<PedidoBBean> lsFormatoPublicaciones = null;
        PedidoBBean bean = new PedidoBBean();
        PedidoMBean mb = new PedidoMBean();
        try{
        	if(idFormatoPublicacionHidden.getSubmittedValue()!=null
        			&& !idFormatoPublicacionHidden.getSubmittedValue().toString().equals(""))
        		this.setIdsPublicacionesHidden((String)idFormatoPublicacionHidden.getSubmittedValue());
        	else
        		this.setIdsPublicacionesHidden((String)idFormatoPublicacionHidden.getValue());
        	if(nombreFormatoHidden.getSubmittedValue()!=null
        			&& !nombreFormatoHidden.getSubmittedValue().toString().equals(""))
        		this.setNombreFormatoNewUpdate((String)nombreFormatoHidden.getSubmittedValue());
        	else
        		this.setNombreFormatoNewUpdate((String)nombreFormatoHidden.getValue());
        	if(tipoFormatoHidden.getSubmittedValue()!=null 
        			&& !tipoFormatoHidden.getSubmittedValue().equals(""))
        		this.setTipoFormato(Integer.parseInt(tipoFormatoHidden.getSubmittedValue().toString()));
        	else
        		this.setTipoFormato(Integer.parseInt(tipoFormatoHidden.getValue().toString()));
        	if(altoFormatoHidden.getSubmittedValue()!=null 
        			&& !altoFormatoHidden.getSubmittedValue().toString().equals(""))
        		alto = (String)altoFormatoHidden.getSubmittedValue();
        	else
        		alto = (String)altoFormatoHidden.getValue();
        	if(anchoFormatoHidden.getSubmittedValue()!=null 
        			&& !anchoFormatoHidden.getSubmittedValue().toString().equals(""))
        		ancho = (String)anchoFormatoHidden.getSubmittedValue();
        	else
        		alto = (String)anchoFormatoHidden.getValue();
        }catch(Exception e){
        	//Nada
        }
    	lsFormatoPublicaciones = mb.obtenerDetallesFormato(this.idPublicacion, this.idFormato, bean, getIdUsuario());
		this.setRespuestaFormatoNewUpdate(mb.agregarActualizarFormato(this.idFormato, this.nombreFormatoNewUpdate, this.tipoFormato, 
				alto, ancho, this.idsPublicacionesHidden, getIdUsuario(), bean, lsFormatoPublicaciones));
    	if(this.nombreFormatoNewUpdate!=null && !this.nombreFormatoNewUpdate.equals(""))
    		decodeRespuestaFormato(this.respuestaFormatoNewUpdate, this.tipoFormato);
    	if(this.tipoFormato==1){//formatoEspecial
			sAlto.setDisabled(false);
			sAlto.setValue(0);
			sAlto.setEnableManualInput(true);
			sAncho.setDisabled(false);
			sAncho.setValue(0);
			sAncho.setEnableManualInput(true);
			this.setAltoDisabled(false);
			this.setAltoRequired(true);
			this.setAnchoDisabled(false);
			this.setAnchoRequired(true);
		}else{
			sAncho.setValue(ancho);
			sAncho.setSubmittedValue(ancho);
			sAncho.setEnableManualInput(false);
			sAncho.setDisabled(true);
			sAlto.setValue(alto);
			sAlto.setSubmittedValue(alto);
			sAlto.setEnableManualInput(false);
			sAlto.setDisabled(true);
		}
    	setPublicacionSlave(event);
    	System.out.println("<-- PedidoBBean.updateFormato()");
    }

	public void setFormaPagoRestanteSlave(ActionEvent event) throws Exception {
		System.out.println("--> PedidoBBean.setFormaPagoRestanteSlave");
		setDatos();
		FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
        UISelectOne selectFormaPago = (UISelectOne)form.findComponent("formasPagoList");
        this.setIdFormaPago(Integer.parseInt(selectFormaPago.getSubmittedValue().toString()));
        UISelectOne selectFormaPagoRestante = (UISelectOne)form.findComponent("formasPagoRestanteList");
        this.setIdFormaPagoRestante(Integer.parseInt(selectFormaPagoRestante.getSubmittedValue().toString()));
        UISelectOne selectCon = (UISelectOne)form.findComponent("conveniosList");
        String convenio = (String)selectCon.getSubmittedValue().toString();
        decodeConvenio(convenio);
        int idConvenio = 0;
        int idFormaPagoConvenio = 0;
        UIInput montRes = (UIInput)form.findComponent("montoRestante");
        String montoRestante = (String)montRes.getSubmittedValue();
        PedidoMBean mb = new PedidoMBean();
        List<PedidoBBean> listaFormasPago = new ArrayList<PedidoBBean>();
        List<PedidoBBean> listaFormasPagoConvenio = new ArrayList<PedidoBBean>();
    	List<PedidoBBean> listaTiposVenta = new ArrayList<PedidoBBean>();
    	selectItemsSlaveFormasPago = new ArrayList<SelectItem>();
        selectItemsSlaveTiposVenta = new ArrayList<SelectItem>();
        listaFormasPago = mb.obtenerFormasPago();
        boolean estaEnListaFormasPago = false;
        System.out.println("	--> convenio "+convenio);
        System.out.println("	--> this.idConvenio "+this.idConvenio);
        System.out.println("	--> this.idFormaPago "+this.idFormaPago);
        System.out.println("	--> this.idFormaPagoRestante "+this.idFormaPagoRestante);
        if(this.idConvenio!=0 && this.idConvenio!=-1){
        	try{
        		String[] convenioFormaPago = convenio.trim().split("\\|");
        		idConvenio = Integer.parseInt(convenioFormaPago[0]);
        		idFormaPagoConvenio = Integer.parseInt(convenioFormaPago[1]);
        	}catch(Exception e){
        		//Nada
        	}
        	this.setIdFormaPago(idFormaPagoConvenio);
        }
        System.out.println("	##--> this.idConvenio "+this.idConvenio);
        System.out.println("	##--> montoRestante "+montoRestante);
        if(this.idConvenio!=0 && this.idConvenio!=-1){
	    	System.out.println("---this.setIdFormaPago "+this.idFormaPago);
	    	System.out.println("---this.setIdFormaPagoRestante "+this.idFormaPagoRestante);
	    	listaFormasPagoConvenio = mb.obtenerTipoVentaFormaPago(idConvenio, idFormaPagoConvenio);
	    	if(this.idFormaPago!=0 && this.idFormaPago!=-1){
	        	System.out.println("---listaFormasPagoConvenio.size() "+listaFormasPagoConvenio.size());
	        	if(listaFormasPagoConvenio.size()>1){
	        		for(int i=0; i<listaFormasPagoConvenio.size(); i++){
	        			System.out.println("*** "+i+" ---listaFormasPagoConvenio.get(i).getIdFormaPago()==this.idFormaPagoRestante "
	        					+listaFormasPagoConvenio.get(i).getIdFormaPago()+" == "+this.idFormaPagoRestante);
	        			if(listaFormasPagoConvenio.get(i).getIdFormaPago()==this.idFormaPagoRestante){
	        				estaEnListaFormasPago=true;
	        				selectItemsSlaveFormasPago.add(new SelectItem(listaFormasPagoConvenio.get(i).getIdFormaPago(), 
	        						listaFormasPagoConvenio.get(i).getNombreFormaPago()));
	        			}else if(this.idFormaPagoRestante!=0 && this.idFormaPagoRestante!=-1){
	        				this.setIdFormaPago(5);
	        			}else{
	        				selectItemsSlaveFormasPago.add(new SelectItem(listaFormasPagoConvenio.get(i).getIdFormaPago(), 
	        						listaFormasPagoConvenio.get(i).getNombreFormaPago()));
	        			}
	        		}
	        		System.out.println("---this.estaEnListaFormasPago "+estaEnListaFormasPago);
	    			if(this.idFormaPago==5 && !estaEnListaFormasPago){
	    				selectItemsSlaveFormasPago.clear();
	    				selectItemsSlaveFormasPago.add(new SelectItem("5","MIXTO"));
	    			}
	        	}else{
	        		if(idFormaPagoConvenio==this.idFormaPagoRestante){
	    	        	//conserva la lista de forma pago que esta preguntar si a un convenio le corresponde solo una forma de pago
	    	    		for(int i=0; i<listaFormasPago.size(); i++){
	    	    			if(idFormaPagoConvenio==listaFormasPago.get(i).getIdFormaPago())
	    	    				selectItemsSlaveFormasPago.add(new SelectItem(listaFormasPago.get(i).getIdFormaPago(), 
	    	    						listaFormasPago.get(i).getNombreFormaPago()));
	    	    		}
	    	        }else if(this.idFormaPagoRestante!=0 && this.idFormaPagoRestante!=-1){
	    	        	//obten la nueva lista que solo contendra mixto
	    	        	this.setIdFormaPago(5);
	    	        	for(int i=0; i<listaFormasPago.size(); i++){
	    	    			if(this.idFormaPago==listaFormasPago.get(i).getIdFormaPago())
	    	    				selectItemsSlaveFormasPago.add(new SelectItem(listaFormasPago.get(i).getIdFormaPago(), 
	    	    						listaFormasPago.get(i).getNombreFormaPago()));
	    	    		}
	    	        }else{
	    	        	for(int i=0; i<listaFormasPagoConvenio.size(); i++){
		    	        	selectItemsSlaveFormasPago.add(new SelectItem(listaFormasPagoConvenio.get(i).getIdFormaPago(), 
	        						listaFormasPagoConvenio.get(i).getNombreFormaPago()));
	    	        	}
	    	        }
	        	}
	        }
	        mb.obtenerMontoRestanteConvenio(this.idCliente, this.idPublicacion, this.idConvenio, this.fechaPublicacionString, 
					this.valorEspecial, this.tipoValoracion, this.idTarifa, this.idRegion, this.idFormato, this.tipoFormato, this.altoFormato, 
					this.anchoFormato, null, null);
        }else{
        	if(this.idConvenio!=0 && this.idConvenio!=-1){
        		for(int i=0; i<listaFormasPago.size(); i++){
        			if(this.idFormaPago==listaFormasPago.get(i).getIdFormaPago())
	    				selectItemsSlaveFormasPago.add(new SelectItem(listaFormasPago.get(i).getIdFormaPago(), 
	    						listaFormasPago.get(i).getNombreFormaPago()));
        		}
        	}else{
        		for(int i=0; i<listaFormasPago.size(); i++){
       				selectItemsSlaveFormasPago.add(new SelectItem(listaFormasPago.get(i).getIdFormaPago(), 
       						listaFormasPago.get(i).getNombreFormaPago()));
        		}
        	}
        }
        if(this.idFormaPago!=0 && this.idFormaPago!=-1)
    		listaTiposVenta = mb.obtenerTiposVentaFormaPago(this.idFormaPago);
    	else
    		listaTiposVenta = mb.obtenerTiposVenta();
    	if(listaTiposVenta.size()==0) selectItemsSlaveTiposVenta.add(new SelectItem("-1", "-sin tipos venta-"));
		if(listaTiposVenta.size()>1) selectItemsSlaveTiposVenta.add(new SelectItem("0", "Seleccione..."));
		for(int i=0; i<listaTiposVenta.size(); i++)
			selectItemsSlaveTiposVenta.add(new SelectItem(listaTiposVenta.get(i).getIdTipoVenta(), 
					listaTiposVenta.get(i).getNombreTipoVenta()));
		System.out.println("<-- PedidoBBean.setFormaPagoRestanteSlave "+this.idFormaPagoRestante);
	}
    
    /*******************************************************/
    public void setAgregarAnuncio(ActionEvent event) throws Exception{
		System.out.println("**********************--> PedidoBBean.agregarAnuncio() ");
		PedidoMBean mb = new PedidoMBean();
		ConvenioPedidoBBean convenioBean = new ConvenioPedidoBBean();
		FacesContext context = javax.faces.context.FacesContext.getCurrentInstance();
		UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
	    HttpServletRequest request = (HttpServletRequest) context.getExternalContext().getRequest();
		request.setAttribute("convenioPedidoBean", convenioBean);
		DetallePedidoBBean detallePedidoBean = (DetallePedidoBBean) request.getAttribute("detallePedidoBean");
		System.out.println("**********************-->valor  "+detallePedidoBean.getHtmlListaDetalleRegion().getValue());
		
		//try{
			setDatos();
	        System.out.println("********************** valores: ");
	        System.out.println(" IdPublicacion: "+this.getIdPublicacion());
	        System.out.println(" TipoPublicacion: "+this.getTipoPublicacion());
	        System.out.println(" IdCliente: "+this.getIdCliente());
	        System.out.println(" IdEjecutivo: "+this.getIdEjecutivo());
	        System.out.println(" isEjecutivoRequired: "+this.isEjecutivoRequired());
	        //termina primer renglon
	        System.out.println(" IdAgencia: "+this.getIdAgencia());
	        System.out.println(" isAgenciaRequired: "+this.isAgenciaRequired());
	        System.out.println(" IdComisionista: "+this.getIdComisionista());
	        System.out.println(" PorcentajeComisionista: "+this.getPorcentajeComisionista());
	        System.out.println(" TipoOrden: "+this.getTipoOrden());
	        //termina segundo renglon
	        System.out.println(" NumeroOrden: "+this.getNumeroOrden());
	        System.out.println(" FechaPublicacionDate: "+this.getFechaPublicacionDate());
	        System.out.println(" FechaPublicacionString: "+this.getFechaPublicacionString());
	        System.out.println(" IdProducto: "+this.getIdProducto());
	        System.out.println(" IdVersion: "+this.getIdVersion());
	        System.out.println(" IdRegion: "+this.getIdRegion());
	        //termina tercer renglon
	        System.out.println(" IdTarifa: "+this.getIdTarifa());
	        System.out.println(" TipoValoracion: "+this.getTipoValoracion());
	        System.out.println(" ValorEspecial: "+this.getValorEspecial());
	        System.out.println(" IdSuplemento: "+this.getIdSuplemento());
	        System.out.println(" IdConvenio: "+this.getIdConvenio());
	        System.out.println(" IdEvento: "+this.getIdEvento());
	        //termina cuarto renglon
	        System.out.println(" IdFormaPago: "+this.getIdFormaPago());
	        System.out.println(" IdTipoVenta: "+this.getIdTipoVenta());
	        System.out.println(" IdFormato: "+this.getIdFormato());
	        System.out.println(" TipoFormato: "+this.getTipoFormato());
	        System.out.println(" AltoFormato: "+this.getAltoFormato());
	        System.out.println(" AnchoFormato: "+this.getAnchoFormato());
	        //termina quinto renglon
	        System.out.println(" IdPatrocinio: "+this.getIdPatrocinio());
	        System.out.println(" IdPosicion: "+this.getIdPosicion());
	        System.out.println(" IdSeccion: "+this.getIdSeccion());
	        System.out.println(" Observaciones: "+this.getObservaciones());
	        System.out.println("******************************* ");
	        //PESTAAS-PATRAAS
	        System.out.println("**********************PESTAAS*******************");
	        UIInput detallesPedidoHidden = (UIInput)form.findComponent("detallesPedidoHidden");
	        this.setDetallesPedidoHidden(detallesPedidoHidden.getSubmittedValue().toString());
	        UIInput detallesConvenioHidden = (UIInput)form.findComponent("detallesConvenioHidden");
	        this.setDetallesConvenioHidden(detallesConvenioHidden.getSubmittedValue().toString());
	        UISelectOne selectFpmr = (UISelectOne)form.findComponent("formasPagoRestanteList");
	        if(selectFpmr!=null)
	        	this.setIdFormaPagoRestante(Integer.parseInt(selectFpmr.getSubmittedValue().toString()));
	        UIInput montoRestanteHidden = (UIInput)form.findComponent("montoRestanteHidden");
	        this.setMontoRestante((String)montoRestanteHidden.getSubmittedValue());
	        System.out.println("**********************this.getMontoRestante() "+this.getMontoRestante());
	        System.out.println("**********************montoRestanteHidden "+montoRestanteHidden.getSubmittedValue());
	        System.out.println("**********************this.getIdFormaPagoRestante() "+this.getIdFormaPagoRestante());
	        System.out.println("**********************this.getDetallesPedidoHidden() "+this.getDetallesPedidoHidden());
	        System.out.println("**********************this.getDetallesConvenioHidden() "+this.getDetallesConvenioHidden());
	        //INGRESO EN BASE DE DATOS
	        //metodo que verifique si ya hay registro (id_pedido) en base de este numero de pedido y agruege o bien incerte de nuevo
	        
	        mb.validarAgregarAnuncio(this);
	        
	    	//obtener las listas nuevamente
	        recuperarListas();
	    	
		    /*UIOutput error = (UIOutput)form.findComponent("errorPedido");
		    error.setValue("Ya fue a la BD");*/
		    //pedidoBBean.setErrorPedido(errorPedido);
			//request.removeAttribute("pedidoBBean");
		    //request.setAttribute("pedidoBBean", this);
		/*}catch(Exception e){
			System.out.println(" !! ERROR ********************** "+e);
			recuperarListas();
			this.setErrorPedidoSeccion2("Verifique los datos. Termine de capturar el anuncio. ");
		}*/
		//this.setErrorPedido("Revisar Pedido");
        System.out.println("**********************<-- PedidoBBean.agregarAnuncio() ");
	}
    
	public String eliminarAnuncio(){
		System.out.println("--> PedidoBBean.eliminarAnuncio() ");
		String exito="";
		System.out.println("<-- PedidoBBean.eliminarAnuncio() ");
		return exito;
	}	
	
	public String ingresarPedido(){
		System.out.println("--> PedidoBBean.ingresarPedido() ");
		String exito="";
		System.out.println("<-- PedidoBBean.ingresarPedido() ");
		return exito;
	}
	
	public void recuperarListas() throws Exception{
		//try{
			PedidoMBean mb = new PedidoMBean();
			List<PedidoBBean> listaEjecutivos = mb.obtenerEjecutivos(this.idPublicacion, this.idCliente);
	    	this.selectItemsSlaveEjecutivos.clear();
	    	if(listaEjecutivos.size()>0) this.selectItemsSlaveEjecutivos.add(new SelectItem("0", "Seleccione..."));
	    	if(listaEjecutivos.size()==0) this.selectItemsSlaveEjecutivos.add(new SelectItem("-1", "-sin ejecutivos-")); 
	    	for(int i=0; i<listaEjecutivos.size(); i++)
	    		this.selectItemsSlaveEjecutivos.add(
	    				new SelectItem(listaEjecutivos.get(i).getIdEjecutivo(), listaEjecutivos.get(i).getNombreEjecutivo()));

	    	List<PedidoBBean> listaAgencias = mb.obtenerAgencias(this.idCliente);
	    	this.selectItemsSlaveAgencias.clear();
	    	//if(listaAgencias.size()>1) selectItemsSlaveAgencias.add(new SelectItem("0", "Seleccione..."));
	    	if(listaAgencias.size()==0) this.selectItemsSlaveAgencias.add(new SelectItem("-1", "-sin agencias-")); 
	    	for(int i=0; i<listaAgencias.size(); i++){
	    		this.selectItemsSlaveAgencias.add(
	    				new SelectItem(listaAgencias.get(i).getIdAgencia(), listaAgencias.get(i).getNombreAgencia()));
				if(listaAgencias.get(i).isEsDefault()) 
					this.setIdAgencia(listaAgencias.get(i).getIdAgencia()); 
			}

	    	List<PedidoBBean> listaComisionistas = mb.obtenerComisionistas(this.idCliente, this.idPublicacion);
	    	this.selectItemsSlaveComisionistas.clear();
	    	if(listaComisionistas.size()>1)this.selectItemsSlaveComisionistas.add(new SelectItem("0", "Seleccione..."));
	    	if(listaComisionistas.size()==0){ 
	    		this.selectItemsSlaveComisionistas.add(new SelectItem("-1", "-sin comisionistas-"));
	    		this.setComisionistaRequired(false);
	    		this.setComisionistaPorcentajeRequired(false);
	    		this.setComisionistaPorcentajeDisabled(true);
			}
			for(int i=0; i<listaComisionistas.size(); i++)
				this.selectItemsSlaveComisionistas.add(
						new SelectItem(listaComisionistas.get(i).getIdComisionista(), 
								listaComisionistas.get(i).getNombreComisionista()));
			
			List<PedidoBBean> listaProductos = mb.obtenerProductos(this.idCliente);
			this.selectItemsSlaveProductos.clear();
			if(listaProductos.size()>1) selectItemsSlaveProductos.add(new SelectItem("0", "Seleccione..."));
	    	if(listaProductos.size()==0) this.selectItemsSlaveProductos.add(new SelectItem("-1", "-sin productos-")); 
			for(int i=0; i<listaProductos.size(); i++)
				this.selectItemsSlaveProductos.add(
						new SelectItem(listaProductos.get(i).getIdProducto(), listaProductos.get(i).getNombreProducto()));
			
			List<PedidoBBean> listaVersiones = mb.obtenerVersiones(this.idProducto);
			this.selectItemsSlaveVersiones.clear();
			if(listaVersiones.size()>1) selectItemsSlaveVersiones.add(new SelectItem("0", "Seleccione..."));
	    	if(listaVersiones.size()==0) this.selectItemsSlaveVersiones.add(new SelectItem("-1", "-sin versiones-")); 
			for(int i=0; i<listaVersiones.size(); i++)
				this.selectItemsSlaveVersiones.add(
						new SelectItem(listaVersiones.get(i).getIdVersion(), listaVersiones.get(i).getNombreVersion()));
			
			List<PedidoBBean> listaRegiones = mb.obtenerRegiones(this.idPublicacion);
			this.selectItemsSlaveRegiones.clear();
			if(listaRegiones.size()>1) selectItemsSlaveRegiones.add(new SelectItem("0", "Seleccione..."));
	    	if(listaRegiones.size()==0) this.selectItemsSlaveRegiones.add(new SelectItem("-1", "-sin regiones-")); 
			for(int i=0; i<listaRegiones.size(); i++)
				this.selectItemsSlaveRegiones.add(
						new SelectItem(listaRegiones.get(i).getIdRegion(), listaRegiones.get(i).getNombreRegion()));
			
			List<PedidoBBean> listaTarifas = mb.obtenerTarifas(this.idCliente, this.idPublicacion, this.fechaPublicacionString);
			this.selectItemsSlaveTarifas.clear();
			if(listaTarifas.size()>1) selectItemsSlaveTarifas.add(new SelectItem("0", "Seleccione..."));
			if(listaTarifas.size()==0) this.selectItemsSlaveTarifas.add(new SelectItem("-1", "-sin tarifas-"));
			for(int i=0; i<listaTarifas.size(); i++)
				this.selectItemsSlaveTarifas.add(
						new SelectItem(listaTarifas.get(i).getIdTarifa(), listaTarifas.get(i).getNombreTarifa()));
			
			List<PedidoBBean> listaSuplementos = mb.obtenerSuplementos(this.idPublicacion);
			this.selectItemsSlaveSuplementos.clear();
			if(listaSuplementos.size()>1) selectItemsSlaveSuplementos.add(new SelectItem("0", "Seleccione..."));
			if(listaSuplementos.size()==0){
				this.selectItemsSlaveSuplementos.add(new SelectItem("-1", "-sin suplementos-"));
				this.setSuplementoRequired(false);
			}
			for(int i=0; i<listaSuplementos.size(); i++)
				this.selectItemsSlaveSuplementos.add(
						new SelectItem(listaSuplementos.get(i).getIdSuplemento(), listaSuplementos.get(i).getNombreSuplemento()));
			
			List<PedidoBBean> listaConvenios = mb.obtenerConvenios(
					this.idCliente, this.idPublicacion, this.valorEspecial, this.tipoValoracion);
			this.selectItemsSlaveConvenios.clear();
			if(listaConvenios.size()>1) selectItemsSlaveConvenios.add(new SelectItem("0", "Seleccione..."));
			if(listaConvenios.size()==0) this.selectItemsSlaveConvenios.add(new SelectItem("-1", "-sin convenios-"));
			for(int i=0; i<listaConvenios.size(); i++)
				this.selectItemsSlaveConvenios.add(
						new SelectItem(listaConvenios.get(i).getConvenio(), listaConvenios.get(i).getNombreConvenio()));
			
			List<PedidoBBean> listaFormasPago = mb.obtenerFormasPago();
			this.selectItemsSlaveFormasPago.clear();
			if(listaFormasPago.size()>1) selectItemsSlaveFormasPago.add(new SelectItem("0", "Seleccione..."));
			if(listaFormasPago.size()==0) this.selectItemsSlaveFormasPago.add(new SelectItem("-1", "-sin formas pago-"));
			for(int i=0; i<listaFormasPago.size(); i++)
				this.selectItemsSlaveFormasPago.add(
						new SelectItem(listaFormasPago.get(i).getIdFormaPago(), listaFormasPago.get(i).getNombreFormaPago()));
			
			List<PedidoBBean> listaTiposVenta = mb.obtenerTiposVenta();
			this.selectItemsSlaveTiposVenta.clear();
			if(listaTiposVenta.size()>1) selectItemsSlaveTiposVenta.add(new SelectItem("0", "Seleccione..."));
			if(listaTiposVenta.size()==0) this.selectItemsSlaveTiposVenta.add(new SelectItem("-1", "-sin tipos venta-"));
			for(int i=0; i<listaTiposVenta.size(); i++)
				this.selectItemsSlaveTiposVenta.add(
						new SelectItem(listaTiposVenta.get(i).getIdTipoVenta(), listaTiposVenta.get(i).getNombreTipoVenta()));
			
			List<PedidoBBean> listaFormatos = mb.obtenerFormatos(this.idPublicacion);
			this.selectItemsSlaveFormatos.clear();
			if(listaFormatos.size()>1) selectItemsSlaveFormatos.add(new SelectItem("0", "Seleccione..."));
			if(listaFormatos.size()==0) this.selectItemsSlaveFormatos.add(new SelectItem("-1", "-sin formatos-"));
			for(int i=0; i<listaFormatos.size(); i++)
				this.selectItemsSlaveFormatos.add(
						new SelectItem(listaFormatos.get(i).getFormato(), listaFormatos.get(i).getNombreFormato()));
			
			List<PedidoBBean> listaPatrocinios = mb.obtenerPatrocinios(this.idPublicacion);
			this.selectItemsSlavePatrocinios.clear();
			if(listaPatrocinios.size()>1) selectItemsSlavePatrocinios.add(new SelectItem("0", "Seleccione..."));
			if(listaPatrocinios.size()==0){ 
				this.selectItemsSlavePatrocinios.add(new SelectItem("-1", "-sin patrocinios-"));
				this.setPatrocinioRequired(false);
			}
			for(int i=0; i<listaPatrocinios.size(); i++)
				this.selectItemsSlavePatrocinios.add(
						new SelectItem(listaPatrocinios.get(i).getIdPatrocinio(), listaPatrocinios.get(i).getNombrePatrocinio()));
			
			List<PedidoBBean> listaPosiciones = mb.obtenerPosiciones(this.idPublicacion);
			this.selectItemsSlavePosiciones.clear();
			if(listaPosiciones.size()>1) selectItemsSlavePosiciones.add(new SelectItem("0", "Seleccione..."));
			if(listaPosiciones.size()==0){
				this.selectItemsSlavePosiciones.add(new SelectItem("-1", "-sin posiciones-"));
				this.setPosicionRequired(false);
			}
			for(int i=0; i<listaPosiciones.size(); i++)
				this.selectItemsSlavePosiciones.add(
						new SelectItem(listaPosiciones.get(i).getIdPosicion(), listaPosiciones.get(i).getNombrePosicion()));
			
			List<PedidoBBean> listaSecciones = mb.obtenerSecciones(this.idPublicacion);
			this.selectItemsSlaveSecciones.clear();
			if(listaSecciones.size()>1) selectItemsSlaveSecciones.add(new SelectItem("0", "Seleccione..."));
			if(listaSecciones.size()==0){
				this.selectItemsSlaveSecciones.add(new SelectItem("-1", "-sin secciones-"));
				this.setPosicionRequired(false);
			}
			for(int i=0; i<listaSecciones.size(); i++)
				this.selectItemsSlaveSecciones.add(
						new SelectItem(listaSecciones.get(i).getIdSeccion(), listaSecciones.get(i).getNombreSeccion()));
		/*}catch(Exception e){
			
		}*/
	}
	/***********************BUSCADOR*************************/
	
	public void setBusquedaPublicacionSlave(ActionEvent event) throws Exception {
		System.out.println("--> PedidoBBean.setBusquedaPublicacionSlave() ");
		FacesContext context = FacesContext.getCurrentInstance();
		HttpSession session = (HttpSession)context.getExternalContext().getSession(true);
    	UIForm form = (UIForm)context.getViewRoot().findComponent("busquedaPedidoForm");
    	UISelectOne selectPublicacionesList = (UISelectOne)form.findComponent("publicacionesList");
        decodePublicacion((String)selectPublicacionesList.getSubmittedValue());
        PedidoMBean mb = new PedidoMBean();
        selectItemsSlaveRegiones = new ArrayList<SelectItem>();
        List<PedidoBBean> listaRegiones = new ArrayList<PedidoBBean>();
        listaRegiones = mb.obtenerRegiones(this.idPublicacion);
		this.setPeriodoPublicacion(mb.obtenerPeriodo(this.idPublicacion));
		this.setDisabledPublicacion(mb.obtenerDisabledPeriodo(this.idPublicacion));
		int idReg=0;
		if(listaRegiones.size()==0) 
			selectItemsSlaveRegiones.add(new SelectItem("-1", "-sin regiones-"));
		else
			idReg = listaRegiones.get(0).getIdRegion();
		for(int i=0; i<listaRegiones.size(); i++)
			selectItemsSlaveRegiones.add(new SelectItem(listaRegiones.get(i).getIdRegion(), listaRegiones.get(i).getNombreRegion()));
		session.setAttribute("idPub", this.idPublicacion);
		session.setAttribute("idReg", idReg);
		System.out.println("<-- PedidoBBean.setBusquedaPublicacionSlave() ");
	}
	
	public void setBusquedaRegionSlave(ActionEvent event) throws Exception {
    	System.out.println("--> PedidoBBean.setBusquedaRegionSlave() ");
    	FacesContext context = FacesContext.getCurrentInstance();
		HttpSession session = (HttpSession)context.getExternalContext().getSession(true);
    	UIForm form = (UIForm)context.getViewRoot().findComponent("busquedaPedidoForm");
    	UISelectOne selectReg = (UISelectOne)form.findComponent("regionesList");
    	this.setIdRegion(Integer.parseInt(selectReg.getSubmittedValue().toString()));
    	session.setAttribute("idReg", this.idRegion);
    	System.out.println("<-- PedidoBBean.setBusquedaRegionSlave() ");
    }
	
	public List<String> autoCompleteGrupoClientes(Object suggest) {
    	System.out.println("--> PedidoBBean.autoCompleteGpoClientes() ");
    	FacesContext context = FacesContext.getCurrentInstance();
    	UIForm form = (UIForm)context.getViewRoot().findComponent("busquedaPedidoForm");
    	UISelectOne selectPublicacionesList = (UISelectOne)form.findComponent("publicacionesList");
        decodePublicacion((String)selectPublicacionesList.getSubmittedValue());
        System.out.println("	--> PedidoBBean.autoCompleteGpoClientes() "+selectPublicacionesList.getSubmittedValue());
        PedidoMBean mb = new PedidoMBean();
        String cliente = (String) suggest;
        clientes = mb.obtenerGrupoClientes(getIdUsuario(), cliente);
        for(int i=0; i<clientes.size(); i++){
        	suggestListClientes.add(clientes.get(i).getNombreCliente()+" ("+clientes.get(i).idCliente+")");
        }
		ArrayList<String> result = new ArrayList<String>();
		Iterator<String> iterator = suggestListClientes.iterator();
		while (iterator.hasNext()) {
			String elem = ((String) iterator.next());
			result.add(elem);
		}
		System.out.println("<-- PedidoBBean.autoCompleteGpoClientes() ");
		return result;
	}
	
	public void setClienteBuscadorSlave(ActionEvent event) throws Exception {
    	System.out.println("--> PedidoBBean.setClienteBuscadorSlave() ");
    	FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("busquedaPedidoForm");
        UISelectOne selectAge = (UISelectOne)form.findComponent("agenciasList");
        HtmlInputText selectCli = (HtmlInputText)form.findComponent("clientesSelect");
        decodeCliente((String)selectCli.getSubmittedValue());
    	selectItemsSlaveAgencias = new ArrayList<SelectItem>();
		PedidoMBean mb = new PedidoMBean();
		List<PedidoBBean> listaAgencias = new ArrayList<PedidoBBean>();
		System.out.println("	this.idCliente: "+this.idCliente);
		if(this.idCliente!=0){
			listaAgencias = mb.obtenerAgenciasGrupoClientes(getIdUsuario(), this.idCliente);
			System.out.println("	listaAgencias: "+listaAgencias.size());
			if(listaAgencias.size()==0){
				selectItemsSlaveAgencias.add(new SelectItem("-1", "-sin agencias-"));
				this.setIdAgencia(0);
			}
			if(listaAgencias.size()>1) selectItemsSlaveAgencias.add(new SelectItem("0", "TODAS LAS AGENCIAS"));
			for(int i=0; i<listaAgencias.size(); i++){
				selectItemsSlaveAgencias.add(new SelectItem(listaAgencias.get(i).getIdAgencia(), listaAgencias.get(i).getNombreAgencia()));
				if(listaAgencias.get(i).isEsDefault()){
					this.setIdAgencia(listaAgencias.get(i).getIdAgencia());
					selectAge.setSubmittedValue(this.getIdAgencia());
				}
			}
		}
		System.out.println("<-- PedidoBBean.setClienteBuscadorSlave() ");
    }
	
	public void setTipoBusquedaSlave(ActionEvent event) throws Exception {
		System.out.println("--> PedidoBBean.setTipoBusquedaSlave() ");
		FacesContext context = FacesContext.getCurrentInstance();
		UIForm form = (UIForm)context.getViewRoot().findComponent("busquedaPedidoForm");
		UIInput radioTipBusqueda = (UIInput)form.findComponent("radioTipoBusqueda");
		int tipoBusqueda = Integer.parseInt(radioTipBusqueda.getSubmittedValue().toString());
		if(tipoBusqueda==0)
			this.setDetalleEdicion("");
		else
			setBusquedaEdicionSlave(event);
		System.out.println("<-- PedidoBBean.setTipoBusquedaSlave() ");
	}
	
	public List<String> autoCompleteEdiciones(Object suggest) throws Exception {
    	System.out.println("--> PedidoBBean.autoCompleteEdiciones() "+this.publicacion+"-"+this.idPublicacion);
    	FacesContext context = FacesContext.getCurrentInstance();
		HttpSession session = (HttpSession)context.getExternalContext().getSession(true);
		int idPub = 0;
		int idReg = 0;
		try{
	    	idPub = Integer.parseInt(session.getAttribute("idPub").toString());
	    	idReg = Integer.parseInt(session.getAttribute("idReg").toString());
		}catch(Exception e){
			//nada
		}
        PedidoMBean mb = new PedidoMBean();
        String edicion = (String) suggest;
        System.out.println("	--> PedidoBBean.autoCompleteEdiciones() "+idPub);
        ediciones = mb.obtenerEdiciones(getIdUsuario(), idPub, idReg, edicion);
        for(int i=0; i<ediciones.size(); i++)
        	suggestListEdiciones.add(ediciones.get(i).getNumeroEdicion());
		ArrayList<String> result = new ArrayList<String>();
		Iterator<String> iterator = suggestListEdiciones.iterator();
		while (iterator.hasNext()) {
			String elem = ((String) iterator.next());
			result.add(elem);
		}
		System.out.println("<-- PedidoBBean.autoCompleteEdiciones() ");
		return result;
	}
	
	public void setBusquedaEdicionSlave(ActionEvent event) throws Exception{
		System.out.println("--> PedidoBBean.setBusquedaEdicionSlave() ");
		FacesContext context = FacesContext.getCurrentInstance();
		UIForm form = (UIForm)context.getViewRoot().findComponent("busquedaPedidoForm");
		UISelectOne selectPublicacionesList = (UISelectOne)form.findComponent("publicacionesList");
        decodePublicacion((String)selectPublicacionesList.getSubmittedValue());
        UISelectOne selectReg = (UISelectOne)form.findComponent("regionesList");
    	this.setIdRegion(Integer.parseInt(selectReg.getSubmittedValue().toString()));
    	UICalendar fechaEdicion = (UICalendar)form.findComponent("calendarEdicion");
    	System.out.println("	--> fechaEdicion "+fechaEdicion.getSubmittedValue());
    	HtmlInputText selectEdi = (HtmlInputText)form.findComponent("edicionesSelect");
    	PedidoMBean mb = new PedidoMBean();
    	this.setNumeroEdicion((String)selectEdi.getSubmittedValue());
    	ediciones = mb.obtenerEdiciones(getIdUsuario(), this.idPublicacion, this.idRegion, this.numeroEdicion);
    	if(ediciones!=null && !ediciones.isEmpty()){
    		this.setFechaPublicacionDate(ediciones.get(0).getFechaPublicacionDate());
    		this.setDetalleEdicion("Tipo de Edicion:&nbsp; "+ediciones.get(0).getTipoEdicion()
    				+".&nbsp; Estatus:&nbsp; "+ediciones.get(0).getEstatusEdicion()
    				+".&nbsp; Fecha:&nbsp; "+ediciones.get(0).getFechaPublicacionString());
    	}
    	fechaEdicion.setSubmittedValue(this.fechaPublicacionDate);
		System.out.println("<-- PedidoBBean.setBusquedaEdicionSlave() "+this.fechaPublicacionDate);
	}
	
	public List<String> autoCompleteOrdenes(Object suggest) {
    	System.out.println("--> PedidoBBean.autoCompleteOrdenes() ");
    	FacesContext context = FacesContext.getCurrentInstance();
    	UIForm form = (UIForm)context.getViewRoot().findComponent("busquedaPedidoForm");
        UISelectOne selectPublicacionesList = (UISelectOne)form.findComponent("publicacionesList");
        decodePublicacion((String)selectPublicacionesList.getSubmittedValue());
        HtmlInputText selectCli = (HtmlInputText)form.findComponent("clientesSelect");
        decodeCliente((String)selectCli.getSubmittedValue());
        PedidoMBean mb = new PedidoMBean();
        String orden = (String) suggest;
        ordenes = mb.obtenerOrdenes(getIdUsuario(), this.idPublicacion, this.idCliente, orden);
        for(int i=0; i<ordenes.size(); i++){
        	suggestListOrdenes.add(ordenes.get(i).getNumeroOrden());
        }
		ArrayList<String> result = new ArrayList<String>();
		Iterator<String> iterator = suggestListOrdenes.iterator();
		while (iterator.hasNext()) {
			String elem = ((String) iterator.next());
			result.add(elem);
		}
		System.out.println("<-- PedidoBBean.autoCompleteOrdenes() ");
		return result;
	}
	
	public void buscarPedido(ActionEvent event) throws Exception{
		System.out.println("--> PedidoBBean.buscarPedido() ");
		FacesContext context = FacesContext.getCurrentInstance();
        UIForm form = (UIForm)context.getViewRoot().findComponent("busquedaPedidoForm");
        UISelectOne selectPublicacionesList = (UISelectOne)form.findComponent("publicacionesList");
        decodePublicacion((String)selectPublicacionesList.getSubmittedValue());
        UIInput tipoBusqueda = (UISelectOne)form.findComponent("radioTipoBusqueda");
        this.setTipoBusqueda(Integer.parseInt(tipoBusqueda.getSubmittedValue().toString()));
        HtmlInputText numEdic = (HtmlInputText)form.findComponent("edicionesSelect");
        this.setNumeroEdicion((String)numEdic.getSubmittedValue());
        UICalendar fechaEdicion = (UICalendar)form.findComponent("calendarEdicion");
        dateString2Date((String)fechaEdicion.getSubmittedValue());
        UICalendar fechaInicial = (UICalendar)form.findComponent("fechaPublicacionInicio");
        dateBusquedaString2Date((String)fechaInicial.getSubmittedValue(), 1);
        UICalendar fechaFinal = (UICalendar)form.findComponent("fechaPublicacionFin");
        dateBusquedaString2Date((String)fechaFinal.getSubmittedValue(), 0);
        HtmlInputText selectCli = (HtmlInputText)form.findComponent("clientesSelect");
        decodeCliente((String)selectCli.getSubmittedValue());
        UISelectOne selectAge = (UISelectOne)form.findComponent("agenciasList");
        this.setIdAgencia(Integer.parseInt(selectAge.getSubmittedValue().toString()));
        HtmlInputText numOrd = (HtmlInputText)form.findComponent("ordenesSelect");
        this.setNumeroOrden((String)numOrd.getSubmittedValue());
        System.out.println("	this.idPublicacion "+this.idPublicacion);
        System.out.println("	this.numeroEdicion "+this.numeroEdicion);
        System.out.println("	this.fechaPublicacionString "+this.fechaPublicacionString);
        System.out.println("	this.fechaBusquedaIniString "+this.fechaBusquedaIniString);
        System.out.println("	this.fechaBusquedaFinString "+this.fechaBusquedaFinString);
        System.out.println("	this.idCliente "+this.idCliente);
        System.out.println("	this.idAgencia "+this.idAgencia);
        System.out.println("	this.numeroOrden "+this.numeroOrden);
		System.out.println("<-- PedidoBBean.buscarPedido() ");
	}
	
	public void setDatos() throws Exception{
		try{
			FacesContext context = FacesContext.getCurrentInstance();
	        UIForm form = (UIForm)context.getViewRoot().findComponent("pedidoForm");
	        UISelectOne selectPublicacionesList = (UISelectOne)form.findComponent("publicacionesList");
	        decodePublicacion((String)selectPublicacionesList.getSubmittedValue());
	        HtmlInputText selectCli = (HtmlInputText)form.findComponent("clientesSelect");
	        decodeCliente((String)selectCli.getSubmittedValue());
	        UISelectOne selectEje = (UISelectOne)form.findComponent("ejecutivosList");
	       	this.setIdEjecutivo(Integer.parseInt(selectEje.getSubmittedValue().toString()));
	        UISelectOne selectAge = (UISelectOne)form.findComponent("agenciasList");
	        this.setIdAgencia(Integer.parseInt(selectAge.getSubmittedValue().toString()));
	        UISelectOne selectCom = (UISelectOne)form.findComponent("comisionistasList");
	        this.setIdComisionista(Integer.parseInt(selectCom.getSubmittedValue().toString()));
	        HtmlInputNumberSpinner spinnerCom = (HtmlInputNumberSpinner)form.findComponent("spinnerPorcentajeComisionista");
	        this.setPorcentajeComisionista((Double)spinnerCom.getSubmittedValue());
	        UIInput radioTipOrd = (UIInput)form.findComponent("radioTipoOrden");
	        this.setTipoOrden(Integer.parseInt(radioTipOrd.getSubmittedValue().toString()));
	        UIInput numeroOrd = (UIInput)form.findComponent("numOrden");
	        this.setNumeroOrden((String)numeroOrd.getSubmittedValue());
	        UICalendar fechaPublicacion = (UICalendar)form.findComponent("fechaPublicacion");
	        dateString2Date((String)fechaPublicacion.getSubmittedValue());
	        UISelectOne selectPro = (UISelectOne)form.findComponent("productosList");
	        this.setIdProducto(Integer.parseInt(selectPro.getSubmittedValue().toString()));
	        UISelectOne selectVer = (UISelectOne)form.findComponent("versionesList");
	        this.setIdVersion(Integer.parseInt(selectVer.getSubmittedValue().toString()));
	        UISelectOne selectReg = (UISelectOne)form.findComponent("regionesList");
	        this.setIdRegion(Integer.parseInt(selectReg.getSubmittedValue().toString()));
	        UISelectOne selectTar = (UISelectOne)form.findComponent("tarifasList");
	        this.setIdTarifa(Integer.parseInt(selectTar.getSubmittedValue().toString()));
	        UIInput radioTipVal = (UIInput)form.findComponent("radioTipoValoracion");
	        this.setTipoValoracion((String)radioTipVal.getSubmittedValue());
	        UIInput valorEsp = (UIInput)form.findComponent("valorEspecial");
	        this.setValorEspecial((String)valorEsp.getSubmittedValue());
	        UISelectOne selectSup = (UISelectOne)form.findComponent("suplementosList");
	        this.setIdSuplemento(Integer.parseInt(selectSup.getSubmittedValue().toString()));
	        UISelectOne selectCon = (UISelectOne)form.findComponent("conveniosList");
	        decodeConvenio((String)selectCon.getSubmittedValue());
	        UISelectOne selectEve = (UISelectOne)form.findComponent("eventosList");
	        this.setIdEvento(Integer.parseInt(selectEve.getSubmittedValue().toString()));
	        UISelectOne selectFor = (UISelectOne)form.findComponent("formasPagoList");
	        this.setIdFormaPago(Integer.parseInt(selectFor.getSubmittedValue().toString()));
	        UISelectOne selectTip = (UISelectOne)form.findComponent("tiposVentaList");
	        this.setIdTipoVenta(Integer.parseInt(selectTip.getSubmittedValue().toString()));
	        UISelectOne selectFmt = (UISelectOne)form.findComponent("formatosList");
	        this.setFormato((String)selectFmt.getSubmittedValue());
	        decodeFormato(this.getFormato());
	        HtmlInputNumberSpinner spinnerAlt = (HtmlInputNumberSpinner)form.findComponent("spinnerAlto");
	        this.setAltoFormato(decodeAltoAncho((String)spinnerAlt.getSubmittedValue()));
	        HtmlInputNumberSpinner spinnerAnc = (HtmlInputNumberSpinner)form.findComponent("spinnerAncho");
	        this.setAnchoFormato(decodeAltoAncho((String)spinnerAnc.getSubmittedValue()));
	        UISelectOne selectPat = (UISelectOne)form.findComponent("patrociniosList");
	        this.setIdPatrocinio(Integer.parseInt(selectPat.getSubmittedValue().toString()));
	        UISelectOne selectPos = (UISelectOne)form.findComponent("posicionesList");
	        this.setIdPosicion(Integer.parseInt(selectPos.getSubmittedValue().toString()));
	        UISelectOne selectSec = (UISelectOne)form.findComponent("seccionesList");
	        this.setIdSeccion(Integer.parseInt(selectSec.getSubmittedValue().toString()));
	        UIInput observ = (UIInput)form.findComponent("observaciones");
	        this.setObservaciones((String)observ.getSubmittedValue());
		}catch(Exception e){
			//System.out.println("!! ERROR en setDatos: "+e);
		}
	}
	
	public Locale getLocale(){return Locale.US;}
	
	private int getIdUsuario() {
    	HttpSession session = (HttpSession)FacesContext.getCurrentInstance().getExternalContext().getSession(true);
    	int idUsuario = Integer.parseInt(session.getAttribute("idUsuario").toString());
    	return idUsuario;
	}
	
	private void decodePublicacion(String submittedValue) {
    	if(submittedValue!=null && !submittedValue.equals("") && !submittedValue.equals("0") && !submittedValue.equals("-1")){
    		this.setPublicacion(submittedValue);
    		this.setTipoPublicacion(Integer.parseInt(submittedValue.substring(0,1)));
    		this.setIdPublicacion(Integer.parseInt(submittedValue.substring(2, this.publicacion.length())));
    	}
	}
    
    private void decodeCliente(String submittedValue) {
    	if(submittedValue!=null && !submittedValue.equals("") && !submittedValue.equals("0") && !submittedValue.equals("-1")){
    		try{
        		Integer.parseInt(submittedValue);
            	this.setIdCliente(Integer.parseInt(submittedValue.trim()));
        	}catch (Exception e) {
    			char c[] = submittedValue.toCharArray();
    			String s="";
    			int id=0;
    			for(int i=0; i<c.length; i++){
    				s = Character.toString(c[i]); 
    				if(s.equals("("))
    					id=Integer.parseInt(submittedValue.substring(i+1, submittedValue.length()-1));
    			}
    			this.setIdCliente(id);
        	}
    	}
	}
    
    private void decodeMedidasEspeciales(Object alto, Object ancho) {
    	if(alto!=null){
    		String sAlto = alto.toString();
    		if(!sAlto.startsWith("org."))
    			this.setAltoFormato(sAlto.toString());
    		else
    			this.setAltoFormato("");
    	}
    	if(ancho!=null){
    		String sAncho = ancho.toString();
    		if(!sAncho.startsWith("org."))
                this.setAnchoFormato(sAncho.toString());
    		else
                this.setAnchoFormato("");
    	}
	}
    
    private String decodeFecha(String fecha, boolean isFechaModal){
		if(fecha!=null && !fecha.equals("")){
			String dia = "";
	    	String mes = "";
	    	String anio = "";
			if(isFechaModal){
				System.out.println("	fecha "+fecha);
				dia = fecha.substring(8,10);
    	    	mes = fecha.substring(4,7).toLowerCase();
    	    	anio = fecha.substring(11,15);
			}else{
    	    	dia = fecha.substring(0,2);
    	    	mes = fecha.substring(5,8).toLowerCase();
    	    	anio = fecha.substring(11,15);
			}
	    	if(mes.equals("ene")||mes.equals("jan"))mes="01";
	    	else if(mes.equals("feb")||mes.equals("feb"))mes="02";
	    	else if(mes.equals("mar")||mes.equals("mar"))mes="03";
	    	else if(mes.equals("abr")||mes.equals("apr"))mes="04";
	    	else if(mes.equals("may")||mes.equals("may"))mes="05";
	    	else if(mes.equals("jun")||mes.equals("jun"))mes="06";
	    	else if(mes.equals("jul")||mes.equals("jul"))mes="07";
	    	else if(mes.equals("ago")||mes.equals("aug"))mes="08";
	    	else if(mes.equals("sep")||mes.equals("sep"))mes="09";
	    	else if(mes.equals("oct")||mes.equals("oct"))mes="10";
	    	else if(mes.equals("nov")||mes.equals("nov"))mes="11";
	    	else if(mes.equals("dic")||mes.equals("dec"))mes="12";
	    	fecha = dia+"/"+mes+"/"+anio;
    	}
    	return fecha;
    }
    
    private void dateString2Date(String fecha) throws Exception {
    	if(fecha!=null && !fecha.equals("")){
	    	fecha = decodeFecha(fecha, false);
			DateFormat df = new SimpleDateFormat("dd/MM/yyyy");
			DateFormat dfs = DateFormat.getDateInstance(DateFormat.SHORT, Locale.US);
	        try{
	            Date fechaPublicacion = df.parse(fecha);  
	            this.setFechaPublicacionDate(fechaPublicacion);
	            this.setFechaPublicacionString(dfs.format(fechaPublicacion));//dd/MM/yy
	        } catch (ParseException e){
	            e.printStackTrace();
	        }
    	}
	}
    
    private void dateEventoString2Date(String fechaInicio, String fechaFin) throws Exception {
    	System.out.println("************************" +fechaInicio);
    	System.out.println("************************" +fechaFin);
    	fechaInicio = decodeFecha(fechaInicio, true);
    	fechaFin = decodeFecha(fechaFin, true);
    	if(fechaInicio!=null && !fechaInicio.equals("") && fechaFin!=null && !fechaFin.equals("")){
    		DateFormat df = new SimpleDateFormat("dd/MM/yyyy");
    		DateFormat dfs = DateFormat.getDateInstance(DateFormat.SHORT, Locale.US);
	        try{
	            Date fechaEventoInicio = df.parse(fechaInicio);  
	            this.setFechaEventoInicioDate(fechaEventoInicio);
	            this.setFechaEventoInicioString(dfs.format(fechaEventoInicio));//dd/MM/yy
	            Date fechaEventoFin = df.parse(fechaFin);  
	            this.setFechaEventoFinDate(fechaEventoFin);
	            this.setFechaEventoFinString(dfs.format(fechaEventoFin));//dd/MM/yy
	        } catch (ParseException e){
	            e.printStackTrace();
	        }
	        if(this.fechaEventoInicioDate.after(this.fechaEventoFinDate))
	        	this.setRespuestaEventoNewUpdate("La fecha Inicial debe ser igual o anterior a la fecha Final del evento.");
		}else
			this.setRespuestaEventoNewUpdate("Debe seleccionar una fecha para el Inicio y Fin del evento.");
	}
    
    private void dateTarifaString2Date(String fechaInicio, String fechaFin) throws Exception {
    	System.out.println("************************" +fechaInicio);
    	System.out.println("************************" +fechaFin);
    	if(fechaInicio.length()>=15)
    		fechaInicio = decodeFecha(fechaInicio, true);
    	if(fechaFin.length()>=15)
    		fechaFin = decodeFecha(fechaFin, true);
    	System.out.println("************************" +fechaInicio);
    	System.out.println("************************" +fechaFin);
    	if(fechaInicio!=null && !fechaInicio.equals("") && fechaFin!=null && !fechaFin.equals("")){
    		DateFormat df = new SimpleDateFormat("dd/MM/yyyy");
    		DateFormat dfs = DateFormat.getDateInstance(DateFormat.SHORT, Locale.US);
	        try{
	            Date fechaTarifaInicio = df.parse(fechaInicio);  
	            this.setFechaTarifaInicioDate(fechaTarifaInicio);
	            this.setFechaTarifaInicioString(dfs.format(fechaTarifaInicio));//dd/MM/yy
	            Date fechaTarifaFin = df.parse(fechaFin);  
	            this.setFechaTarifaFinDate(fechaTarifaFin);
	            this.setFechaTarifaFinString(dfs.format(fechaTarifaFin));//dd/MM/yy
	        } catch (ParseException e){
	            e.printStackTrace();
	        }
	        System.out.println("FID************************" +this.fechaTarifaInicioDate);
	        System.out.println("FFD************************" +this.fechaTarifaFinDate);
	        /* System.out.println("FID************************" +this.fechaTarifaInicioDate.before(this.fechaTarifaFinDate));
	        System.out.println("FFD************************" +this.fechaTarifaFinDate.before(this.fechaTarifaInicioDate));
	        System.out.println("************************" +this.fechaTarifaInicioDate.after(this.fechaTarifaFinDate));
	        System.out.println("************************" +this.fechaTarifaFinDate.after(this.fechaTarifaInicioDate));*/
	        if(this.fechaTarifaInicioDate.after(this.fechaTarifaFinDate))
	        	this.setRespuestaTarifaNewUpdate("La fecha Inicial debe ser igual o anterior a la fecha Final del tarifa.");
		}else
			this.setRespuestaTarifaNewUpdate("Debe seleccionar una fecha para el Inicio y Fin del tarifa.");
	}
    
    private void dateBusquedaString2Date(String fecha, int inicialFinal) throws Exception {
    	if(fecha!=null && !fecha.equals("")){
	    	fecha = decodeFecha(fecha, false);
			DateFormat df = new SimpleDateFormat("dd/MM/yyyy");
			DateFormat dfs = DateFormat.getDateInstance(DateFormat.SHORT, Locale.US);
	        try{
	            Date fechaPublicacion = df.parse(fecha);  
	            if(inicialFinal==1){
	            	this.setFechaBusquedaIniDate(fechaPublicacion);
	            	this.setFechaBusquedaIniString(dfs.format(fechaPublicacion));//dd/MM/yy
	            }else{
	            	this.setFechaBusquedaFinDate(fechaPublicacion);
	            	this.setFechaBusquedaFinString(dfs.format(fechaPublicacion));//dd/MM/yy
	            }
	        } catch (ParseException e){
	            e.printStackTrace();
	        }
    	}
	}
    
    private void decodeConvenio(String submittedValue) {
    	System.out.println("$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ "+submittedValue);
    	if(submittedValue!=null && !submittedValue.equals("") && !submittedValue.equals("0") && !submittedValue.equals("-1")){
    		String[] convenioFormaPago = submittedValue.trim().split("\\|");
       		this.setIdConvenio(Integer.parseInt(convenioFormaPago[0]));
       		this.setIdFormaPago(Integer.parseInt(convenioFormaPago[1]));
    	}
	}

    private void decodeFormato(String submittedValue) {
    	if(submittedValue!=null && !submittedValue.equals("") && !submittedValue.equals("0") && !submittedValue.equals("-1")){
    		String[] formato = submittedValue.trim().split("\\|");
       		this.setIdFormato(Integer.parseInt(formato[0]));
       		this.setTipoFormato(Integer.parseInt(formato[1]));
    	}
	}
    
    private void decodeRespuestaProducto (String submittedValue) {
    	try{
	    	if(submittedValue!=null && !submittedValue.equals("") && !submittedValue.equals("0") && !submittedValue.equals("-1")){
	    		String[] respuesta = submittedValue.trim().split("\\|");
	       		this.setIdProducto(Integer.parseInt(respuesta[0]));
	       		this.setRespuestaProductoNewUpdate(respuesta[1]);
	    	}
	    	if(this.respuestaProductoNewUpdate!=null && this.respuestaProductoNewUpdate.equals("null"))
	    		this.setRespuestaProductoNewUpdate("");
	    }catch(Exception e){
			System.out.println(e);
		}
	}
    
    private void decodeRespuestaVersion (String submittedValue) {
    	try{
	    	if(submittedValue!=null && !submittedValue.equals("") && !submittedValue.equals("0") && !submittedValue.equals("-1")){
	    		String[] respuesta = submittedValue.trim().split("\\|");
	       		this.setIdVersion(Integer.parseInt(respuesta[0]));
	       		this.setRespuestaVersionNewUpdate(respuesta[1]);
	    	}
	    	if(this.respuestaVersionNewUpdate!=null && this.respuestaVersionNewUpdate.equals("null"))
	    		this.setRespuestaVersionNewUpdate("");
    	}catch(Exception e){
    		System.out.println(e);
    	}
	}
    
    private void decodeRespuestaEvento (String submittedValue) {
    	try{
			if(submittedValue!=null && !submittedValue.equals("") && !submittedValue.equals("0") && !submittedValue.equals("-1")){
	    		String[] respuesta = submittedValue.trim().split("\\|");
	       		this.setIdEvento(Integer.parseInt(respuesta[0]));
	       		this.setRespuestaEventoNewUpdate(respuesta[1]);
	    	}
	    	if(this.respuestaEventoNewUpdate!=null && this.respuestaEventoNewUpdate.equals("null"))
	    		this.setRespuestaEventoNewUpdate("");
    	}catch(Exception e){
    		System.out.println(e);
    	}
	}

	private void decodeRespuestaPatrocinio(String submittedValue) {
		try{
			if(submittedValue!=null && !submittedValue.equals("") && !submittedValue.equals("0") && !submittedValue.equals("-1")){
	    		String[] respuesta = submittedValue.trim().split("\\|");
	       		this.setIdPatrocinio(Integer.parseInt(respuesta[0]));
	       		this.setRespuestaPatrocinioNewUpdate(respuesta[1]);
	    	}
	    	if(this.respuestaPatrocinioNewUpdate!=null && this.respuestaPatrocinioNewUpdate.equals("null"))
	    		this.setRespuestaPatrocinioNewUpdate("");
		}catch(Exception e){
			System.out.println(e);
		}
	}
	
    private void decodeRespuestaSuplemento(String submittedValue) {
    	try{
	    	if(submittedValue!=null && !submittedValue.equals("") && !submittedValue.equals("0") && !submittedValue.equals("-1")){
	    		String[] respuesta = submittedValue.trim().split("\\|");
	       		this.setIdSuplemento(Integer.parseInt(respuesta[0]));
	       		this.setRespuestaSuplementoNewUpdate(respuesta[1]);
	    	}
	    	if(this.respuestaSuplementoNewUpdate!=null && this.respuestaSuplementoNewUpdate.equals("null"))
	    		this.setRespuestaSuplementoNewUpdate("");
    	}catch(Exception e){
			System.out.println(e);
		}
	}

    private void decodeRespuestaPosicion(String submittedValue) {
    	try{
	    	if(submittedValue!=null && !submittedValue.equals("") && !submittedValue.equals("0") && !submittedValue.equals("-1")){
	    		String[] respuesta = submittedValue.trim().split("\\|");
	       		this.setIdPosicion(Integer.parseInt(respuesta[0]));
	       		this.setRespuestaPosicionNewUpdate(respuesta[1]);
	    	}
	    	if(this.respuestaPosicionNewUpdate!=null && this.respuestaPosicionNewUpdate.equals("null"))
	    		this.setRespuestaPosicionNewUpdate("");
    	}catch(Exception e){
			System.out.println(e);
		}
	}
    
    private void decodeRespuestaSeccion(String submittedValue) {
    	try{
	    	if(submittedValue!=null && !submittedValue.equals("") && !submittedValue.equals("0") && !submittedValue.equals("-1")){
	    		String[] respuesta = submittedValue.trim().split("\\|");
	       		this.setIdSeccion(Integer.parseInt(respuesta[0]));
	       		this.setRespuestaSeccionNewUpdate(respuesta[1]);
	    	}
	    	if(this.respuestaSeccionNewUpdate!=null && this.respuestaSeccionNewUpdate.equals("null"))
	    		this.setRespuestaSeccionNewUpdate("");
	    }catch(Exception e){
			System.out.println(e);
		}
	}

	private void decodeRespuestaFormato(String submittedValue, int tipoFormato) {
		try{
	    	if(submittedValue!=null && !submittedValue.equals("") && !submittedValue.equals("0") && !submittedValue.equals("-1")){
	    		String[] respuesta = submittedValue.trim().split("\\|");
	       		this.setIdFormato(Integer.parseInt(respuesta[0]));
	       		this.setRespuestaFormatoNewUpdate(respuesta[1]);
	       		this.setFormato(this.idFormato+"|"+tipoFormato);//1=formatoEspecial
	    	}
	    	if(this.respuestaFormatoNewUpdate!=null && this.respuestaFormatoNewUpdate.equals("null"))
	    		this.setRespuestaFormatoNewUpdate("");
	    }catch(Exception e){
			System.out.println(e);
		}
	}
	
	private void decodeRespuestaTarifa (String submittedValue) {
    	try{
			if(submittedValue!=null && !submittedValue.equals("") && !submittedValue.equals("0") && !submittedValue.equals("-1")){
	    		String[] respuesta = submittedValue.trim().split("\\|");
	       		this.setIdTarifa(Integer.parseInt(respuesta[0]));
	       		this.setRespuestaTarifaNewUpdate(respuesta[1]);
	    	}
	    	if(this.respuestaTarifaNewUpdate!=null && this.respuestaTarifaNewUpdate.equals("null"))
	    		this.setRespuestaTarifaNewUpdate("");
    	}catch(Exception e){
    		System.out.println(e);
    	}
	}
	
	private String decodeAltoAncho(String submittedValue) {
		char c;
		String onlyNumber="";
		String character = null;
		if(submittedValue!=null && !submittedValue.trim().equals("") && !submittedValue.equals("0") && !submittedValue.equals("-1")){
			for(int i=0; i<submittedValue.length(); i++){
				c = submittedValue.charAt(i);
				if(c!='.'){
					if(Character.isDigit(c)){
						character = String.valueOf(c);
						onlyNumber = onlyNumber+character;
					}
				}else{
					character = String.valueOf(c);
					onlyNumber = onlyNumber+character;
				}
			}
		}
		return onlyNumber;
	}
	
	int idPedido;
	    
    private String publicacion="";
	int idPublicacion;
	String nombrePublicacion;
	int tipoPublicacion;
	List<PedidoBBean> publicaciones;
	String [] publicacionesEvento;
	String periodoPublicacion;
	String disabledPublicacion;
	
	private String suggestCliente = "";
	String cliente;
	int idCliente;
	String nombreCliente;
	int tipoCliente;
	List<PedidoBBean> clientes;
	List<String> suggestListClientes = new ArrayList<String>();
	
	int idEjecutivo;
	String nombreEjecutivo;
	boolean ejecutivoRequired = true;
	
	int idAgencia;
	String nombreAgencia;
	boolean esDefault;
	boolean agenciaRequired = true;
	
	int idComisionista;
	String nombreComisionista;
	Double porcentajeComisionista;
	boolean comisionistaRequired = false;
	boolean comisionistaPorcentajeRequired = false;
	boolean comisionistaPorcentajeDisabled = true;
	
	String numeroOrden;
	List<PedidoBBean> ordenes;
	List<String> suggestListOrdenes = new ArrayList<String>();
	private String suggestOrden = "";
	String idOrden;
	int tipoOrden;
	
	int idProducto;
	String nombreProducto;
	String nombreProductoNewUpdate = "";
	String respuestaProductoNewUpdate = "";
	List<PedidoBBean> productos;
	
	int idVersion; 
	String nombreVersion;
	String nombreVersionNewUpdate = "";
	String respuestaVersionNewUpdate = "";
	List<PedidoBBean> versiones = new ArrayList<PedidoBBean>();
	
	int idRegion;
	String nombreRegion;
	List<PedidoBBean> regiones;
	
	int idTarifa;
	String nombreTarifa;
	List<PedidoBBean> tarifas;
	Date fechaTarifaInicioDate;
	Date fechaTarifaFinDate;
	String fechaTarifaInicioString;
	String fechaTarifaFinString;
	String publicacionTarifa;
	String nombreTarifaNewUpdate;
	String respuestaTarifaNewUpdate;
	int idTarifaCopiar;
	
	int idDivisa;
	String nombreDivisa;
	String costoTotalDivisa;
	
	String tipoValoracion = "normal";
	String valorEspecial = "0.00";
	boolean valorEspecialDisabled = true;
	String valorEspecialStyle = "visibility: hidden; width: 0px; height: 0px;";
	
	String periodicoRevistaStyle = "panelGridRenglonPeriodicoRevistaOff";
	
	String fechaSlave;
	Date fechaPublicacionDate;
	String fechaPublicacionString;
	UIInput arregloFechasSeleccionadas;
	String nombreFechasPublicacion;
	List<PedidoBBean> fechasPublicacion;
	List<PedidoBBean> listaEdicionesFechas;
	
	String fechaEdicion;
	String numeroEdicion;
	String tipoEdicion;
	String estatusEdicion;
	String detalleEdicion;
	List<PedidoBBean> ediciones;
	List<String> suggestListEdiciones = new ArrayList<String>();
	private String suggestEdicion = "";
	String nombreEdicion;
	String numeroPaginasEdicion;
	String regionEdicion;
	int rowCount = 13;
	String rowByKey = "13";
	String id = "13";
	String modalHeight = "330";
	
	int idPatrocinio;
	String nombrePatrocinio;
	List<PedidoBBean> patrocinios;
	boolean patrocinioRequired = true;
	String nombrePatrocinioNewUpdate;
	String respuestaPatrocinioNewUpdate;
	String publicacionPatrocinio;
	
	int idPosicion;
	String nombrePosicion;
	List<PedidoBBean> posiciones;
	boolean posicionRequired = true;
	String nombrePosicionNewUpdate;
	String respuestaPosicionNewUpdate;
	String [] publicacionesPosicion;
	SelectItem[] listaPublicacionesPosicionItems;
	
	private UIInput formatoSeleccionado;
	String formato;
	int idFormato;
	String nombreFormato;
	HtmlInputNumberSpinner alto;
	HtmlInputNumberSpinner ancho;
	String anchoFormato;
	String altoFormato;
	String maxAlto = "1";
	String maxAncho = "1";
	int tipoFormato;
	boolean altoRequired = false;
	boolean anchoRequired = false;
	boolean altoDisabled = true;
	boolean anchoDisabled = true;
	List<PedidoBBean> formatos;
	boolean formatoEspecial;
	Date fechaFormatoInicioDate;
	Date fechaFormatoFinDate;
	String fechaFormatoInicioString;
	String fechaFormatoFinString;
	String respuestaFormatoNewUpdate;
	String nombreFormatoNewUpdate;
	
	int idSeccion;
	String nombreSeccion;
	List<PedidoBBean> secciones;
	boolean seccionRequired = true;
	String nombreSeccionNewUpdate;
	String respuestaSeccionNewUpdate;
	
	int idSuplemento;
	String nombreSuplemento;
	List<PedidoBBean> suplementos;
	boolean suplementoRequired = true;
	String nombreSuplementoNewUpdate;
	String respuestaSuplementoNewUpdate="";
	
	int idSufijo;
	String nombreSufijo;
	int numeroPaginas;
	int estatus;
	
	int idTipoVenta;
	String nombreTipoVenta;
	List<PedidoBBean> tiposVenta;
	
	int idConvenio;
	String convenio;
	String nombreConvenio;
	String montoConvenio;
	List<PedidoBBean> convenios;
	
	int idEvento;
	String idMultiPublicacionModal;

	String nombreEvento;
	String nombreEventoNewUpdate="";
	String respuestaEventoNewUpdate="";
	Date fechaEventoInicioDate;
	Date fechaEventoFinDate;
	String fechaEventoInicioString;
	String fechaEventoFinString;
	int idEventoPublicacionNewUpdateField;
	String idsPublicacionesHidden;//va concatenado los id de publicacion
	String descripcionEvento;
	List<PedidoBBean> eventos;
	SelectItem[] listaPublicacionesEventoItems;
	
	int idFormaPago;
	int idFormaPagoRestante;
	String montoRestante;
	String nombreFormaPago;
	List<PedidoBBean> formasPago;
	
	String observaciones;
	HtmlInputTextarea htmlObservaciones;
	//String respuesta;
	String errorPedidoTabPanel;
	String errorPedidoSeccion1;
	String errorPedidoSeccion2;
	String detallesPedidoHidden;
	String detallesConvenioHidden;
	
	boolean disabledAgregarAnuncio;
	String disabledEliminarAnuncio;
	
	/*BUSCADOR*/
	int tipoBusqueda;
	String fechaBusquedaIniString;
	Date fechaBusquedaIniDate;
	String fechaBusquedaFinString;
	Date fechaBusquedaFinDate;
	

	public String getSelectedItemsSlaveProductos() {
		return selectedItemsSlaveProductos;
	}

	public void setSelectedItemsSlaveProductos(String selectedItemsSlaveProductos) {
		this.selectedItemsSlaveProductos = selectedItemsSlaveProductos;
	}

	public List<SelectItem> getSelectItemsSlaveProductos() {
		return selectItemsSlaveProductos;
	}

	public void setSelectItemsSlaveProductos(
			List<SelectItem> selectItemsSlaveProductos) {
		this.selectItemsSlaveProductos = selectItemsSlaveProductos;
	}

	public String getSelectedItemsSlaveAgencias() {
		return selectedItemsSlaveAgencias;
	}

	public void setSelectedItemsSlaveAgencias(String selectedItemsSlaveAgencias) {
		this.selectedItemsSlaveAgencias = selectedItemsSlaveAgencias;
	}

	public List<SelectItem> getSelectItemsSlaveAgencias() {
		return selectItemsSlaveAgencias;
	}

	public void setSelectItemsSlaveAgencias(
			List<SelectItem> selectItemsSlaveAgencias) {
		this.selectItemsSlaveAgencias = selectItemsSlaveAgencias;
	}

	public String getSelectedItemsSlaveSuplementos() {
		return selectedItemsSlaveSuplementos;
	}

	public void setSelectedItemsSlaveSuplementos(
			String selectedItemsSlaveSuplementos) {
		this.selectedItemsSlaveSuplementos = selectedItemsSlaveSuplementos;
	}

	public List<SelectItem> getSelectItemsSlaveSuplementos() {
		return selectItemsSlaveSuplementos;
	}

	public void setSelectItemsSlaveSuplementos(
			List<SelectItem> selectItemsSlaveSuplementos) {
		this.selectItemsSlaveSuplementos = selectItemsSlaveSuplementos;
	}

	public String getSelectedItemsSlaveConvenios() {
		return selectedItemsSlaveConvenios;
	}

	public void setSelectedItemsSlaveConvenios(String selectedItemsSlaveConvenios) {
		this.selectedItemsSlaveConvenios = selectedItemsSlaveConvenios;
	}

	public List<SelectItem> getSelectItemsSlaveConvenios() {
		return selectItemsSlaveConvenios;
	}

	public void setSelectItemsSlaveConvenios(
			List<SelectItem> selectItemsSlaveConvenios) {
		this.selectItemsSlaveConvenios = selectItemsSlaveConvenios;
	}

	public String getSelectedItemsSlaveRegiones() {
		return selectedItemsSlaveRegiones;
	}

	public void setSelectedItemsSlaveRegiones(String selectedItemsSlaveRegiones) {
		this.selectedItemsSlaveRegiones = selectedItemsSlaveRegiones;
	}

	public List<SelectItem> getSelectItemsSlaveRegiones() {
		return selectItemsSlaveRegiones;
	}

	public void setSelectItemsSlaveRegiones(
			List<SelectItem> selectItemsSlaveRegiones) {
		this.selectItemsSlaveRegiones = selectItemsSlaveRegiones;
	}

	public String getSelectedItemsSlavePatrocinios() {
		return selectedItemsSlavePatrocinios;
	}

	public void setSelectedItemsSlavePatrocinios(
			String selectedItemsSlavePatrocinios) {
		this.selectedItemsSlavePatrocinios = selectedItemsSlavePatrocinios;
	}

	public List<SelectItem> getSelectItemsSlavePatrocinios() {
		return selectItemsSlavePatrocinios;
	}

	public void setSelectItemsSlavePatrocinios(
			List<SelectItem> selectItemsSlavePatrocinios) {
		this.selectItemsSlavePatrocinios = selectItemsSlavePatrocinios;
	}

	public String getPublicacion() {
		return publicacion;
	}

	public void setPublicacion(String publicacion) {
		this.publicacion = publicacion;
	}

	public int getIdPublicacion() {
		return idPublicacion;
	}

	public void setIdPublicacion(int idPublicacion) {
		this.idPublicacion = idPublicacion;
	}

	public String getNombrePublicacion() {
		return nombrePublicacion;
	}

	public void setNombrePublicacion(String nombrePublicacion) {
		this.nombrePublicacion = nombrePublicacion;
	}

	public int getTipoPublicacion() {
		return tipoPublicacion;
	}

	public void setTipoPublicacion(int tipoPublicacion) {
		this.tipoPublicacion = tipoPublicacion;
	}

	public List<PedidoBBean> getPublicaciones() {
		return publicaciones;
	}

	public void setPublicaciones(List<PedidoBBean> publicaciones) {
		this.publicaciones = publicaciones;
	}

	public String getCliente() {
		return cliente;
	}

	public void setCliente(String cliente) {
		this.cliente = cliente;
	}
	
	public int getIdCliente() {
		return idCliente;
	}

	public void setIdCliente(int idCliente) {
		this.idCliente = idCliente;
	}

	public String getNombreCliente() {
		return nombreCliente;
	}

	public void setNombreCliente(String nombreCliente) {
		this.nombreCliente = nombreCliente;
	}

	public int getTipoCliente() {
		return tipoCliente;
	}

	public void setTipoCliente(int tipoCliente) {
		this.tipoCliente = tipoCliente;
	}

	public List<PedidoBBean> getClientes() {
		return clientes;
	}

	public void setClientes(List<PedidoBBean> clientes) {
		this.clientes = clientes;
	}

	public String getNombreEjecutivo() {
		return nombreEjecutivo;
	}

	public void setNombreEjecutivo(String nombreEjecutivo) {
		this.nombreEjecutivo = nombreEjecutivo;
	}

	public int getIdAgencia() {
		return idAgencia;
	}

	public void setIdAgencia(int idAgencia) {
		this.idAgencia = idAgencia;
	}

	public String getNombreAgencia() {
		return nombreAgencia;
	}

	public void setNombreAgencia(String nombreAgencia) {
		this.nombreAgencia = nombreAgencia;
	}

	public String getNombreComisionista() {
		return nombreComisionista;
	}

	public void setNombreComisionista(String nombreComisionista) {
		this.nombreComisionista = nombreComisionista;
	}

	public Double getPorcentajeComisionista() {
		return porcentajeComisionista;
	}

	public void setPorcentajeComisionista(Double porcentajeComisionista) {
		this.porcentajeComisionista = porcentajeComisionista;
	}

	public String getNumeroOrden() {
		return numeroOrden;
	}

	public void setNumeroOrden(String numeroOrden) {
		this.numeroOrden = numeroOrden;
	}

	public int getIdProducto() {
		return idProducto;
	}

	public void setIdProducto(int idProducto) {
		this.idProducto = idProducto;
	}

	public String getNombreProducto() {
		return nombreProducto;
	}

	public void setNombreProducto(String nombreProducto) {
		this.nombreProducto = nombreProducto;
	}

	public List<PedidoBBean> getProductos() {
		return productos;
	}

	public void setProductos(List<PedidoBBean> productos) {
		this.productos = productos;
	}

	public int getIdRegion() {
		return idRegion;
	}

	public void setIdRegion(int idRegion) {
		this.idRegion = idRegion;
	}

	public String getNombreRegion() {
		return nombreRegion;
	}

	public void setNombreRegion(String nombreRegion) {
		this.nombreRegion = nombreRegion;
	}

	public List<PedidoBBean> getRegiones() {
		return regiones;
	}

	public void setRegiones(List<PedidoBBean> regiones) {
		this.regiones = regiones;
	}

	public int getIdTarifa() {
		return idTarifa;
	}

	public void setIdTarifa(int idTarifa) {
		this.idTarifa = idTarifa;
	}

	public String getNombreTarifa() {
		return nombreTarifa;
	}

	public void setNombreTarifa(String nombreTarifa) {
		this.nombreTarifa = nombreTarifa;
	}

	public List<PedidoBBean> getTarifas() {
		return tarifas;
	}

	public void setTarifas(List<PedidoBBean> tarifas) {
		this.tarifas = tarifas;
	}

	public String getTipoValoracion() {
		return tipoValoracion;
	}

	public void setTipoValoracion(String tipoValoracion) {
		this.tipoValoracion = tipoValoracion;
	}

	public String getValorEspecial() {
		return valorEspecial;
	}

	public void setValorEspecial(String valorEspecial) {
		this.valorEspecial = valorEspecial;
	}

	public String getNombreFechasPublicacion() {
		return nombreFechasPublicacion;
	}

	public void setNombreFechasPublicacion(String nombreFechasPublicacion) {
		this.nombreFechasPublicacion = nombreFechasPublicacion;
	}

	public List<PedidoBBean> getFechasPublicacion() {
		return fechasPublicacion;
	}

	public void setFechasPublicacion(List<PedidoBBean> fechasPublicacion) {
		this.fechasPublicacion = fechasPublicacion;
	}

	public int getIdPatrocinio() {
		return idPatrocinio;
	}

	public void setIdPatrocinio(int idPatrocinio) {
		this.idPatrocinio = idPatrocinio;
	}

	public String getNombrePatrocinio() {
		return nombrePatrocinio;
	}

	public void setNombrePatrocinio(String nombrePatrocinio) {
		this.nombrePatrocinio = nombrePatrocinio;
	}

	public List<PedidoBBean> getPatrocinios() {
		return patrocinios;
	}

	public void setPatrocinios(List<PedidoBBean> patrocinios) {
		this.patrocinios = patrocinios;
	}

	public int getIdPosicion() {
		return idPosicion;
	}

	public void setIdPosicion(int idPosicion) {
		this.idPosicion = idPosicion;
	}

	public String getNombrePosicion() {
		return nombrePosicion;
	}

	public void setNombrePosicion(String nombrePosicion) {
		this.nombrePosicion = nombrePosicion;
	}

	public List<PedidoBBean> getPosiciones() {
		return posiciones;
	}

	public void setPosiciones(List<PedidoBBean> posiciones) {
		this.posiciones = posiciones;
	}

	public int getIdFormato() {
		return idFormato;
	}

	public void setIdFormato(int idFormato) {
		this.idFormato = idFormato;
	}

	public String getNombreFormato() {
		return nombreFormato;
	}

	public void setNombreFormato(String nombreFormato) {
		this.nombreFormato = nombreFormato;
	}

	public List<PedidoBBean> getFormatos() {
		return formatos;
	}

	public void setFormatos(List<PedidoBBean> formatos) {
		this.formatos = formatos;
	}

	public int getIdSuplemento() {
		return idSuplemento;
	}

	public void setIdSuplemento(int idSuplemento) {
		this.idSuplemento = idSuplemento;
	}

	public String getNombreSuplemento() {
		return nombreSuplemento;
	}

	public void setNombreSuplemento(String nombreSuplemento) {
		this.nombreSuplemento = nombreSuplemento;
	}

	public List<PedidoBBean> getSuplementos() {
		return suplementos;
	}

	public void setSuplementos(List<PedidoBBean> suplementos) {
		this.suplementos = suplementos;
	}

	public int getIdConvenio() {
		return idConvenio;
	}

	public String getConvenio() {
		return convenio;
	}

	public void setConvenio(String convenio) {
		this.convenio = convenio;
	}

	public void setIdConvenio(int idConvenio) {
		this.idConvenio = idConvenio;
	}

	public String getNombreConvenio() {
		return nombreConvenio;
	}

	public void setNombreConvenio(String nombreConvenio) {
		this.nombreConvenio = nombreConvenio;
	}

	public String getMontoConvenio() {
		return montoConvenio;
	}

	public void setMontoConvenio(String montoConvenio) {
		this.montoConvenio = montoConvenio;
	}

	public List<PedidoBBean> getConvenios() {
		return convenios;
	}

	public void setConvenios(List<PedidoBBean> convenios) {
		this.convenios = convenios;
	}

	public List<PedidoBBean> getFormasPago() {
		return formasPago;
	}

	public void setFormasPago(List<PedidoBBean> formasPago) {
		this.formasPago = formasPago;
	}

	public String getObservaciones() {
		return observaciones;
	}

	public void setObservaciones(String observaciones) {
		this.observaciones = observaciones;
	}

	public String getSelectedItemsSlaveFormatos() {
		return selectedItemsSlaveFormatos;
	}

	public void setSelectedItemsSlaveFormatos(String selectedItemsSlaveFormatos) {
		this.selectedItemsSlaveFormatos = selectedItemsSlaveFormatos;
	}

	public List<SelectItem> getSelectItemsSlaveFormatos() {
		return selectItemsSlaveFormatos;
	}

	public void setSelectItemsSlaveFormatos(
			List<SelectItem> selectItemsSlaveFormatos) {
		this.selectItemsSlaveFormatos = selectItemsSlaveFormatos;
	}

	public int getIdFormaPago() {
		return idFormaPago;
	}

	public void setIdFormaPago(int idFormaPago) {
		this.idFormaPago = idFormaPago;
	}

	public String getNombreFormaPago() {
		return nombreFormaPago;
	}

	public void setNombreFormaPago(String nombreFormaPago) {
		this.nombreFormaPago = nombreFormaPago;
	}

	public String getAnchoFormato() {
		return anchoFormato;
	}

	public void setAnchoFormato(String anchoFormato) {
		this.anchoFormato = anchoFormato;
	}

	public String getAltoFormato() {
		return altoFormato;
	}

	public void setAltoFormato(String altoFormato) {
		this.altoFormato = altoFormato;
	}

	public int getTipoFormato() {
		return tipoFormato;
	}

	public void setTipoFormato(int tipoFormato) {
		this.tipoFormato = tipoFormato;
	}

	public String getSelectedItemsSlaveAltoFormato() {
		return selectedItemsSlaveAltoFormato;
	}

	public void setSelectedItemsSlaveAltoFormato(
			String selectedItemsSlaveAltoFormato) {
		this.selectedItemsSlaveAltoFormato = selectedItemsSlaveAltoFormato;
	}

	public String getSelectedItemsSlaveAnchoFormato() {
		return selectedItemsSlaveAnchoFormato;
	}

	public void setSelectedItemsSlaveAnchoFormato(
			String selectedItemsSlaveAnchoFormato) {
		this.selectedItemsSlaveAnchoFormato = selectedItemsSlaveAnchoFormato;
	}

	public List<SelectItem> getSelectItemsSlaveAnchoFormato() {
		return selectItemsSlaveAnchoFormato;
	}

	public void setSelectItemsSlaveAnchoFormato(
			List<SelectItem> selectItemsSlaveAnchoFormato) {
		this.selectItemsSlaveAnchoFormato = selectItemsSlaveAnchoFormato;
	}

	public List<SelectItem> getSelectItemsSlaveAltoFormato() {
		return selectItemsSlaveAltoFormato;
	}

	public void setSelectItemsSlaveAltoFormato(
			List<SelectItem> selectItemsSlaveAltoFormato) {
		this.selectItemsSlaveAltoFormato = selectItemsSlaveAltoFormato;
	}

	public UIInput getArregloFechasSeleccionadas() {
		return arregloFechasSeleccionadas;
	}

	public void setArregloFechasSeleccionadas(UIInput arregloFechasSeleccionadas) {
		this.arregloFechasSeleccionadas = arregloFechasSeleccionadas;
	}

	public UIInput getFormatoSeleccionado() {
		return formatoSeleccionado;
	}

	public void setFormatoSeleccionado(UIInput formatoSeleccionado) {
		this.formatoSeleccionado = formatoSeleccionado;
	}

	public boolean isFormatoEspecial() {
		return formatoEspecial;
	}

	public void setFormatoEspecial(boolean formatoEspecial) {
		this.formatoEspecial = formatoEspecial;
	}

	public String getSelectedItemsSlaveTiposVenta() {
		return selectedItemsSlaveTiposVenta;
	}

	public void setSelectedItemsSlaveTiposVenta(String selectedItemsSlaveTiposVenta) {
		this.selectedItemsSlaveTiposVenta = selectedItemsSlaveTiposVenta;
	}

	public List<SelectItem> getSelectItemsSlaveTiposVenta() {
		return selectItemsSlaveTiposVenta;
	}

	public void setSelectItemsSlaveTiposVenta(
			List<SelectItem> selectItemsSlaveTiposVenta) {
		this.selectItemsSlaveTiposVenta = selectItemsSlaveTiposVenta;
	}

	public int getIdTipoVenta() {
		return idTipoVenta;
	}

	public void setIdTipoVenta(int idTipoVenta) {
		this.idTipoVenta = idTipoVenta;
	}

	public String getNombreTipoVenta() {
		return nombreTipoVenta;
	}

	public void setNombreTipoVenta(String nombreTipoVenta) {
		this.nombreTipoVenta = nombreTipoVenta;
	}

	public List<PedidoBBean> getTiposVenta() {
		return tiposVenta;
	}

	public void setTiposVenta(List<PedidoBBean> tiposVenta) {
		this.tiposVenta = tiposVenta;
	}

	public String getSelectedItemsSlaveFormasPago() {
		return selectedItemsSlaveFormasPago;
	}

	public void setSelectedItemsSlaveFormasPago(String selectedItemsSlaveFormasPago) {
		this.selectedItemsSlaveFormasPago = selectedItemsSlaveFormasPago;
	}

	public List<SelectItem> getSelectItemsSlaveFormasPago() {
		return selectItemsSlaveFormasPago;
	}

	public void setSelectItemsSlaveFormasPago(
			List<SelectItem> selectItemsSlaveFormasPago) {
		this.selectItemsSlaveFormasPago = selectItemsSlaveFormasPago;
	}

	public String getSelectedItemsSlavePosiciones() {
		return selectedItemsSlavePosiciones;
	}

	public void setSelectedItemsSlavePosiciones(String selectedItemsSlavePosiciones) {
		this.selectedItemsSlavePosiciones = selectedItemsSlavePosiciones;
	}

	public List<SelectItem> getSelectItemsSlavePosiciones() {
		return selectItemsSlavePosiciones;
	}

	public void setSelectItemsSlavePosiciones(
			List<SelectItem> selectItemsSlavePosiciones) {
		this.selectItemsSlavePosiciones = selectItemsSlavePosiciones;
	}

	public String getSelectedItemsSlaveTarifas() {
		return selectedItemsSlaveTarifas;
	}

	public void setSelectedItemsSlaveTarifas(String selectedItemsSlaveTarifas) {
		this.selectedItemsSlaveTarifas = selectedItemsSlaveTarifas;
	}

	public List<SelectItem> getSelectItemsSlaveTarifas() {
		return selectItemsSlaveTarifas;
	}

	public void setSelectItemsSlaveTarifas(List<SelectItem> selectItemsSlaveTarifas) {
		this.selectItemsSlaveTarifas = selectItemsSlaveTarifas;
	}

	public int getIdEjecutivo() {
		return idEjecutivo;
	}

	public void setIdEjecutivo(int idEjecutivo) {
		this.idEjecutivo = idEjecutivo;
	}

	public int getIdComisionista() {
		return idComisionista;
	}

	public void setIdComisionista(int idComisionista) {
		this.idComisionista = idComisionista;
	}

	public String getSelectedItemsSlaveEjecutivos() {
		return selectedItemsSlaveEjecutivos;
	}

	public void setSelectedItemsSlaveEjecutivos(String selectedItemsSlaveEjecutivos) {
		this.selectedItemsSlaveEjecutivos = selectedItemsSlaveEjecutivos;
	}

	public List<SelectItem> getSelectItemsSlaveEjecutivos() {
		return selectItemsSlaveEjecutivos;
	}

	public void setSelectItemsSlaveEjecutivos(
			List<SelectItem> selectItemsSlaveEjecutivos) {
		this.selectItemsSlaveEjecutivos = selectItemsSlaveEjecutivos;
	}

	public String getSelectedItemsSlaveComisionistas() {
		return selectedItemsSlaveComisionistas;
	}

	public void setSelectedItemsSlaveComisionistas(
			String selectedItemsSlaveComisionistas) {
		this.selectedItemsSlaveComisionistas = selectedItemsSlaveComisionistas;
	}

	public List<SelectItem> getSelectItemsSlaveComisionistas() {
		return selectItemsSlaveComisionistas;
	}

	public void setSelectItemsSlaveComisionistas(
			List<SelectItem> selectItemsSlaveComisionistas) {
		this.selectItemsSlaveComisionistas = selectItemsSlaveComisionistas;
	}

	public String getSelectedItemsSlaveSecciones() {
		return selectedItemsSlaveSecciones;
	}

	public void setSelectedItemsSlaveSecciones(String selectedItemsSlaveSecciones) {
		this.selectedItemsSlaveSecciones = selectedItemsSlaveSecciones;
	}

	public List<SelectItem> getSelectItemsSlaveSecciones() {
		return selectItemsSlaveSecciones;
	}

	public void setSelectItemsSlaveSecciones(
			List<SelectItem> selectItemsSlaveSecciones) {
		this.selectItemsSlaveSecciones = selectItemsSlaveSecciones;
	}

	public int getIdSeccion() {
		return idSeccion;
	}

	public void setIdSeccion(int idSeccion) {
		this.idSeccion = idSeccion;
	}

	public String getNombreSeccion() {
		return nombreSeccion;
	}

	public void setNombreSeccion(String nombreSeccion) {
		this.nombreSeccion = nombreSeccion;
	}

	public List<PedidoBBean> getSecciones() {
		return secciones;
	}

	public void setSecciones(List<PedidoBBean> secciones) {
		this.secciones = secciones;
	}
	
	public String getFechaEdicion() {
		return fechaEdicion;
	}

	public void setFechaEdicion(String fechaEdicion) {
		this.fechaEdicion = fechaEdicion;
	}

	public String getNumeroEdicion() {
		return numeroEdicion;
	}

	public void setNumeroEdicion(String numeroEdicion) {
		this.numeroEdicion = numeroEdicion;
	}

	public List<PedidoBBean> getListaEdicionesFechas() {
		return listaEdicionesFechas;
	}

	public void setListaEdicionesFechas(List<PedidoBBean> listaEdicionesFechas) {
		this.listaEdicionesFechas = listaEdicionesFechas;
	}

	public String getNombreEdicion() {
		return nombreEdicion;
	}

	public void setNombreEdicion(String nombreEdicion) {
		this.nombreEdicion = nombreEdicion;
	}

	public String getNumeroPaginasEdicion() {
		return numeroPaginasEdicion;
	}

	public void setNumeroPaginasEdicion(String numeroPaginasEdicion) {
		this.numeroPaginasEdicion = numeroPaginasEdicion;
	}

	public int getRowCount() {
		return rowCount;
	}

	public void setRowCount(int rowCount) {
		this.rowCount = rowCount;
	}

	public String getRowByKey() {
		return rowByKey;
	}

	public void setRowByKey(String rowByKey) {
		this.rowByKey = rowByKey;
	}

	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public String getModalHeight() {
		return modalHeight;
	}

	public void setModalHeight(String modalHeight) {
		this.modalHeight = modalHeight;
	}

	public String getRegionEdicion() {
		return regionEdicion;
	}

	public void setRegionEdicion(String regionEdicion) {
		this.regionEdicion = regionEdicion;
	}

	public int getIdVersion() {
		return idVersion;
	}

	public void setIdVersion(int idVersion) {
		this.idVersion = idVersion;
	}

	public String getNombreVersion() {
		return nombreVersion;
	}

	public void setNombreVersion(String nombreVersion) {
		this.nombreVersion = nombreVersion;
	}

	public List<PedidoBBean> getVersiones() {
		return versiones;
	}

	public void setVersiones(List<PedidoBBean> versiones) {
		this.versiones = versiones;
	}

	public boolean isEsDefault() {
		return esDefault;
	}

	public void setEsDefault(boolean esDefault) {
		this.esDefault = esDefault;
	}
	
	public String getSelectedItemsSlaveVersiones() {
		return selectedItemsSlaveVersiones;
	}

	public void setSelectedItemsSlaveVersiones(String selectedItemsSlaveVersiones) {
		this.selectedItemsSlaveVersiones = selectedItemsSlaveVersiones;
	}

	public List<SelectItem> getSelectItemsSlaveVersiones() {
		return selectItemsSlaveVersiones;
	}

	public void setSelectItemsSlaveVersiones(
			List<SelectItem> selectItemsSlaveVersiones) {
		this.selectItemsSlaveVersiones = selectItemsSlaveVersiones;
	}

	public Date getFechaPublicacionDate() {
		return fechaPublicacionDate;
	}

	public void setFechaPublicacionDate(Date fechaPublicacionDate) {
		this.fechaPublicacionDate = fechaPublicacionDate;
	}

	public String getFechaPublicacionString() {
		return fechaPublicacionString;
	}

	public void setFechaPublicacionString(String fechaPublicacionString) {
		this.fechaPublicacionString = fechaPublicacionString;
	}

	public String getFechaSlave() {
		return fechaSlave;
	}

	public void setFechaSlave(String fechaSlave) {
		this.fechaSlave = fechaSlave;
	}

	public boolean isEjecutivoRequired() {
		return ejecutivoRequired;
	}

	public void setEjecutivoRequired(boolean ejecutivoRequired) {
		this.ejecutivoRequired = ejecutivoRequired;
	}

	public boolean isAgenciaRequired() {
		return agenciaRequired;
	}

	public void setAgenciaRequired(boolean agenciaRequired) {
		this.agenciaRequired = agenciaRequired;
	}

	public boolean isComisionistaRequired() {
		return comisionistaRequired;
	}

	public void setComisionistaRequired(boolean comisionistaRequired) {
		this.comisionistaRequired = comisionistaRequired;
	}

	public boolean isPatrocinioRequired() {
		return patrocinioRequired;
	}

	public void setPatrocinioRequired(boolean patrocinioRequired) {
		this.patrocinioRequired = patrocinioRequired;
	}

	public boolean isPosicionRequired() {
		return posicionRequired;
	}

	public void setPosicionRequired(boolean posicionRequired) {
		this.posicionRequired = posicionRequired;
	}

	public boolean isSeccionRequired() {
		return seccionRequired;
	}

	public void setSeccionRequired(boolean seccionRequired) {
		this.seccionRequired = seccionRequired;
	}

	public boolean isSuplementoRequired() {
		return suplementoRequired;
	}

	public void setSuplementoRequired(boolean suplementoRequired) {
		this.suplementoRequired = suplementoRequired;
	}

	public boolean isComisionistaPorcentajeRequired() {
		return comisionistaPorcentajeRequired;
	}

	public void setComisionistaPorcentajeRequired(
			boolean comisionistaPorcentajeRequired) {
		this.comisionistaPorcentajeRequired = comisionistaPorcentajeRequired;
	}

	public boolean isComisionistaPorcentajeDisabled() {
		return comisionistaPorcentajeDisabled;
	}

	public void setComisionistaPorcentajeDisabled(
			boolean comisionistaPorcentajeDisabled) {
		this.comisionistaPorcentajeDisabled = comisionistaPorcentajeDisabled;
	}

	public boolean isDisabledAgregarAnuncio() {
		return disabledAgregarAnuncio;
	}

	public void setDisabledAgregarAnuncio(boolean disabledAgregarAnuncio) {
		this.disabledAgregarAnuncio = disabledAgregarAnuncio;
	}

	public String getDisabledEliminarAnuncio() {
		return disabledEliminarAnuncio;
	}

	public void setDisabledEliminarAnuncio(String disabledEliminarAnuncio) {
		this.disabledEliminarAnuncio = disabledEliminarAnuncio;
	}

	public String getFormato() {
		return formato;
	}

	public void setFormato(String formato) {
		this.formato = formato;
	}

	public boolean isAltoRequired() {
		return altoRequired;
	}

	public void setAltoRequired(boolean altoRequired) {
		this.altoRequired = altoRequired;
	}

	public boolean isAnchoRequired() {
		return anchoRequired;
	}

	public void setAnchoRequired(boolean anchoRequired) {
		this.anchoRequired = anchoRequired;
	}

	public boolean isAltoDisabled() {
		return altoDisabled;
	}

	public void setAltoDisabled(boolean altoDisabled) {
		this.altoDisabled = altoDisabled;
	}

	public boolean isAnchoDisabled() {
		return anchoDisabled;
	}

	public void setAnchoDisabled(boolean anchoDisabled) {
		this.anchoDisabled = anchoDisabled;
	}

	/*public String getRespuesta() {
		return respuesta;
	}

	public void setRespuesta(String respuesta) {
		this.respuesta = respuesta;
	}*/

	public String getSelectedItemsSlaveEventos() {
		return selectedItemsSlaveEventos;
	}

	public void setSelectedItemsSlaveEventos(String selectedItemsSlaveEventos) {
		this.selectedItemsSlaveEventos = selectedItemsSlaveEventos;
	}

	public List<SelectItem> getSelectItemsSlaveEventos() {
		return selectItemsSlaveEventos;
	}

	public void setSelectItemsSlaveEventos(List<SelectItem> selectItemsSlaveEventos) {
		this.selectItemsSlaveEventos = selectItemsSlaveEventos;
	}

	public int getIdEvento() {
		return idEvento;
	}

	public void setIdEvento(int idEvento) {
		this.idEvento = idEvento;
	}

	public String getNombreEvento() {
		return nombreEvento;
	}

	public void setNombreEvento(String nombreEvento) {
		this.nombreEvento = nombreEvento;
	}

	public List<PedidoBBean> getEventos() {
		return eventos;
	}

	public void setEventos(List<PedidoBBean> eventos) {
		this.eventos = eventos;
	}
	
	public String getNombreProductoNewUpdate() {
		return nombreProductoNewUpdate;
	}

	public void setNombreProductoNewUpdate(String nombreProductoNewUpdate) {
		this.nombreProductoNewUpdate = nombreProductoNewUpdate;
	}

	public String getNombreVersionNewUpdate() {
		return nombreVersionNewUpdate;
	}

	public void setNombreVersionNewUpdate(String nombreVersionNewUpdate) {
		this.nombreVersionNewUpdate = nombreVersionNewUpdate;
	}

	public String getRespuestaProductoNewUpdate() {
		return respuestaProductoNewUpdate;
	}

	public void setRespuestaProductoNewUpdate(String respuestaProductoNewUpdate) {
		this.respuestaProductoNewUpdate = respuestaProductoNewUpdate;
	}

	public String getRespuestaVersionNewUpdate() {
		return respuestaVersionNewUpdate;
	}

	public void setRespuestaVersionNewUpdate(String respuestaVersionNewUpdate) {
		this.respuestaVersionNewUpdate = respuestaVersionNewUpdate;
	}

	public String getNombreEventoNewUpdate() {
		return nombreEventoNewUpdate;
	}

	public void setNombreEventoNewUpdate(String nombreEventoNewUpdate) {
		this.nombreEventoNewUpdate = nombreEventoNewUpdate;
	}

	public String getRespuestaEventoNewUpdate() {
		return respuestaEventoNewUpdate;
	}

	public void setRespuestaEventoNewUpdate(String respuestaEventoNewUpdate) {
		this.respuestaEventoNewUpdate = respuestaEventoNewUpdate;
	}

	public Date getFechaEventoInicioDate() {
		return fechaEventoInicioDate;
	}

	public void setFechaEventoInicioDate(Date fechaEventoInicioDate) {
		this.fechaEventoInicioDate = fechaEventoInicioDate;
	}

	public Date getFechaEventoFinDate() {
		return fechaEventoFinDate;
	}

	public void setFechaEventoFinDate(Date fechaEventoFinDate) {
		this.fechaEventoFinDate = fechaEventoFinDate;
	}

	public String getFechaEventoInicioString() {
		return fechaEventoInicioString;
	}

	public void setFechaEventoInicioString(String fechaEventoInicioString) {
		this.fechaEventoInicioString = fechaEventoInicioString;
	}

	public String getFechaEventoFinString() {
		return fechaEventoFinString;
	}

	public void setFechaEventoFinString(String fechaEventoFinString) {
		this.fechaEventoFinString = fechaEventoFinString;
	}

	public int getIdEventoPublicacionNewUpdateField() {
		return idEventoPublicacionNewUpdateField;
	}

	public void setIdEventoPublicacionNewUpdateField(
			int idEventoPublicacionNewUpdateField) {
		this.idEventoPublicacionNewUpdateField = idEventoPublicacionNewUpdateField;
	}

	public String getDescripcionEvento() {
		return descripcionEvento;
	}

	public void setDescripcionEvento(String descripcionEvento) {
		this.descripcionEvento = descripcionEvento;
	}

	public int getIdFormaPagoRestante() {
		return idFormaPagoRestante;
	}

	public void setIdFormaPagoRestante(int idFormaPagoRestante) {
		this.idFormaPagoRestante = idFormaPagoRestante;
	}

	public String[] getPublicacionesEvento() {
		return publicacionesEvento;
	}

	public void setPublicacionesEvento(String[] publicacionesEvento) {
		this.publicacionesEvento = publicacionesEvento;
	}

	public String getPeriodoPublicacion() {
		return periodoPublicacion;
	}

	public void setPeriodoPublicacion(String periodoPublicacion) {
		this.periodoPublicacion = periodoPublicacion;
	}

	public String getDisabledPublicacion() {
		return disabledPublicacion;
	}

	public void setDisabledPublicacion(String disabledPublicacion) {
		this.disabledPublicacion = disabledPublicacion;
	}

	public String getDetallesPedidoHidden() {
		return detallesPedidoHidden;
	}

	public void setDetallesPedidoHidden(String detallesPedidoHidden) {
		this.detallesPedidoHidden = detallesPedidoHidden;
	}

	public String getDetallesConvenioHidden() {
		return detallesConvenioHidden;
	}

	public void setDetallesConvenioHidden(String detallesConvenioHidden) {
		this.detallesConvenioHidden = detallesConvenioHidden;
	}

	public String getIdOrden() {
		return idOrden;
	}

	public void setIdOrden(String idOrden) {
		this.idOrden = idOrden;
	}

	public int getTipoOrden() {
		return tipoOrden;
	}

	public void setTipoOrden(int tipoOrden) {
		this.tipoOrden = tipoOrden;
	}

	public int getIdPedido() {
		return idPedido;
	}

	public void setIdPedido(int idPedido) {
		this.idPedido = idPedido;
	}

	public String getSuggestCliente() {
		return suggestCliente;
	}

	public void setSuggestCliente(String suggestCliente) {
		this.suggestCliente = suggestCliente;
	}

	public int getTipoBusqueda() {
		return tipoBusqueda;
	}

	public void setTipoBusqueda(int tipoBusqueda) {
		this.tipoBusqueda = tipoBusqueda;
	}

	public Date getFechaBusquedaIniDate() {
		return fechaBusquedaIniDate;
	}

	public void setFechaBusquedaIniDate(Date fechaBusquedaIniDate) {
		this.fechaBusquedaIniDate = fechaBusquedaIniDate;
	}

	public Date getFechaBusquedaFinDate() {
		return fechaBusquedaFinDate;
	}

	public void setFechaBusquedaFinDate(Date fechaBusquedaFinDate) {
		this.fechaBusquedaFinDate = fechaBusquedaFinDate;
	}

	public String getFechaBusquedaIniString() {
		return fechaBusquedaIniString;
	}

	public void setFechaBusquedaIniString(String fechaBusquedaIniString) {
		this.fechaBusquedaIniString = fechaBusquedaIniString;
	}

	public String getFechaBusquedaFinString() {
		return fechaBusquedaFinString;
	}

	public void setFechaBusquedaFinString(String fechaBusquedaFinString) {
		this.fechaBusquedaFinString = fechaBusquedaFinString;
	}

	public List<PedidoBBean> getOrdenes() {
		return ordenes;
	}

	public void setOrdenes(List<PedidoBBean> ordenes) {
		this.ordenes = ordenes;
	}

	public List<PedidoBBean> getEdiciones() {
		return ediciones;
	}

	public void setEdiciones(List<PedidoBBean> ediciones) {
		this.ediciones = ediciones;
	}

	public String getSuggestOrden() {
		return suggestOrden;
	}

	public void setSuggestOrden(String suggestOrden) {
		this.suggestOrden = suggestOrden;
	}

	public String getSuggestEdicion() {
		return suggestEdicion;
	}

	public void setSuggestEdicion(String suggestEdicion) {
		this.suggestEdicion = suggestEdicion;
	}

	public String getTipoEdicion() {
		return tipoEdicion;
	}

	public void setTipoEdicion(String tipoEdicion) {
		this.tipoEdicion = tipoEdicion;
	}

	public String getEstatusEdicion() {
		return estatusEdicion;
	}

	public void setEstatusEdicion(String estatusEdicion) {
		this.estatusEdicion = estatusEdicion;
	}

	public String getDetalleEdicion() {
		return detalleEdicion;
	}

	public void setDetalleEdicion(String detalleEdicion) {
		this.detalleEdicion = detalleEdicion;
	}

	public String getRespuestaSuplementoNewUpdate() {
		return respuestaSuplementoNewUpdate;
	}

	public void setRespuestaSuplementoNewUpdate(String respuestaSuplementoNewUpdate) {
		this.respuestaSuplementoNewUpdate = respuestaSuplementoNewUpdate;
	}

	public String getNombreSuplementoNewUpdate() {
		return nombreSuplementoNewUpdate;
	}

	public void setNombreSuplementoNewUpdate(String nombreSuplementoNewUpdate) {
		this.nombreSuplementoNewUpdate = nombreSuplementoNewUpdate;
	}

	public String getNombrePosicionNewUpdate() {
		return nombrePosicionNewUpdate;
	}

	public void setNombrePosicionNewUpdate(String nombrePosicionNewUpdate) {
		this.nombrePosicionNewUpdate = nombrePosicionNewUpdate;
	}

	public String getRespuestaPosicionNewUpdate() {
		return respuestaPosicionNewUpdate;
	}

	public void setRespuestaPosicionNewUpdate(String respuestaPosicionNewUpdate) {
		this.respuestaPosicionNewUpdate = respuestaPosicionNewUpdate;
	}

	public String getNombreSeccionNewUpdate() {
		return nombreSeccionNewUpdate;
	}

	public void setNombreSeccionNewUpdate(String nombreSeccionNewUpdate) {
		this.nombreSeccionNewUpdate = nombreSeccionNewUpdate;
	}

	public String getRespuestaSeccionNewUpdate() {
		return respuestaSeccionNewUpdate;
	}

	public void setRespuestaSeccionNewUpdate(String respuestaSeccionNewUpdate) {
		this.respuestaSeccionNewUpdate = respuestaSeccionNewUpdate;
	}

	public String getNombrePatrocinioNewUpdate() {
		return nombrePatrocinioNewUpdate;
	}

	public void setNombrePatrocinioNewUpdate(String nombrePatrocinioNewUpdate) {
		this.nombrePatrocinioNewUpdate = nombrePatrocinioNewUpdate;
	}

	public String getRespuestaPatrocinioNewUpdate() {
		return respuestaPatrocinioNewUpdate;
	}

	public void setRespuestaPatrocinioNewUpdate(String respuestaPatrocinioNewUpdate) {
		this.respuestaPatrocinioNewUpdate = respuestaPatrocinioNewUpdate;
	}

	public Date getFechaFormatoInicioDate() {
		return fechaFormatoInicioDate;
	}

	public void setFechaFormatoInicioDate(Date fechaFormatoInicioDate) {
		this.fechaFormatoInicioDate = fechaFormatoInicioDate;
	}

	public Date getFechaFormatoFinDate() {
		return fechaFormatoFinDate;
	}

	public void setFechaFormatoFinDate(Date fechaFormatoFinDate) {
		this.fechaFormatoFinDate = fechaFormatoFinDate;
	}

	public String getFechaFormatoInicioString() {
		return fechaFormatoInicioString;
	}

	public void setFechaFormatoInicioString(String fechaFormatoInicioString) {
		this.fechaFormatoInicioString = fechaFormatoInicioString;
	}

	public String getFechaFormatoFinString() {
		return fechaFormatoFinString;
	}

	public void setFechaFormatoFinString(String fechaFormatoFinString) {
		this.fechaFormatoFinString = fechaFormatoFinString;
	}

	public String getRespuestaFormatoNewUpdate() {
		return respuestaFormatoNewUpdate;
	}

	public void setRespuestaFormatoNewUpdate(String respuestaFormatoNewUpdate) {
		this.respuestaFormatoNewUpdate = respuestaFormatoNewUpdate;
	}

	public String getNombreFormatoNewUpdate() {
		return nombreFormatoNewUpdate;
	}

	public void setNombreFormatoNewUpdate(String nombreFormatoNewUpdate) {
		this.nombreFormatoNewUpdate = nombreFormatoNewUpdate;
	}

	public String getMaxAlto() {
		return maxAlto;
	}

	public void setMaxAlto(String maxAlto) {
		this.maxAlto = maxAlto;
	}

	public String getMaxAncho() {
		return maxAncho;
	}

	public void setMaxAncho(String maxAncho) {
		this.maxAncho = maxAncho;
	}

	public String getIdsPublicacionesHidden() {
		return idsPublicacionesHidden;
	}

	public void setIdsPublicacionesHidden(String idsPublicacionesHidden) {
		this.idsPublicacionesHidden = idsPublicacionesHidden;
	}

	public String getSelectedItemsSufijo() {
		return selectedItemsSufijo;
	}

	public void setSelectedItemsSufijo(String selectedItemsSufijo) {
		this.selectedItemsSufijo = selectedItemsSufijo;
	}

	public List<SelectItem> getSelectItemsSufijo() {
		return selectItemsSufijo;
	}

	public void setSelectItemsSufijo(List<SelectItem> selectItemsSufijo) {
		this.selectItemsSufijo = selectItemsSufijo;
	}

	public int getEstatus() {
		return estatus;
	}

	public void setEstatus(int estatus) {
		this.estatus = estatus;
	}

	public int getIdSufijo() {
		return idSufijo;
	}

	public void setIdSufijo(int idSufijo) {
		this.idSufijo = idSufijo;
	}

	public String getNombreSufijo() {
		return nombreSufijo;
	}

	public void setNombreSufijo(String nombreSufijo) {
		this.nombreSufijo = nombreSufijo;
	}

	public int getNumeroPaginas() {
		return numeroPaginas;
	}

	public void setNumeroPaginas(int numeroPaginas) {
		this.numeroPaginas = numeroPaginas;
	}

	public String getPublicacionPatrocinio() {
		return publicacionPatrocinio;
	}

	public void setPublicacionPatrocinio(String publicacionPatrocinio) {
		this.publicacionPatrocinio = publicacionPatrocinio;
	}

	public String[] getPublicacionesPosicion() {
		return publicacionesPosicion;
	}

	public void setPublicacionesPosicion(String[] publicacionesPosicion) {
		this.publicacionesPosicion = publicacionesPosicion;
	}

	public String getIdMultiPublicacionModal() {
		return idMultiPublicacionModal;
	}

	public void setIdMultiPublicacionModal(String idMultiPublicacionModal) {
		this.idMultiPublicacionModal = idMultiPublicacionModal;
	}

	public String getSelectedItemsDivisa() {
		return selectedItemsDivisa;
	}

	public void setSelectedItemsDivisa(String selectedItemsDivisa) {
		this.selectedItemsDivisa = selectedItemsDivisa;
	}

	public List<SelectItem> getSelectItemsDivisa() {
		return selectItemsDivisa;
	}

	public void setSelectItemsDivisa(List<SelectItem> selectItemsDivisa) {
		this.selectItemsDivisa = selectItemsDivisa;
	}

	public Date getFechaTarifaInicioDate() {
		return fechaTarifaInicioDate;
	}

	public void setFechaTarifaInicioDate(Date fechaTarifaInicioDate) {
		this.fechaTarifaInicioDate = fechaTarifaInicioDate;
	}

	public Date getFechaTarifaFinDate() {
		return fechaTarifaFinDate;
	}

	public void setFechaTarifaFinDate(Date fechaTarifaFinDate) {
		this.fechaTarifaFinDate = fechaTarifaFinDate;
	}

	public String getPublicacionTarifa() {
		return publicacionTarifa;
	}

	public void setPublicacionTarifa(String publicacionTarifa) {
		this.publicacionTarifa = publicacionTarifa;
	}

	public int getIdDivisa() {
		return idDivisa;
	}

	public void setIdDivisa(int idDivisa) {
		this.idDivisa = idDivisa;
	}

	public String getRespuestaTarifaNewUpdate() {
		return respuestaTarifaNewUpdate;
	}

	public void setRespuestaTarifaNewUpdate(String respuestaTarifaNewUpdate) {
		this.respuestaTarifaNewUpdate = respuestaTarifaNewUpdate;
	}

	public String getNombreDivisa() {
		return nombreDivisa;
	}

	public void setNombreDivisa(String nombreDivisa) {
		this.nombreDivisa = nombreDivisa;
	}

	public String getNombreTarifaNewUpdate() {
		return nombreTarifaNewUpdate;
	}

	public void setNombreTarifaNewUpdate(String nombreTarifaNewUpdate) {
		this.nombreTarifaNewUpdate = nombreTarifaNewUpdate;
	}

	public String getCostoTotalDivisa() {
		return costoTotalDivisa;
	}

	public void setCostoTotalDivisa(String costoTotalDivisa) {
		this.costoTotalDivisa = costoTotalDivisa;
	}

	public String getFechaTarifaInicioString() {
		return fechaTarifaInicioString;
	}

	public void setFechaTarifaInicioString(String fechaTarifaInicioString) {
		this.fechaTarifaInicioString = fechaTarifaInicioString;
	}

	public String getFechaTarifaFinString() {
		return fechaTarifaFinString;
	}

	public void setFechaTarifaFinString(String fechaTarifaFinString) {
		this.fechaTarifaFinString = fechaTarifaFinString;
	}

	public String getSelectedItemsCopiarTarifa() {
		return selectedItemsCopiarTarifa;
	}

	public void setSelectedItemsCopiarTarifa(String selectedItemsCopiarTarifa) {
		this.selectedItemsCopiarTarifa = selectedItemsCopiarTarifa;
	}

	public List<SelectItem> getSelectItemsCopiarTarifa() {
		return selectItemsCopiarTarifa;
	}

	public void setSelectItemsCopiarTarifa(List<SelectItem> selectItemsCopiarTarifa) {
		this.selectItemsCopiarTarifa = selectItemsCopiarTarifa;
	}

	public int getIdTarifaCopiar() {
		return idTarifaCopiar;
	}

	public void setIdTarifaCopiar(int idTarifaCopiar) {
		this.idTarifaCopiar = idTarifaCopiar;
	}

	public org.richfaces.component.html.HtmlInputNumberSpinner getAlto() {
		return alto;
	}

	public void setAlto(org.richfaces.component.html.HtmlInputNumberSpinner alto) {
		this.alto = alto;
	}

	public org.richfaces.component.html.HtmlInputNumberSpinner getAncho() {
		return ancho;
	}

	public void setAncho(org.richfaces.component.html.HtmlInputNumberSpinner ancho) {
		this.ancho = ancho;
	}

	public boolean isValorEspecialDisabled() {
		return valorEspecialDisabled;
	}

	public void setValorEspecialDisabled(boolean valorEspecialDisabled) {
		this.valorEspecialDisabled = valorEspecialDisabled;
	}

	public String getValorEspecialStyle() {
		return valorEspecialStyle;
	}

	public void setValorEspecialStyle(String valorEspecialStyle) {
		this.valorEspecialStyle = valorEspecialStyle;
	}

	public String getPeriodicoRevistaStyle() {
		return periodicoRevistaStyle;
	}

	public void setPeriodicoRevistaStyle(String periodicoRevistaStyle) {
		this.periodicoRevistaStyle = periodicoRevistaStyle;
	}

	public HtmlInputTextarea getHtmlObservaciones() {
		return htmlObservaciones;
	}

	public void setHtmlObservaciones(HtmlInputTextarea htmlObservaciones) {
		this.htmlObservaciones = htmlObservaciones;
	}

	public String getErrorPedidoSeccion1() {
		return errorPedidoSeccion1;
	}

	public void setErrorPedidoSeccion1(String errorPedidoSeccion1) {
		this.errorPedidoSeccion1 = errorPedidoSeccion1;
	}

	public String getErrorPedidoSeccion2() {
		return errorPedidoSeccion2;
	}

	public void setErrorPedidoSeccion2(String errorPedidoSeccion2) {
		this.errorPedidoSeccion2 = errorPedidoSeccion2;
	}

	public String getErrorPedidoTabPanel() {
		return errorPedidoTabPanel;
	}

	public void setErrorPedidoTabPanel(String errorPedidoTabPanel) {
		this.errorPedidoTabPanel = errorPedidoTabPanel;
	}

	public String getMontoRestante() {
		return montoRestante;
	}

	public void setMontoRestante(String montoRestante) {
		this.montoRestante = montoRestante;
	}

}
